       PROGRAM BEPS1K
       use hpf_library
   
!         parameter( indx =  14, npx =   4096000, npxb = 409600)
!         parameter( indx =   14, npx =    5120, npxb = 512)
         parameter( indx =   7, npx =    5120, npxb = 512)
!        parameter( indx =   7, npx =    10240, npxb = 1024)
!         parameter( indx =  18, npx =   409600, npxb = 40960)
!        parameter( indx =  12, npx =  1000000, npxb =   200000)
!        parameter( indx =  12, npx =  4096000, npxb =   409600)
!        parameter( indx =  13, npx =  6096000, npxb =   409600)
!        parameter( indx =  18, npx = 40960000, npxb =  4096000)

!          parameter (indx=25, npx=40960000 ,npxb=4096000)

! parameter( indx =  18, npx =   409600, npxb = 40960) case i 28.00 sec for 
! parallel ,433.47899 for serial version

! Time
      parameter( tend =  5.000, dt = 0.2000000e+00)
! Velocity
      parameter( vtx =   1.000,  vdx= 5.000, vtdx =   0.500)
      parameter( avdx=   5.000)
! Arch , vprocs, boundaries
      parameter( indnvp= 2, idps =    2, idimp =   2)
! Electrons
      parameter(np=npx+npxb)
      parameter(nx=2**indx,nxh=nx/2)
! Time steps
      parameter(nloop=tend/dt+.0001)
! Vprocs, partitions, particle/partition,
      parameter(nvp=2**indnvp,nblok=1+1*(nvp-1))
      parameter(npmax=(np/nvp)*1.01+250,nxpmx=(nx-1)/nvp+4)
! Grids/dim
      parameter(kxp=(nxh-1)/nvp+1,kblok=1+1*(nxh/kxp-1))
      parameter(nbmax=1+(2*(npx*vtx+npxb*vtdx)+1.4*npxb*avdx)*dt/nx)
      parameter(ntmax=2*nbmax)
      parameter(indx1=indx-indnvp-1)

      parameter(npd=128)
      complex ffc, fc, qc, sct,scc,f,shifted,tsct
      common /large/ part
      integer tar
      dimension part(idimp,npmax,nblok) 

      dimension maskp(npmax,nblok)
      dimension q(nxpmx,nblok), fx(nxpmx,nblok)
      dimension qc(kxp,kblok), fc(kxp,nblok)
      dimension ffc(kxp,kblok)
      dimension mixup(kxp,kblok), sct(indx1,kxp,kblok)
      dimension edges(idps,nblok)
      dimension nxp(nblok), noff(nblok)
      dimension npp(nblok), nps(nblok)

      dimension sbufl(idimp,nbmax,nblok), sbufr(idimp,nbmax,nblok)
      dimension rbufl(idimp,nbmax,nblok), rbufr(idimp,nbmax,nblok)

      dimension ihole(ntmax,nblok)
      dimension jsl(idps,nblok), jsr(idps,nblok)
      dimension jss(idps,nblok), scr(idps,nblok),scc(idps,nblok)


      REAL  , DIMENSION(NBLOK)   :: SUM_0
      INTEGER  , DIMENSION(NBLOK)   :: ISUM_0
      DOUBLE PRECISION   START_TIME,FINISH_TIME
      dimension shifted(kblok),tsct(kxp,kblok),tar(kxp,kblok)
      
      integer npr,ibflg,npss,ierr
      real awe(nloop), awke(nloop), awt(nloop)


!HPF$ PROCESSORS                          PROC(NUMBER_OF_PROCESSORS())
!HPF$ DISTRIBUTE (*,BLOCK) ONTO PROC   :: EDGES,MASKP,Q,FX,IHOLE,JSL,JSR,JSS
!HPF$ DISTRIBUTE (*,BLOCK) ONTO PROC   :: SCR,tsct,tar
!HPF$ DISTRIBUTE (*,BLOCK) ONTO PROC   :: QC,FC,FFC,MIXUP,SCC
!HPF$ DISTRIBUTE (*,*,BLOCK) ONTO PROC :: PART,SBUFL,SBUFR,RBUFL,RBUFR,sct
!HPF$ DISTRIBUTE (BLOCK) ONTO PROC     :: NOFF,NXP,NPP,NPS,SUM_0,ISUM_0
!HPF$ DISTRIBUTE (BLOCK) ONTO PROC     :: shifted
   
 INTERFACE
   EXTRINSIC (F77_LOCAL) SUBROUTINE INDEP_LOOP_PDOST1(PART,Q,NOFF,NPP,QME,&
    idimp, npmax,kblok,nblok,nxpmx)  
 
   REAL ,DIMENSION(:,:,:),INTENT(IN)     :: PART
    INTEGER,DIMENSION(:),INTENT(IN)       :: NOFF,NPP
    REAL ,DIMENSION(:,:),INTENT(INOUT)    :: Q
    REAL,INTENT(IN)                       :: QME


    
    !HPF$ DISTRIBUTE   *(*,*,BLOCK)        :: PART
    !HPF$ DISTRIBUTE   *(BLOCK)            :: NOFF,NPP
    !HPF$ DISTRIBUTE   *(*,BLOCK)          :: Q

   END SUBROUTINE


 extrinsic (f77_local) subroutine bitrv1(mixup,isign,indx,indx1,kxp, &
      kblok,sct,tsct)

       complex ,dimension(:,:,:),intent(out) :: sct
       complex ,dimension(:,:),intent(out)   :: tsct
       integer ,dimension(:,:),intent(out)    :: mixup
       integer,intent(in)            :: isign,indx,kxp,kblok

     
       !HPF$ distribute *(*,block)   :: mixup,tsct
       !HPF$ distribute *(*,*,block)   :: sct
 end subroutine

  extrinsic (f77_local)subroutine dist_particle (part,edges,npp,npx,vtx,&
   nblok,idimp,npmax,nx)

     integer ,intent(in)                  :: npx,nx,nblok,idimp,npmax
     real  ,intent(in)                    :: vtx
     real ,dimension(:,:,:),intent(inout)   :: part
     real, dimension(:,:),intent(in)      :: edges
     integer,dimension(:),intent(inout)     :: npp

     !hpf$ distribute *(*,*,block)         :: part
     !hpf$ inherit             edges
     !hpf$ distribute *(block)             :: npp
 end subroutine

  subroutine dcomp1(edges,nxp,noff,nx,nvp,idps,nblok)
      real,intent(inout) ::  edges(:,:)
      integer,intent(inout) :: nxp(:), noff(:)

      !hpf$ distribute *(*,block) :: edges
      !hpf$ distribute *(block)   :: nxp,noff
  end subroutine     

  subroutine ppois1 (q,fx,isign,ffc,ax,affp,wp,nx,kxp,kblok,nblok,sum_0)
     
      complex,intent(inout) ::  q(kxp,kblok), fx(kxp,kblok)
      complex,intent(inout) :: ffc(kxp,kblok)
      real,intent(inout) :: sum_0(nblok)

      !hpf$ distribute *(*,block) :: q,fx
      !hpf$ distribute *(*,block) :: ffc
  end subroutine 

   subroutine pistr1 (part,edges,npp,nps,vtx,vdx,npx,nx,idimp,npmax,&
     nblok,idps,sum_0)

      real,intent(inout)  :: part(:,:,:)
      real ,intent(inout) :: edges(:,:),sum_0(:)
      integer,intent(inout) :: npp(:), nps(:)

      !hpf$ distribute *(*,*,block ) :: part
      !hpf$ distribute *(*,block)    :: edges
      !hpf$ distribute *(block)      :: npp,nps
   end subroutine
  
     subroutine cppfp1 (f,fc,isign,scr,scc,nvp,nxpmx,nblok,kxp,kblok,idps)
        
      real,intent(inout) :: f(:,:)
      complex,intent(inout)  :: fc(:,:),scc(:,:)
      real,intent(inout) ::scr(:,:)

      !hpf$ distribute *(*,block) :: f,fc,scr,scc
     end subroutine

     subroutine ifft(f,g,isign,mixup,sct,indx,kxp,kblok,tsct,tar)
     
      complex,intent(inout) :: f(:,:), g(:,:),sct(:,:,:),tsct(:,:)
      integer,intent(inout) :: mixup(:,:),tar(:,:)
     
      !hpf$ distribute *(*,block) :: f,g,mixup,tsct,tar
      !hpf$ distribute *(*,*,block)   :: sct 
     end subroutine

     subroutine dfft(f,g,isign,mixup,sct,indx,kxp,kblok,tsct,tar)

      complex,intent(inout) :: f(:,:), g(:,:),sct(:,:,:),tsct(:,:)
      integer,intent(inout) :: mixup(:,:),tar(:,:)

      !hpf$ distribute *(*,block) :: f,g,mixup,tsct,tar
      !hpf$ distribute *(*,*,block)   :: sct
     end subroutine

      subroutine ppush1(part,fx,npp,noff,qtm,dt,ek,idimp,npmax,nblok,&
     nxpmx,sum_0)
       real,intent(inout) :: part(:,:,:), fx(:,:),sum_0(:)
       integer,intent(inout) :: npp(:), noff(:)

       !hpf$ distribute *(*,*,block) :: part
       !hpf$ distribute *(*,block)   :: fx
       !hpf$ distribute *(block)     :: npp,noff,sum_0
     end subroutine

     subroutine pmove1 (part,edges,npp,sbufr,sbufl,rbufr,rbufl,ihole,jsr &
     ,jsl,jss,nx,nvp,idimp,npmax,nblok,idps,nbmax,ntmax,ierr,isum_0)

      real,intent(inout) :: part(:,:,:)
      real,intent(inout) :: edges(:,:)
      real,intent(inout) :: sbufl(:,:,:),sbufr(:,:,:)
      real,intent(inout) :: rbufl(:,:,:), rbufr(:,:,:)
      integer,intent(inout)  :: npp(:),jsl(:,:), jsr(:,:), jss(:,:)
      integer,intent(inout)  :: ihole(:,:),isum_0(:)

      !hpf$ distribute *(*,*,block) :: part,sbufr,sbufl,rbufr,rbufl
      !hpf$ distribute *(*,block)   :: edges,jsl,jsr,jss,ihole
      !hpf$ distribute *(block)     :: npp,isum_0
     end subroutine

END INTERFACE

      double precision tbegin,timeend
  991 format (5h t = ,i7)
  992 format (19h * * * q.e.d. * * *)
  993 format (34h field, kinetic, total energies = ,3e14.7)

      data qme,ax /-1.,.8666667/
! ------------------------------------
! initialize
! ------------------------------------
      kstrt = 1
!     open(unit=6,file='output1',form='formatted',status='unknown')

      itime = 0
      anx = float(nx)
      qtme = qme*dt
      affp = anx/float(np)
      zero = 0.

! ------------------------------
! calculate partition variables
! ------------------------------
    
      print *,'beg',elapsed_time()
      call dcomp1(edges,nxp,noff,nx,nvp,idps,nblok)
      print *,'after decomp',elapsed_time()    
      npp = 0
      nps = 1
      q = 0

! prepare fft tables
     isign = 0
     call bitrv1(mixup,isign,indx-1,indx1,kxp,kblok,sct,tsct)

     print *,'after bitrv',elapsed_time()


! calculate form factors
     call  ppois1 (qc,fc,isign,ffc,ax,affp,we,nx,kxp,kblok,nblok,sum_0)
     
     print *,'after ppois',elapsed_time()

! -------------------------------------------------------------
! initial density profile and maxwellian velocity distribution
! background electrons
! -------------------------------------------------------------

      if (npx.gt.0)  call pistr1 (part,edges,npp,nps,vtx,zero, &
        npx,nx,idimp,npmax,nblok,idps,sum_0)

      print *,'after pistr1',elapsed_time()

     
! -----------------
! beam electrons
! -----------------

      nps = npp +1
      if (npxb.gt.0) call pistr1 (part,edges,npp,nps,vtdx,vdx, &
        npxb,nx,idimp,npmax,nblok,idps,sum_0) 
      print *,'after pistr1',elapsed_time()
!upto here ,it is okey
   
      call  INDEP_LOOP_PDOST1(PART,Q,NOFF,NPP,QME,idimp, npmax,kblok &
          ,nblok,nxpmx)

      print *,'after pdost',elapsed_time()

! ----------------------------------------
! add background ion density
     
       qi0 = -qme/affp

       q(2:nxp(1)+1,:) = q(2:nxp(1)+1,:) + qi0

! all nxp(k) is equal for  any k. so we take nxp(1) as a representative

! =======================================
!
! * * * start main iteration loop * * *

!
! =======================================

   call timer(tbegin) 
   do while(itime.lt.nloop)

      write (6,991) itime

! ----------------------------------
! transform charge to fourier space
! ----------------------------------
    
      isign = -1
! -------------------------------------------------------------------
! copy data from particle to field partition, and add up guard cells
! -------------------------------------------------------------------
      t1= elapsed_time()
      call cppfp1 (q,qc,isign,scr,scc,nvp,nxpmx,nblok,kxp,kblok,idps)
      
      print *,'after cppfp',elapsed_time()
   
      call ifft(qc,fc,isign,mixup,sct,indx,kxp,kblok,tsct,tar)
   
      print *,'after ifft',elapsed_time()
      
! ----------------------------------------
! calculate force/charge in fourier space
! ----------------------------------------
       call ppois1 (qc,fc,isign,ffc,ax,affp,we,nx,kxp,kblok,nblok,sum_0)  
       print *,'after ppois',elapsed_time()
! -------------------------------------
! transform force/charge to real space
! -------------------------------------
       isign = 1

       call dfft(qc,fc,isign,mixup,sct,indx,kxp,kblok,tsct,tar)
       
      print *,'after dfft',elapsed_time()
 
! --------------------------------------------------------------------
! copy data from field to particle partition, and copy to guard cells
! --------------------------------------------------------------------
      call cppfp1 (fx,fc,isign,scr,scc,nvp,nxpmx,nblok,kxp,kblok,idps)    
  
      print *,'after cppfp',elapsed_time()
     
! ----------------------

! ----------------------------------------
! particle push and charge density update
! ----------------------------------------
! -----------------------------------
! initialize charge density to zero
! -----------------------------------
      q = 0.0
      wke = 0.0
! ---------------
! push particles
! ---------------

     call  ppush1(part,fx,npp,noff,qtme,dt,wke,idimp,npmax,nblok,&
          nxpmx,sum_0)

      print *,'after ppush',elapsed_time()

! ------------------------------------------------
! move particles into appropriate spatial regions
! ------------------------------------------------

      call  pmove1 (part,edges,npp,sbufr,sbufl,rbufr,rbufl,ihole,jsr &
     ,jsl,jss,nx,nvp,idimp,npmax,nblok,idps,nbmax,ntmax,ierr,isum_0)

      print *,'after pmove',elapsed_time()

! ---------------
! deposit charge
! ---------------
     call  INDEP_LOOP_PDOST1(PART,Q,NOFF,NPP,QME,idimp, npmax,kblok &
          ,nblok,nxpmx)
       
     print *,'after pdost',elapsed_time()

! ----------------------
! add background charge
! ----------------------
      q(2:nxp(1)+1,:) = q(2:nxp(1)+1,:) + qi0

! ------------------
! energy diagnostic
! ------------------
      wt = we + wke
      write (6,993) we, wke, wt
      itime = itime + 1


   enddo
! ====================================
!
! * * * end main iteration loop * * *
!
! ====================================

       call timer(timeend) 
       print *,'total elapsed time',timeend-tbegin

  end 

 real function elapsed_time()
      integer :: clock_count, clock_rate, clock_max
      integer, save :: last_count
      logical, save :: system_clock_not_yet_called = .true.

      call system_clock(count=clock_count,&                              
                       count_rate=clock_rate, &
                       count_max=clock_max)
      if (system_clock_not_yet_called) then
         system_clock_not_yet_called = .false.
         elapsed_time = 0.0
      else if (clock_count > last_count) then
         elapsed_time = real(clock_count-last_count)/real(clock_rate)
      else
         elapsed_time = real(clock_max-last_count+clock_count)&          
                  /real(clock_rate)
      end if
      last_count = clock_count
      return
 end function elapsed_time

 subroutine timer(t)

    integer val(8)
    double precision t

    call date_and_time(values=val)
    t = dble(val(8))*1d-3 + dble(val(7)) +          &
        dble(val(6))*60d0 + dble(val(5))*3600d0

 end subroutine timer




 
! =========================================================================
!
! This subroutine moves particles into appropriate spatial regions
!
! =========================================================================

subroutine pmove1 (part,edges,npp,sbufr,sbufl,rbufr,rbufl,ihole,jsr &
     ,jsl,jss,nx,nvp,idimp,npmax,nblok,idps,nbmax,ntmax,ierr,isum_0)

      real,intent(inout) :: part(:,:,:)
      real,intent(inout) :: edges(:,:)
      real,intent(inout) :: sbufl(:,:,:),sbufr(:,:,:)
      real,intent(inout) :: rbufl(:,:,:), rbufr(:,:,:)
      integer,intent(inout)  :: npp(:),jsl(:,:), jsr(:,:), jss(:,:)
      integer,intent(inout)  :: ihole(:,:),isum_0(:)

      !hpf$ distribute *(*,*,block) :: part,sbufr,sbufl,rbufr,rbufl
      !hpf$ distribute *(*,block)   :: edges,jsl,jsr,jss,ihole
      !hpf$ distribute *(block)     :: npp,isum_0
    

 INTERFACE
   EXTRINSIC (F77_LOCAL) SUBROUTINE INDEP_LOOP_PMOVE1_1(PART,EDGES,NPP, &
            SBUFR,SBUFL,IHOLE,JSR,JSL,JSS,NX,NVP,NBMAX,idimp,npmax, &
        nblok,ntmax)

      REAL,intent(in) ::  PART(idimp,npmax,nblok)
      REAL,intent(out) :: SBUFR(idimp,nbmax,nblok),SBUFL(idimp,nbmax,nblok)
      REAL ,intent(in) :: EDGES(idimp,nblok)
    INTEGER,intent(inout) :: JSR(idimp,nblok),JSL(idimp,nblok),JSS(idimp,nblok)
      INTEGER,intent(out) :: IHOLE(ntmax,nblok)
      INTEGER,intent(in) :: NX,NVP,NBMAX
      INTEGER,intent(in) :: NPP(nblok)


   !HPF$ DISTRIBUTE *(*,*,BLOCK)          :: PART,SBUFR,SBUFL
   !HPF$ DISTRIBUTE *(*,BLOCK)           :: EDGES,IHOLE,JSR,JSL,JSS
   !HPF$ DISTRIBUTE *(BLOCK)             ::  NPP

 END SUBROUTINE


 EXTRINSIC (F77_LOCAL) SUBROUTINE INDEP_LOOP_PMOVE1_2(EDGES,RBUFR,RBUFL, &
     JSR,JSL,ISUM_0,idimp,nbmax,nblok)

       REAL,intent(in) :: RBUFR(idimp,nbmax,nblok),RBUFL(idimp,nbmax,nblok)
       REAL,intent(in) ::  EDGES(idimp,nblok)
       INTEGER,intent(inout) :: JSR(idimp,nblok),JSL(idimp,nblok)
       integer,intent(out) :: isum_0(nblok)

    
      !HPF$ DISTRIBUTE *(*,*,BLOCK)          :: RBUFR,RBUFL
      !HPF$ DISTRIBUTE *(*,BLOCK)            :: EDGES,JSR,JSL
      !HPF$ DISTRIBUTE *(BLOCK)              :: ISUM_0

  END SUBROUTINE

  EXTRINSIC (F77_LOCAL) SUBROUTINE INDEP_LOOP_PMOVE1_3(EDGES,SBUFR,SBUFL,&
            RBUFR,RBUFL,JSR,JSL,JSS,NVP,NX,idimp,nbmax,nblok)
     
      REAL,intent(inout) :: SBUFR(idimp,nbmax,nblok),SBUFL(idimp,nbmax,nblok)
      REAL,intent(inout) :: RBUFR(idimp,nbmax,nblok),RBUFL(idimp,nbmax,nblok)
      REAL ,intent(in) :: EDGES(idimp,nblok)
      INTEGER,intent(inout)::JSR(idimp,nblok),JSL(idimp,nblok),JSS(idimp,nblok)
      integer,intent(in)  :: nvp,nx      
   
    !HPF$ DISTRIBUTE *(*,*,BLOCK)          :: RBUFR,RBUFL,SBUFR,SBUFL
    !HPF$ DISTRIBUTE *(*,BLOCK)            :: EDGES,JSR,JSL,JSS

  END SUBROUTINE

  EXTRINSIC (F77_LOCAL) SUBROUTINE INDEP_LOOP_PMOVE1_4(JSR,JSL,JSS,NPMAX, &
           ISUM_0,NPP,idimp,nblok )

      INTEGER,intent(inout)::JSR(idimp,nblok),JSL(idimp,nblok),JSS(idimp,nblok)
      integer,intent(out) :: isum_0(nblok)
      integer,intent(in) :: npp(nblok)
      INTEGER,intent(in) :: NPMAX

      !HPF$ DISTRIBUTE *(*,BLOCK)            :: JSR,JSL,JSS
      !HPF$ DISTRIBUTE *(BLOCK)              :: ISUM_0,NPP

   END SUBROUTINE


    EXTRINSIC (F77_LOCAL) SUBROUTINE INDEP_LOOP_PMOVE1_5(PART,EDGES,NPP, &
            RBUFR,RBUFL,IHOLE,JSR,JSL,JSS,idimp,npmax,nblok,&
       nbmax,ntmax)
  
      REAL,intent(inout) :: PART(idimp,npmax,nblok)
      REAL,intent(in) :: RBUFR(idimp,nbmax,nblok),RBUFL(idimp,nbmax,nblok)
      REAL ,intent(in) :: EDGES(idimp,nblok)
      INTEGER,intent(inout)::JSR(idimp,nblok),JSL(idimp,nblok),JSS(idimp,nblok)
      integer,intent(in) :: ihole(ntmax,nblok)
      integer,intent(inout) :: npp(nblok)
            
  
        !HPF$ DISTRIBUTE *(*,*,BLOCK)     :: PART,RBUFR,RBUFL
        !HPF$ DISTRIBUTE *(*,BLOCK)      :: EDGES,IHOLE,JSR,JSL,JSS
        !HPF$ DISTRIBUTE *(BLOCK)        ::  NPP

 END SUBROUTINE

 end interface
      
      

      npr = SUM(npp)

11    CALL INDEP_LOOP_PMOVE1_1(PART,EDGES,NPP,SBUFR,SBUFL,IHOLE, &
          JSR,JSL,JSS,NX,NVP,NBMAX,idimp,npmax,nblok,ntmax)

! --------------------------------
! check for full buffer condition
! --------------------------------
     ibflg = SUM(JSS(2,:))


! -------------------------
! copy particle buffers
! -------------------------

!------------------------------------------------------------------------
! Get the number of particles which will come from the left neighbor
! and store it in jsl array.Also Shift send buffers which will go to
! the right
! neighbor ,to to right trough third dimension

!------------------------------------------------------------------------
12   JSL(2,:) = CSHIFT(JSR(1,:),-1)
     RBUFL = CSHIFT(SBUFR,SHIFT=-1,DIM=3)


!------------------------------------------------------------------------
! Get the number of particles which will come from the right neigbor
! and store it in jsr array.Also Shift send buffers which will go to
! the left  neighbor ,to left  trough third dimension
!------------------------------------------------------------------------
     JSR(2,:) = CSHIFT(JSL(1,:),+1)
     RBUFR = CSHIFT(SBUFL,SHIFT=+1,DIM=3)


! -------------------------------------------
! check if particles must be passed further
! -------------------------------------------
    CALL INDEP_LOOP_PMOVE1_2(EDGES,RBUFR,RBUFL,JSR,JSL,ISUM_0,idimp,&
                     nbmax,nblok)
    npss = SUM(ISUM_0)


        if (npss == 0) go to 150
! -------------------------------------------
! remove particles which do not belong here
! -------------------------------------------
  CALL INDEP_LOOP_PMOVE1_3(EDGES,SBUFR,SBUFL, RBUFR,RBUFL,JSR,JSL,JSS, &
     NVP,NX,idimp,nbmax,nblok)

! -------------------------------------------
! check if move would overflow particle array
! -------------------------------------------
     CALL INDEP_LOOP_PMOVE1_4(JSR,JSL,JSS,NPMAX, &
         ISUM_0,NPP,idimp,nblok)

 150      ierr = SUM(ISUM_0)


       if (ierr.gt.0) then
          write (6,*) 'particle overflow error, ierr =', ierr
          return
       endif

! ------------------------------------------------------
! distribute incoming particles from buffers
! ------------------------------------------------------
       CALL INDEP_LOOP_PMOVE1_5(PART,EDGES,NPP, &
              RBUFR,RBUFL,IHOLE,JSR,JSL,JSS,idimp,npmax,nblok,&
       nbmax,ntmax)

! ------------------------------------------------------
! check if any particles have to be passed further
! ------------------------------------------------------
      if (npss.gt.0) go to 12
! check if buffer overflowed and more particles remain to be checked
      if (ibflg.gt.0) go to 11
! debugging section: count total number of particles after move
      npss = SUM(NPP)
      if (npr.ne.npss) write (6,*) 'number error,np-old,np-new=',npr,npss
end subroutine pmove1


!==========================================================================

        subroutine permute(f,g,mixup,indx,kxp,kblok,tar)

	complex,intent(inout) :: f(:,:),g(:,:)
        integer,intent(inout)    :: mixup(:,:),tar(:,:)  

        !hpf$ distribute *(*,block) :: g,mixup,tar
        !hpf$ align f(*,*) with g(i,j)
    
         forall(k=1:kblok,j=1:kxp)
            tar(j,k) = (mixup(j,k) - 1)/kxp + 1
            g(j,k)   = f(mixup(j,k)-kxp*(tar(j,k)-1), tar(j,k))
         endforall

         return
         end


       SUBROUTINE FFT(F,g,isign,sct,indx,kxp,kblok,tsct)

        complex f,g,sct,tsct
	complex,intent(inout) :: f(:,:),g(:,:),sct(:,:,:),tsct(:,:)

        !hpf$ distribute *(*,block) :: f,g,tsct     
        !hpf$ distribute *(*,*,block) :: sct


	integer lind
	Real m1,m2 

	nx = 2**indx
	nxh = nx/2
	indx1 = indx-1
	kbs = nxh/kxp
	dnx = 6.28318530717959/float(nx)
	temp= log10(float(kxp))/log10(2.0)
        lind = temp

!C important note: log10(2048.0)/log10(2.0) is not equal to 11
!C with this xlf compiler if target variable is integer
!C Therefore we assign the result to real var.    

!C ---------------------------
!C inverse fourier transform
!C bit-reverse array elements to temporary
!C ---------------------------
           
         do  l = 1, indx1
            nxs = 2**(l - 1)
            kxs = nxs/kxp
!C ---------------------------
!C local calculation
!C ---------------------------

            if (kxs.eq.0) then
               forall(k=1:kblok,j=1:kxp,(btest(j-1,l-1) .eqv. .false.) )
                   f(j,k) = g(j+nxs,k)
               endforall
               forall(k=1:kblok,j=1:kxp,(btest(j-1,l-1) .eqv. .true.) )    
                   f(j,k) = g(j-nxs,k)
               endforall
!C ---------------------------
!C perform reduction
!C ---------------------------
               km = kxp/nxs
               if (isign .eq. -1) then
                  forall(k=1:kblok,j=1:kxp,(btest(j-1,l-1) .eqv. .false.) )
                    g(j,k) = g(j,k) + sct(l,j,k)*f(j,k)
                  endforall

                  forall(k=1:kblok,j=1:kxp,(btest(j-1,l-1) .eqv. .true.) )
                    g(j,k) = f(j,k) - sct(l,j,k)*g(j,k)
                  endforall
                else if (isign .eq. 1) then
                  forall(k=1:kblok,j=1:kxp,(btest(j-1,l-1) .eqv. .false.) )
                    tsct(j,k) =  conjg(sct(l,j,k))
                    g(j,k) = g(j,k) + tsct(j,k)*f(j,k)
                  endforall

                  forall(k=1:kblok,j=1:kxp,(btest(j-1,l-1) .eqv. .true.) )
                    tsct(j,k) =  conjg(sct(l,j,k))
                    g(j,k) = f(j,k) - tsct(j,k)*g(j,k)
                  endforall
                endif

             else
!C ---------------------------
!C copy data
!C ---------------------------

               tsct = cshift(g,shift=2**(l-lind-1),dim=2)
               forall(k=1:kblok,j=1:kxp,(btest(k-1,l-lind-1) .eqv. .false.))
                 f(j,k) = tsct(j,k)
               endforall

               tsct = cshift(g,shift=-(2**(l-lind-1)),dim=2)
               forall(k=1:kblok,j=1:kxp,(btest(k-1,l-lind-1) .eqv. .true.))
                 f(j,k) = tsct(j,k)
               endforall

!C ------------------
!C perform reduction
!C ------------------
               km = nxh/nxs
               dns = dnx*float(km)
               forall(k=1:kblok,j=1:kxp,(btest(k-1,l-lind-1) .eqv. .false.)) 
                 tsct(j,k) = kxp*(k-1-kxs*int((k-1)/kxs))-1
                 tsct(j,k) = dns*(j+real(tsct(j,k)))
                 tsct(j,k) = cmplx(cos(real(tsct(j,k))), &
                              isign*sin(real(tsct(j,k))))
                 g(j,k) = g(j,k) + tsct(j,k)*f(j,k)
               endforall

               forall(k=1:kblok,j=1:kxp,(btest(k-1,l-lind-1) .eqv. .true.)) 
                 tsct(j,k) = kxp*(k-1-kxs*int((k-1)/kxs))-1
                 tsct(j,k) = dns*(j+real(tsct(j,k)))      
                 tsct(j,k) = cmplx(cos(real(tsct(j,k))), &
                                isign*sin(real(tsct(j,k))))
                 g(j,k) = f(j,k) - tsct(j,k)*g(j,k)           
               endforall
            endif
                 
        enddo
!  do l=1,indx1
  
        return
        end 

        SUBROUTINE SCRAMBLE(F,G,isign,indx,kxp,kblok,tsct)

        COMPLEX ,intent(inout) :: F(:,:),G(:,:),tsct(:,:)

        !hpf$ distribute (*,block) :: f,g,tsct

        Real m1,m2

        nx = 2**indx
        nxh = nx/2
        kbs = nxh/kxp
        dnx = 6.28318530717959/float(nx)
        kxp2 = kxp +2
        
        f(2:kxp,1:(kblok/2))         = g(2:kxp,kblok:((kblok/2)+1):-1)
        f(2:kxp,((kblok/2)+1):kblok) = g(2:kxp,(kblok/2):1:-1) 
        
        f(1,2:(kblok/2))  = g(1,kblok:(kblok/2)+2:-1)
        f(1,(kblok/2)+1:kblok)  = g(1,(kblok/2)+1:2:-1) 

!C calculate multipliers used in scrambling
        if (isign .eq. -1) then
           m1 = 0.5/float(nx)
           m2 = 2.0*m1
        else if (isign .eq. 1) then
           m1 = 1.0
           m2 = 1.0
        endif
        is = -isign
!C ------------------
!C perform reduction
!C ------------------

        forall(k=1:kblok,j=2:kxp)
             tsct(j,k) = dnx*float(j + kxp*(k-1)-1)
             g(j,k) = m1*((g(j,k) + conjg(f(kxp2-j,k))) &
                   - (g(j,k)  &
                   - conjg(f(kxp2-j,k)))*cmplx(sin(real(tsct(j,k))), &
                      is*cos(real(tsct(j,k))))) 
        endforall

        forall(k=2:kblok) 
             tsct(1,k) = dnx*float(1 + kxp*(k-1)-1)
             g(1,k) = m1*((g(1,k) + conjg(f(1,k))) - &
                          (g(1,k) - conjg(f(1,k)))* &
                          cmplx(sin(real(tsct(1,k))),&
                          is*cos(real(tsct(1,k)))))
        endforall

        g(1,1) = m2*cmplx(real(g(1,1)) + &
                          aimag(g(1,1)),real(g(1,1)) &
                          - aimag(g(1,1)))
!C copy result to destination
 
        f = g
     
        return
        end  




!========================================================================
!========================================================================
!========================================================================
 
subroutine ifft(f,g,isign,mixup,sct,indx,kxp,kblok,tsct,tar)

      complex,intent(inout) :: f(:,:), g(:,:),sct(:,:,:),tsct(:,:)
      integer,intent(inout) :: mixup(:,:),tar(:,:)

      !hpf$ distribute *(*,block) :: f,g,mixup,tsct,tar
      !hpf$ distribute *(*,*,block)   :: sct

      interface

         SUBROUTINE FFT(F,g,isign,sct,indx,kxp,kblok,tsct)
	    complex,intent(inout) :: f(:,:),g(:,:),sct(:,:,:),tsct(:,:)

            !hpf$ distribute *(*,block) :: f,g,tsct 
            !hpf$ distribute *(*,*,block)   :: sct
         end subroutine    


         
          SUBROUTINE SCRAMBLE(F,G,isign,indx,kxp,kblok,tsct)

            COMPLEX,INTENT(INOUT)   :: F(kxp,kblok),G(kxp,kblok)
            COMPLEX,INTENT(INOUT)   :: tsct(kxp,kblok)
            INTEGER,INTENT(IN)                     :: INDX,ISIGN,KXP,KBLOK

            !HPF$ distribute *(*,block)     :: f,g,tsct
         end subroutine


         SUBROUTINE permute(F,g,mixup,indx,kxp,kblok,tar)

   	    complex,intent(inout) :: F(kxp,kblok),G(kxp,kblok)
            integer,intent(inout) :: mixup(kxp,kblok),tar(kxp,kblok)  

            !HPF$ distribute *(*,block)     :: g,mixup,tar
            !hpf$ align f(*,*) with g(i,j)
    
         end subroutine

     END INTERFACE
         
   
         call permute(F,g,mixup,indx,kxp,kblok,tar)
         call fft(f,g,isign,sct,indx,kxp,kblok,tsct)

         call SCRAMBLE(f,g,isign,indx,kxp,kblok,tsct)
         
         return
  end subroutine

!========================================================================
!========================================================================
!========================================================================
subroutine dfft(f,g,isign,mixup,sct,indx,kxp,kblok,tsct,tar)

      complex,intent(inout) :: f(:,:), g(:,:),sct(:,:,:),tsct(:,:)
      integer,intent(inout) :: mixup(:,:),tar(:,:)

      !hpf$ distribute *(*,block) :: f,g,mixup,tsct,tar
      !hpf$ distribute *(*,*,block)   :: sct


      interface

         SUBROUTINE FFT(F,g,isign,sct,indx,kxp,kblok,tsct)
	    complex,intent(inout) :: f(:,:),g(:,:),sct(:,:,:),tsct(:,:)

            !hpf$ distribute *(*,block) :: f,g,tsct 
            !hpf$ distribute *(*,*,block)   :: sct 
         end subroutine    
 
         SUBROUTINE SCRAMBLE(F,G,isign,indx,kxp,kblok,tsct)

            COMPLEX,DIMENSION(:,:),INTENT(INOUT)   :: F,G,tsct
            INTEGER,INTENT(IN)                     :: INDX,ISIGN,KXP,KBLOK

            !HPF$ distribute *(*,block)     :: f,g,tsct
         end subroutine

         SUBROUTINE permute(F,g,mixup,indx,kxp,kblok,tar)

   	    complex,intent(inout) :: F(kxp,kblok),G(kxp,kblok)
            integer,intent(inout) :: mixup(kxp,kblok) ,tar(kxp,kblok) 

            !HPF$ distribute *(*,block)     :: g,mixup,tar
            !hpf$ align f(*,*) with g(i,j)      
    
         end subroutine

       END INTERFACE

       call SCRAMBLE(f,g,isign,indx,kxp,kblok,tsct)

       call permute(F,g,mixup,indx,kxp,kblok,tar)
      
       call fft(f,g,isign,sct,indx,kxp,kblok,tsct)

       return
  end subroutine



!=========================================================================
!
!  This subroutine calculates particle charge density
!  using second-order spline interpolation, with periodic boundaries.
!
! =========================================================================


   subroutine ppush1(part,fx,npp,noff,qtme,dt,ek,idimp,npmax,nblok,nxpmx,sum_0)
  
      real,intent(inout) ::  part(:,:,:), fx(:,:),sum_0(:)
      integer,intent(inout) :: npp(:), noff(:)

      !hpf$ distribute *(*,*,block) :: part
      !hpf$ distribute *(*,block) :: fx
      !hpf$ distribute *(block) :: sum_0,npp,noff



 INTERFACE
  EXTRINSIC (F77_LOCAL) SUBROUTINE INDEP_LOOP_PPUSH1(PART,FX,NPP,&
                 NOFF,QTME, DT,SUM_0, idimp,npmax,nblok,nxpmx)

  
     REAL ,INTENT(INOUT)    :: PART(idimp,npmax,nblok)
     INTEGER,INTENT(IN)     :: NOFF(nblok),NPP(nblok)
     REAL ,INTENT(IN)        :: FX(nxpmx,nblok)
     REAL,INTENT(IN)        :: QTME,DT
     REAL,INTENT(INOUT)     :: SUM_0(nblok)
    
     !HPF$ DISTRIBUTE *(*,*,BLOCK)    :: PART
     !HPF$ DISTRIBUTE *(*,BLOCK)      :: FX
     !HPF$ DISTRIBUTE *(BLOCK)        :: SUM_0,NPP,NOFF


    END SUBROUTINE
  END INTERFACE



      CALL INDEP_LOOP_PPUSH1(part,fx,npp,noff,qtme,dt,sum_0,idimp,&
               npmax,nblok,nxpmx)

      sum1 = SUM(sum_0)

! normalize kinetic energy

      ek = ek + .125*sum1

      return
 end subroutine ppush1


! =========================================================================
!
!  This subroutine determines spatial boundaries for particle
!  decomposition, calculates number of grid points in each spatial
!  region, and the offset of these grid points from the global address
!
! =========================================================================
   
     subroutine dcomp1(edges,nxp,noff,nx,nvp,idps,nblok)
      real,intent(inout) ::  edges(:,:)
      integer,intent(inout) :: nxp(:), noff(:)

      !hpf$ distribute *(*,block):: edges
      !hpf$ distribute *(block) :: nxp,noff

      real at1
      integer k

      at1 = float(nx)/float(nvp)
      FORALL(k=1:nblok)
         edges(1,k) = at1*float(k-1)
         noff(k) = edges(1,k)  + .5
         edges(2,k) = at1*float(k)
         nxp(k) = INT(edges(2,k) + .5) - noff(k)
      ENDFORALL
      ! initialize starting address of all partitions 
      ! initialize the number of particles for each partiton
      ! initialize the charge density for each grid point,including guard
      ! cell 's grid point ,of each partiton. Here all the total number of 
      ! grid points for each partition are equal if we take each 
      ! constant as power of 2. Also the number of the primary grid points
      ! are equal 
    
      return
      end subroutine dcomp1


! =========================================================================
!
!  This subroutine calculates initial particle co-ordinate
!  and velocity, with uniform density and maxwellian velocity with drift.
! =========================================================================
  
       subroutine pistr1 (part,edges,npp,nps,vtx,vdx,npx,nx,idimp,npmax,&
     nblok,idps,sum_0)

      real,intent(inout)  :: part(:,:,:)
      real ,intent(inout) :: edges(:,:),sum_0(:)
      integer,intent(inout) ::  npp(:), nps(:)

      !hpf$ distribute *(*,*,block) :: part
      !hpf$ distribute *(*,block) ::edges
      !hpf$ distribute *(block) ::npp,nps,sum_0

 INTERFACE 
   EXTRINSIC (F77_LOCAL) SUBROUTINE INDEP_LOOP_PIST1_1(NPP,NPS,PART,SUM_0,&
    idimp,nblok,npmax)
    
    INTEGER,INTENT(IN)     :: NPP(nblok),NPS(nblok)
    REAL   ,INTENT(OUT)    :: SUM_0(nblok)
    REAL ,INTENT(IN) :: PART(idimp,npmax,nblok)

    !HPF$ DISTRIBUTE   *(BLOCK)         :: NPP,NPS ,SUM_0
    !HPF$ DISTRIBUTE   *(*,*,BLOCK)     :: PART

  END SUBROUTINE

  EXTRINSIC (F77_LOCAL) SUBROUTINE INDEP_LOOP_PIST1_2(NPP,NPS,PART,SUM_1,&
                   idimp,nblok,npmax)

    INTEGER,INTENT(IN)      :: NPP(nblok),NPS(nblok)
    REAL   ,             INTENT(IN)      :: SUM_1
    REAL ,INTENT(INOUT)    :: PART(idimp,npmax,nblok)

    !HPF$ DISTRIBUTE   *(BLOCK)           :: NPP,NPS
    !HPF$ DISTRIBUTE   *(*,*,BLOCK)       :: PART

  END SUBROUTINE

  extrinsic (f77_local) subroutine dist_particle(part,edges,npp,npx,vtx,nblok,&
        idimp,npmax,nx)
        real,intent(inout) :: part(idimp,npmax,nblok)
        real,intent(in)    :: edges(idimp,nblok)
        integer,intent(inout) :: npp(nblok)
    
        !HPF$ DISTRIBUTE   *(*,*,BLOCK)     :: PART
        !HPF$ DISTRIBUTE   *(*,BLOCK)     :: edges
        !HPF$ DISTRIBUTE   *(BLOCK)     ::npp
  end subroutine

 end interface


      double precision ranorm
      real sum_1


      call dist_particle (part,edges,npp,npx,vtx,nblok,idimp,npmax,nx)
      
      CALL  INDEP_LOOP_PIST1_1(NPP,NPS,PART,SUM_0,idimp,nblok,npmax)
     
      SUM_1 = SUM(SUM_0) ! Accumulate all the sums of partitions in SUM_1

      SUM_1 = SUM_1/FLOAT(NPX) - VDX

      CALL  INDEP_LOOP_PIST1_2(NPP,NPS,PART,SUM_1,idimp,nblok,npmax  )
      

      return
end subroutine pistr1

      

!=========================================================================
!  This subroutine solves 1d poisson's equation in fourier space for
!  force/charge (or convolution of electric field over particle shape)
!  with periodic boundary conditions.
!  The equation used is:
!    fx(k) = -sqrt(-1)*k*g(k)*s(k), where k = 2pi*j/nx, j = fourier mode,
!    g(k) = (affp/k**2)*s(k), and s(k) = exp(-(k*ax)**2/2), except for
!    fx(k=0) = fx(k=pi) = 0.
!
!  If isign is not equal to 0, force/charge is calculated.
!   aimag(ffc(j,k)) = particle shape factor s for fourier mode jj - 1
!   real(ffc(j,k)) = potential green's function g for fourier mode jj - 1
!
! =========================================================================
   
    subroutine ppois1 (q,fx,isign,ffc,ax,affp,wp,nx,kxp,kblok,nblok,sum_0)
     
      complex,intent(inout) ::  q(:,:), fx(:,:)
      complex,intent(inout) :: ffc(:,:)
      real,intent(inout) :: sum_0(:)

      !hpf$ distribute *(*,block) :: q,fx,ffc
      !hpf$ distribute *(block) :: sum_0

  INTERFACE
    EXTRINSIC (F77_LOCAL) SUBROUTINE INDEP_LOOP_PPOIS1_1(FFC,NX,KXP,AFFP,AX,&
               kblok)
      INTEGER ,INTENT(IN)                                 :: NX,KXP
      REAL  ,INTENT(IN)                                   :: AFFP,AX
      COMPLEX, INTENT(OUT)                :: FFC(kxp,kblok)

   
      !HPF$ DISTRIBUTE   *(*,BLOCK)  :: FFC
   END SUBROUTINE

    EXTRINSIC (F77_LOCAL) SUBROUTINE INDEP_LOOP_PPOIS1_2(FFC,QC,FC,NX,KXP,&
                                  AFFP,AX,sum_0,kblok,nblok)

      INTEGER ,INTENT(IN)                      :: NX,KXP
      REAL ,INTENT(IN)                         :: AFFP,AX
      COMPLEX, INTENT(IN)                 :: FFC(kxp,kblok),QC(kxp,kblok)
      COMPLEX,DIMENSION(:,:), INTENT(OUT)                :: FC(kxp,kblok)
      REAL, DIMENSION(:),INTENT(OUT)                     :: sum_0(nblok)


      !HPF$ DISTRIBUTE *(*,BLOCK)         :: FFC,FC,QC
      !HPF$ DISTRIBUTE *(BLOCK)           :: sum_0


   END SUBROUTINE
 END INTERFACE
   
      nxh = nx/2

      if (isign == 0)  then 
         if (1 > nxh) return
         CALL  INDEP_LOOP_PPOIS1_1(FFC,NX,KXP,AFFP,AX,kblok)
      else
         if (1 > nxh) return
         CALL INDEP_LOOP_PPOIS1_2(FFC,Q,FX,NX,KXP,&
                      AFFP,AX,sum_0,kblok,nblok)
! kblok is equal to nblok
         wp = SUM(sum_0)
         wp = float(nx)*wp
      endif

      return 
      end subroutine ppois1


! =========================================================================
!
! thus subroutine copies data between particle and field partitions.
! if isign = -1, data is copied from particle to field partition.
! if isign = 1, data is copied from field to particle partition.
!
! =========================================================================
! Dont forget to initialize the array parameters f and fc
! because we are passing parameter as global variables
    
     subroutine cppfp1 (f,fc,isign,scr,scc,nvp,nxpmx,nblok,kxp,kblok,idps)
        
      real,intent(inout) :: f(:,:)
      complex,intent(inout)  :: fc(:,:),scc(:,:)
      real,intent(inout) ::scr(:,:)

      !hpf$ distribute *(*,block) :: f,fc,scr,scc

      interface
       extrinsic (f77_local) subroutine do_forall(f,fc,kxp,kblok)
             real,intent(out) ::  f(:,:)
             complex,intent(in) :: fc(:,:)

             !hpf$ distribute *(*,block) :: f,fc
       end subroutine
      end interface

! ---------------------------------------
! copy from particle to field partition
! ---------------------------------------
      if (isign == -1) then

         FORALL(K=1:KBLOK,J=1:KXP)
           fc(j,k) = cmplx(f(2*j,k),f(2*j+1,k))
         ENDFORALL

         SCR(1,:) = CSHIFT(f(NXPMX-1, :),-1) ! SHIFT ONE TO THE RIGHT
         SCR(2,:) = CSHIFT(f(NXPMX,   :),-1) ! SHIFT ONE TO THE RIGHT

         fC(1,:) = fC(1,:) +CMPLX(SCR(1,:),SCR(2,:))

!         FORALL(J=1:KXP)      
!           fC(1,j) = fC(1,j) +CMPLX(SCR(1,j),SCR(2,j))
!         endforall  

         SCR(1,:) = CSHIFT(f(1,:),+1 ) ! SHIFT ONE TO THE LEFT

         fC(KXP,:) = fC(KXP,:) + CMPLX(0.0,SCR(1,:))
        
!         FORALL(J=1:KXP)
!           fC(KXP,j) = fC(KXP,j) + CMPLX(0.0,SCR(1,j))
!         endforall

       else if (isign == 1) then

! --------------------------------------
! copy from field to particle partition
! --------------------------------------

         call do_forall(f,fc,kxp,kblok)

         SCC(1,:) = CSHIFT(FC(KXP,:),-1)

         F(1,:) = AIMAG(SCC(1,:))

!         forall(j=1:kxp)
!            F(1,j) = AIMAG(SCC(1,j))
!         endforall

         SCC(1,:) = CSHIFT(FC(1,:),+1)

         F(NXPMX-1, :) = REAL(SCC(1,:))
         F(NXPMX,   :) = AIMAG(SCC(1,:))
     
!         forall(j=1:kxp)
!           F(NXPMX-1, j) = REAL(SCC(1,j))
!           F(NXPMX,   j) = AIMAG(SCC(1,j))
!         endforall
     endif

     return
     end subroutine cppfp1




