
c * * * periodic 2d electrostatic particle simulation kernel code * * *
c for IBM SP1 

      program beps2k

      parameter( indx =   5, indy =   6, npx =      96, npy =     192)
cbenc parameter( indx =   6, indy =   7, npx =     384, npy =     768)
cbenc parameter( indx =   7, indy =   8, npx =    1280, npy =    2560)

      parameter( npxb =  32, npyb =  64)
cbenc parameter( npxb = 128, npyb = 256)
cbenc parameter( npxb = 384, npyb = 768)

      parameter( tend =  65.000, dt = 0.2000000e+00)

      parameter( vty =   1.000, vdy =   5.000, vtdy =   0.500)

      parameter( avdy =   5.000)

c mshare = (0,1) = (no,yes) architecture is shared memory
      parameter( indnvp =   2, idps =    2, idimp =   4, mshare =   1)

      parameter(npxy=npx*npy,npxyb=npxb*npyb,np=npxy+npxyb)
      parameter(nx=2**indx,ny=2**indy,nxh=nx/2,nyh=ny/2)
      parameter(nxv=nx+2,nyv=ny+2,nxvh=nxv/2,nxvy=nxv*ny)

      parameter(nloop=tend/dt+.0001)

      parameter(nvp=2**indnvp,nblok=1+mshare*(nvp-1))

      parameter(npmax=(np/nvp)*1.01+7000,nypmx=(ny-1)/nvp+4)
      parameter(nxvyp=nxv*nypmx)

      parameter(kyp=(ny-1)/nvp+1,kxp=(nxh-1)/nvp+1)

      parameter(kblok=1+mshare*(ny/kyp-1),jblok=1+mshare*(nxh/kxp-1))

      parameter(nmx=nx*(ny/nx)+ny*(nx/ny),nxy=nmx/(2-nx/nmx-ny/nmx))
      parameter(nxyh=nxy/2,nmxh=nxh*(ny/nxh)+ny*(nxh/ny))
      parameter(nxhy=nmxh/(2-nxh/nmxh-ny/nmxh))

      parameter(nbmax=1+(2*(npxy*vty+npxyb*vtdy)+1.4*npxyb*avdy)*dt/ny)

      parameter(ntmax=2*nbmax)

      parameter(npd=128,nine=9)
      complex qc, fxc, fyc, qt, fxt, fyt, ffc, bs, br, scr, sct
      common /large/ part

      dimension part(idimp,npmax,nblok)
      dimension q(nxv,nypmx,nblok)
      dimension qc(nxvh,kyp,kblok)
      dimension qt(nyv,kxp,jblok)

      dimension fx(nxv,nypmx,nblok), fy(nxv,nypmx,nblok)
      dimension fxc(nxvh,kyp,kblok), fyc(nxvh,kyp,kblok)
      dimension fxt(nyv,kxp,jblok),  fyt(nyv,kxp,jblok)
      dimension ffc(nyh,kxp,jblok)

      dimension mixup(nxhy), sct(nxyh)

      dimension bs(kxp,kyp,kblok), br(kxp,kyp,jblok)

      dimension edges(idps,nblok)

      dimension nyp(nblok), noff(nblok)
      dimension npp(nblok), nps(nblok)

      dimension sbufl(idimp,nbmax,nblok), sbufr(idimp,nbmax,nblok)
      dimension rbufl(idimp,nbmax,nblok), rbufr(idimp,nbmax,nblok)

      dimension ihole(ntmax,nblok)

      dimension jsl(idps,nblok), jsr(idps,nblok)
      dimension jss(idps,nblok), scr(nxvh,idps,nblok)

      real PGI_t0, PGI_total

  991 format (5h t = ,i7)
  992 format (19h * * * q.e.d. * * *)
  993 format (34h field, kinetic, total energies = ,3e14.7)

      data vtx,qme,vdx,vtdx /1.,-1.,0.,.5/
      data ax,ay /.866667,.866667/

c ntpose = (0,1) = (no,yes) input, output data are transposed in pfft2r
      data ntpose /1/

!HPF$ PROCESSORS :: PROCS(4)
!HPF$ DISTRIBUTE (BLOCK) ONTO PROCS :: nps, npp, noff, nyp
!HPF$ DISTRIBUTE (*,BLOCK) ONTO PROCS :: jsl, jsr, jss
!HPF$ DISTRIBUTE (*,BLOCK) :: edges
!HPF$ DISTRIBUTE (*,*,BLOCK) :: part
!HPF$ DISTRIBUTE (*,*,BLOCK) :: q 
!HPF$ DISTRIBUTE (*,*,BLOCK) :: fx, fy
!HPF$ DISTRIBUTE (*,*,BLOCK) :: fxc, fyc
!HPF$ DISTRIBUTE (*,*,BLOCK) :: scr  
c -------------------------------------
c initialize for parallel processing
c -------------------------------------
      call ppinit(idproc,nvp)
      kstrt = idproc + 1
      if (kstrt.eq.1) then
         open(unit=6,file='output2',form='formatted',status='unknown')
      endif
c -------------------------------------
c initialize timer
c -------------------------------------
      call TIMER(PGI_t0)
c -------------------------------------
c initialize constants
c -------------------------------------
      itime = 0
      qtme = qme*dt
      affp = float(nx*ny)/float(np)
      zero = 0.
c -------------------------------------
c calculate partition variables
c -------------------------------------
      call dcomp2(edges,nyp,noff,ny,kstrt,nvp,idps,nblok)
c -------------------------------------
c prepare fft tables
c -------------------------------------
      isign = 0
      call pfft2r(qc,qt,bs,br,isign,ntpose,mixup,sct,indx,indy,kstrt,nxv
     1h,nyv,kxp,kyp,jblok,kblok,nxhy,nxyh)
c -------------------------------------
c calculate form factors
c -------------------------------------
      call ppois2(qt,fxt,fyt,isign,ffc,ax,ay,affp,we,nx,ny,kstrt,nyv,kxp
     1,jblok,nyh)
c ------------------------------------------------------
c initialize density profile and velocity distribution
c background electrons
c ------------------------------------------------------
      npp(1:nblok) = 0
      nps(1:nblok) = 1
!HPF$ INDEPENDENT, new(nyp3,k,j)
      do 130 l = 1, nblok
         nyp3 = nyp(l) + 3
         do 120 k = 1, nyp3
            do 110 j = 1, nx
               q(j,k,l) = 0.
  110       continue
  120    continue
  130 continue
      if (npxy.gt.0) call pistr2 (part,edges,npp,nps,vtx,vty,zero,zero,n
     1px,npy,nx,ny,idimp,npmax,nblok,idps)
c ----------------
c beam electrons
c ----------------
      nps(1:nblok) = npp(1:nblok) + 1
      if (npxyb.gt.0) call pistr2 (part,edges,npp,nps,vtdx,vtdy,vdx,vdy,
     1npxb,npyb,nx,ny,idimp,npmax,nblok,idps)
c ----------------------------------------
c deposit charge for initial distribution
c ----------------------------------------
      call pdost2(part,q,npp,noff,qme,nx,idimp,npmax,nblok,nxv,nypmx)

c -----------------------------
c add background ion density
c -----------------------------
      qi0 = -qme/affp
!HPF$ INDEPENDENT, new(k,j)
      do 240 l = 1, nblok
         do k = 1, nyp(l)
            do j = 1, nx
               q(j,k+1,l) = q(j,k+1,l) + qi0
            enddo
         enddo
  240 continue
c =======================================
c
c * * * start main iteration loop * * *
c
c =======================================
  500 if (nloop.le.itime) go to 2000
      if (kstrt.eq.1) write (6,991) itime
      isign = -1
c -------------------------------------------------------------------
c copy data from particle to field partition, and add up guard cells
c -------------------------------------------------------------------
      call cppfp2 (q,qc,isign,scr,kstrt,nvp,nx,nxv,nypmx,nblok,nxvh,kyp,
     1kblok,idps)
c ----------------------------------
c transform charge to fourier space
c ----------------------------------
      call pfft2r(qc,qt,bs,br,isign,ntpose,mixup,sct,indx,indy,kstrt,nxv
     1h,nyv,kxp,kyp,jblok,kblok,nxhy,nxyh)
c -----------------------------------------
c calculate force/charge in fourier space
c -----------------------------------------
      call ppois2(qt,fxt,fyt,isign,ffc,ax,ay,affp,we,nx,ny,kstrt,nyv,kxp
     1,jblok,nyh)
c -------------------------------------
c transform force/charge to real space
c -------------------------------------
      isign = 1
      call pfft2r(fxc,fxt,bs,br,isign,ntpose,mixup,sct,indx,indy,kstrt,n
     1xvh,nyv,kxp,kyp,jblok,kblok,nxhy,nxyh)
      call pfft2r(fyc,fyt,bs,br,isign,ntpose,mixup,sct,indx,indy,kstrt,n
     1xvh,nyv,kxp,kyp,jblok,kblok,nxhy,nxyh)
c --------------------------------------------------------------------
c copy data from field to particle partition, and copy to guard cells
c --------------------------------------------------------------------
      call cppfp2 (fx,fxc,isign,scr,kstrt,nvp,nx,nxv,nypmx,nblok,nxvh,ky
     1p,kblok,idps)
      call cppfp2 (fy,fyc,isign,scr,kstrt,nvp,nx,nxv,nypmx,nblok,nxvh,ky
     1p,kblok,idps)
c -----------------------------------------
c particle push and charge density update
c -----------------------------------------
c     call timera(-1,'push    ')
c -----------------------------------
c initialize charge density to zero
c -----------------------------------
!HPF$ INDEPENDENT, new(nyp3, k, j)
      do 1250 l = 1, nblok
         nyp3 = nyp(l) + 3
         do k = 1, nyp3
            do j = 1, nx
               q(j,k,l) = 0.
            enddo
         enddo
 1250 continue
      wke = 0.
c ----------------
c push particles
c ----------------
      call ppush2 (part,fx,fy,npp,noff,qtme,dt,wke,nx,idimp,npmax,nblok,
     1nxv,nypmx)
c -------------------------------------------------
c move particles into appropriate spatial regions
c -------------------------------------------------
      call pmove2 (part,edges,npp,sbufr,sbufl,rbufr,rbufl,ihole,jsr,jsl,
     1jss,ny,kstrt,nvp,idimp,npmax,nblok,idps,nbmax,ntmax,ierr)
c ----------------
c deposit charge
c ----------------
      call pdost2(part,q,npp,noff,qme,nx,idimp,npmax,nblok,nxv,nypmx)
c ----------------------
c add background charge
c ----------------------
!HPF$ INDEPENDENT, new(k, j)
      do 1280 l = 1, nblok
         do k = 1, nyp(l)
            do j = 1, nx
               q(j,k+1,l) = q(j,k+1,l) + qi0
            enddo
         enddo
 1280 continue
c     call timera(1,'push    ')
c --------------------
c energy diagnostic
c --------------------
      wt = we + wke
      if (kstrt.eq.1) write (6,993) we, wke, wt
      itime = itime + 1
      go to 500
 2000 continue
c =====================================
c
c * * * end main iteration loop * * *
c
c =====================================
      if (kstrt.eq.1) write (6,992)
      call TIMER(PGI_total)
      print *,'total time = ',(PGI_total - PGI_t0), 'seconds',
     1      PGI_total, PGI_t0
!      call ppexit
      stop
      end
C =======================================================
c - - - this subroutine initializes parallel processing
C =======================================================
      subroutine ppinit(idproc,nvp)
      character*8 jbname
c     parameter(MAXTDS=1024)
      common /pparms/ nproc, nprec, lgrp, jbname
c     common /pvtids/ idts
c     dimension idts(MAXTDS+1)
c     save pvtids
c nproc = number of real or virtual processors obtained
c nprec = (4,8) = number of bytes per word
c this segment is used for shared memory computers
      nproc = nvp
      idproc = 0
      if (nproc.ne.nvp) then
         write (6,*) ' processor number error: nvp,nproc=',nvp,nproc
!         call ppexit
         stop
      endif
      return
      end

C =======================================================================
c - - - this subroutine determines spatial boundaries for particle
c - - - decomposition, calculates number of grid points in each spatial
c - - -region, and the offset of these grid points from the global address
C =======================================================================
      subroutine dcomp2(edges,nyp,noff,ny,kstrt,nvp,idps,nblok)
      dimension edges(idps,nblok)
      dimension nyp(nblok), noff(nblok)
      ks = kstrt - 2
      at1 = float(ny)/float(nvp)
!HPF$ INDEPENDENT, new(kb, kr)
      do 10 l = 1, nblok
         kb = l + ks
         edges(1,l) = at1*float(kb)
         noff(l) = edges(1,l) + .5
         edges(2,l) = at1*float(kb + 1)
         kr = edges(2,l) + .5
         nyp(l) = kr - noff(l)
   10 continue
      return
      end
C =======================================================================
c for 2d code, this subroutine calculates initial particle co-ordinates
c and velocities with uniform density and maxwellian velocity with drift
c for distributed data.
C =======================================================================
      subroutine pistr2 (part,edges,npp,nps,vtx,vty,vdx,vdy,npx,npy,nx,n
     1y,idimp,npmax,nblok,idps)
      character*8 jbname
      double precision ranorm
      common /pparms/ nproc, nprec, lgrp, jbname
      external s_vadd
      dimension part(idimp,npmax,nblok)
      dimension edges(idps,nblok), npp(nblok), nps(nblok)
      dimension sum2(2)
      npxy = npx*npy
      at1 = float(nx)/float(npx)
      at2 = float(ny)/float(npy)
      do 30 k = 1, npy
         yt = at2*(float(k) - .5)
         do 20 j = 1, npx
c ---------------------------------
c uniform density profile
c ---------------------------------
            xt = at1*(float(j) - .5)
c ---------------------------------
c maxwellian velocity distribution
c ---------------------------------
            vxt = vtx*ranorm(d)
            vyt = vty*ranorm(d)
            do 10 l = 1, nblok
               if ((yt.ge.edges(1,l)).and.(yt.lt.edges(2,l))) then
                  npt = npp(l) + 1
                  part(1,npt,l) = xt
                  part(2,npt,l) = yt
                  part(3,npt,l) = vxt
                  part(4,npt,l) = vyt
                  npp(l) = npt
               endif
   10       continue
   20    continue
   30 continue
c -------------------
c add correct drift
c -------------------
      sum2(1) = 0.
      sum2(2) = 0.
      do 50 l = 1, nblok
         sum0 = 0.
         sum1 = 0.
         do 40 j = nps(l), npp(l)
            sum0 = sum0 + part(3,j,l)
            sum1 = sum1 + part(4,j,l)
   40    continue
         sum2(1) = sum2(1) + sum0
         sum2(2) = sum2(2) + sum1
   50 continue
      at1 = 1./float(npxy)
      sum2(1) = at1*sum2(1) - vdx
      sum2(2) = at1*sum2(2) - vdy
!HPF$ INDEPENDENT, new(j)
      do 70 l = 1, nblok
         do 60 j = nps(l), npp(l)
            part(3,j,l) = part(3,j,l) - sum2(1)
            part(4,j,l) = part(4,j,l) - sum2(2)
   60    continue
   70 continue
      return
      end
C =========================================================================
c for 2d code, this subroutine calculates particle charge density
c using second-order spline interpolation, periodic boundaries
c and distributed data.
c charge density is approximated by values at the nearest grid points
c q(n,m)=qm*(.75-dx**2)*(.75-dy**2)
c q(n+1,m)=.5*qm*((.5+dx)**2)*(.75-dy**2)
c q(n-1,m)=.5*qm*((.5-dx)**2)*(.75-dy**2)
c q(n,m+1)=.5*qm*(.75-dx**2)*(.5+dy)**2
c q(n+1,m+1)=.25*qm*((.5+dx)**2)*(.5+dy)**2
c q(n-1,m+1)=.25*qm*((.5-dx)**2)*(.5+dy)**2
c q(n,m-1)=.5*qm*(.75-dx**2)*(.5-dy)**2
c q(n+1,m-1)=.25*qm*((.5+dx)**2)*(.5-dy)**2
c q(n-1,m-1)=.25*qm*((.5-dx)**2)*(.5-dy)**2
c where n,m = nearest grid points and dx = x-n, dy = y-m
C =========================================================================
      subroutine pdost2(part,q,npp,noff,qm,nx,idimp,npmax,nblok,nxv,nypm
     1x)
c scalar version with spatial decomposition
      dimension part(idimp,npmax,nblok), q(nxv,nypmx,nblok)
      dimension npp(nblok), noff(nblok)
!HPF$ INDEPENDENT, NEW(amx, dxl, dyl, dxp, dyp, nl,nn,ml,mm,mnoff,mp)
      do 20 l = 1, nblok
       mnoff = noff(l) - 2
c -------------------------------
c find interpolation weights
c -------------------------------
       do 10 j = 1, npp(l)
         nn = part(1,j,l) + .5
         dxl = part(1,j,l) - float(nn)
         nn = nn + 1
         if (nn.gt.nx) nn = nn - nx
         amx = qm*(.75 - dxl*dxl)
         np = nn + 1
         if (np.gt.nx) np = np - nx
         dxp = .5*qm*(.5 + dxl)**2
         nl = nn - 1
         if (nl.lt.1) nl = nl + nx
         dxl = .5*qm*(.5 - dxl)**2
         mm = part(2,j,l) + .5
         dyl = part(2,j,l) - float(mm)
         mm = mm - mnoff
         amy = .75 - dyl*dyl
         mp = mm + 1
         dyp = .5*(.5 + dyl)**2
         ml = mm - 1
         dyl = .5*(.5 - dyl)**2
c ----------------
c deposit charge
c ----------------
         q(nn,mm,l) = q(nn,mm,l) + amx*amy
         q(np,mm,l) = q(np,mm,l) + dxp*amy
         q(nl,mm,l) = q(nl,mm,l) + dxl*amy
         q(nn,mp,l) = q(nn,mp,l) + amx*dyp
         q(np,mp,l) = q(np,mp,l) + dxp*dyp
         q(nl,mp,l) = q(nl,mp,l) + dxl*dyp
         q(nn,ml,l) = q(nn,ml,l) + amx*dyl
         q(np,ml,l) = q(np,ml,l) + dxp*dyl
         q(nl,ml,l) = q(nl,ml,l) + dxl*dyl
   10  continue
   20 continue
      return
      end

C =========================================================================
c thus subroutine copies data between particle and field partitions,
c where the field and particle partitions are assumed to be the same.
c in going from particle to field partitions, data from guard cells
c is added to the field partition.  in going from field to particle
c partitions, data is copied to the guard cells.
c f(j,k,l) = real data for grid j,k in particle partition l.  the number
c grids per partition is uniform and includes three extra guard cells.
c fc(j,k,l) = complex data for grid j,k in field partition l.  the
c number of grids per partition is uniform and maximum number of
c partitions is ny/2.
c if isign = -1, data is copied from particle to field partition.
c if isign = 1, data is copied from field to particle partition.
C =========================================================================

      subroutine cppfp2 (f,fc,isign,scr,kstrt,nvp,nx,nxv,nypmx,nblok,nxv
     1h,kyp,kblok,idps)

      character*8 jbname
      common /pparms/ nproc, nprec, lgrp, jbname
      complex fc, scr
      dimension f(nxv,nypmx,nblok), fc(nxvh,kyp,kblok)
      dimension scr(nxvh,idps,nblok)
      nxh = nx/2
      ks = kstrt - 2
      moff = nypmx*nvp
      if (isign) 10, 100, 110
c --------------------------------------
c copy from particle to field partition
c --------------------------------------
   10 continue
!HPF$ INDEPENDENT, NEW(k, j)
      do 40 l = 1, kblok
       do 30 k = 1, kyp
         do 20 j = 1, nxh
           fc(j,k,l) = cmplx(f(2*j-1,k+1,l),f(2*j,k+1,l))
   20    continue
   30  continue
   40 continue
c -----------------
c add guard cells
c -----------------
!HPF$ INDEPENDENT, NEW(kr, krr, kl, ngc, j)
      do 90 l = 1, kblok
        kr = l + ks + 2
        if (kr.gt.nvp) kr = kr - nvp
        krr = kr
        kl = l + ks
        if (kl.lt.1) kl = kl + nvp
        kll = kl
        ngc = 2
c ---------------------------------------------
c special case of only one grid per processor
c ---------------------------------------------
        if (kyp.eq.1) then
          krr = krr + 1
          if (krr.gt.nvp) krr = krr - nvp
          kll = kll - 1
          if (kll.lt.1) kll = kll + nvp
          ngc = 1
        endif
c ---------------------------------
c first add guard cells from right
c ---------------------------------
        do 50 j = 1, nxh
          scr(j,1,l) = cmplx(f(2*j-1,kyp+2,kl),f(2*j,kyp+2,kl))
          scr(j,2,l) = cmplx(f(2*j-1,kyp+3,kll),f(2*j,kyp+3,kll))
   50   continue
        do 60 j = 1, nxh
          fc(j,1,l) = fc(j,1,l) + scr(j,1,l)
          fc(j,ngc,l) = fc(j,ngc,l) + scr(j,2,l)
   60   continue
c -------------------------------
c then add guard cells from left
c -------------------------------
        do 70 j = 1, nxh
          scr(j,1,l) = cmplx(f(2*j-1,1,kr),f(2*j,1,kr))
   70   continue
        do 80 j = 1, nxh
          fc(j,kyp,l) = fc(j,kyp,l) + scr(j,1,l)
   80   continue
   90 continue
  100 return
c ---------------------------------------
c copy from field to particle partition
c ---------------------------------------
  110 continue
!HPF$ INDEPENDENT, NEW(k, j)
      do 140 l = 1, kblok
        do 130 k = 1, kyp
          do 120 j = 1, nxh
            f(2*j-1,k+1,l) = real(fc(j,k,l))
            f(2*j,k+1,l) = aimag(fc(j,k,l))
  120     continue
  130   continue
  140 continue
c ---------------------
c copy to guard cells
c ---------------------
!HPF$ INDEPENDENT, NEW(kr, krr, kl, ngc)
      do 170 l = 1, kblok
        kr = l + ks + 2
        if (kr.gt.nvp) kr = kr - nvp
        krr = kr
        kl = l + ks
        if (kl.lt.1) kl = kl + nvp
        kll = kl
        ngc = 2
c --------------------------------------------
c special case of only one grid per processor
c --------------------------------------------
        if (kyp.eq.1) then
          krr = krr + 1
          if (krr.gt.nvp) krr = krr - nvp
          kll = kll - 1
          if (kll.lt.1) kll = kll + nvp
          ngc = 1
        endif
c -------------------------
c copy to left guard cell
c -------------------------
        do 150 j = 1, nxh
          f(2*j-1,1,l) = real(fc(j,kyp,kl))
          f(2*j,1,l) = aimag(fc(j,kyp,kl))
  150   continue
c ---------------------------
c copy to right guard cells
c ---------------------------
        do 160 j = 1, nxh
          f(2*j-1,kyp+2,l) = real(fc(j,1,kr))
          f(2*j,kyp+2,l) = aimag(fc(j,1,kr))
          f(2*j-1,kyp+3,l) = real(fc(j,ngc,krr))
          f(2*j,kyp+3,l) = aimag(fc(j,ngc,krr))
  160   continue
  170 continue
      return
      end

C ========================================================================
c this subroutine solves 2d poisson's equation in fourier space for
c force/charge (or convolution of electric field over particle shape)
c with periodic boundary conditions, for distributed data.
c the equation used is:
c fx(kx,ky) = -sqrt(-1)*kx*g(kx,ky)*s(kx,ky),
c fy(kx,ky) = -sqrt(-1)*ky*g(kx,ky)*s(kx,ky),
c where kx = 2pi*j/nx, ky = 2pi*k/ny, and j,k = fourier mode numbers,
c g(kx,ky) = (affp/(kx**2+ky**2))*s(kx,ky),
c s(kx,ky) = exp(-((kx*ax)**2+(ky*ay)**2)/2), except for
c for fourier mode (jj-1,k-1), where jj = j + kxp*(l - 1)
c if isign = 0, form factor array is prepared
c if isign is not equal to 0, force/charge is calculated.
c aimag(ffc(k,j,l)) = finite-size particle shape factor s
c real(ffc(k,j,l)) = potential green's function g
c for fourier mode (jj-1,k-1), where jj = j + kxp*(l - 1)
c ax/ay = half-width of particle in x/y direction
c affp = normalization constant = nx*ny/np, where np=number of particles
c electric field energy is also calculated, using
c wp = nx*ny*sum((affp/(kx**2+ky**2))*|q(kx,ky)*s(kx,ky)|**2)
c nx/ny = system length in x/y direction
c nyv = first dimension of field arrays, must be >= ny
c nyhd = first dimension of form factor array, must be >= nyh
C ========================================================================
      subroutine ppois2(q,fx,fy,isign,ffc,ax,ay,affp,wp,nx,ny,kstrt,nyv,
     1kxp,jblok,nyhd)
      character*8 jbname
      common /pparms/ nproc, nprec, lgrp, jbname
      complex q, fx, fy, ffc, zero
      external s_vadd
      dimension q(nyv,kxp,jblok)
      dimension fx(nyv,kxp,jblok), fy(nyv,kxp,jblok)
      dimension ffc(nyhd,kxp,jblok)
      nxh = nx/2
      nyh = ny/2
      ny2 = ny + 2
      ks = kstrt - 2
      dnx = 6.28318530717959/float(nx)
      dny = 6.28318530717959/float(ny)
      zero = cmplx(0.,0.)
      if (isign.ne.0) go to 40
      if (kstrt.gt.nxh) return
c ---------------------------
c prepare form factor array
c ---------------------------
      do 30 l = 1, jblok
        joff = kxp*(l + ks) - 1
        do 20 j = 1, kxp
          dkx = dnx*float(j + joff)
          at1 = dkx*dkx
          at2 = (dkx*ax)**2
          do 10 k = 1, nyh
            dky = dny*float(k - 1)
            at3 = dky*dky + at1
            at4 = exp(-.5*((dky*ay)**2 + at2))
            if (at3.eq.0.) then
              ffc(k,j,l) = cmplx(0.,1.)
            else
              ffc(k,j,l) = cmplx(affp*at4/at3,at4)
            endif
   10     continue
   20   continue
   30 continue
      return
c ---------------------------------------------
c calculate force/charge and sum field energy
c ---------------------------------------------
   40 wp = 0.
      if (kstrt.gt.nxh) go to 90
      do 80 l = 1, jblok
c mode numbers 0 < kx < nx/2 and 0 < ky < ny/2
        joff = kxp*(l + ks) - 1
        do 60 j = 1, kxp
          dkx = dnx*float(j + joff)
          if ((j+joff).gt.0) then
            do 50 k = 2, nyh
              k1 = ny2 - k
              at1 = real(ffc(k,j,l))*aimag(ffc(k,j,l))
              at2 = dkx*at1
              at3 = dny*float(k - 1)*at1
              fx(k,j,l) = at2*cmplx(aimag(q(k,j,l)),-real(q(k,j,l)))
              fx(k1,j,l) = at2*cmplx(aimag(q(k1,j,l)),-real(q(k1,j,l)))
              fy(k,j,l) = at3*cmplx(aimag(q(k,j,l)),-real(q(k,j,l)))
              fy(k1,j,l) = at3*cmplx(-aimag(q(k1,j,l)),real(q(k1,j,l)))
              wp = wp + at1*(q(k,j,l)*conjg(q(k,j,l)) + 
     1              q(k1,j,l)*conjg(q(k1,j,l)))
   50       continue
          endif
c ---------------------------
c mode numbers ky = 0, ny/2
c ---------------------------
          k1 = nyh + 1
          at1 = real(ffc(1,j,l))*aimag(ffc(1,j,l))
          fx(1,j,l) = dkx*at1*cmplx(aimag(q(1,j,l)),-real(q(1,j,l)))
          fx(k1,j,l) = zero
          fy(1,j,l) = zero
          fy(k1,j,l) = zero
          wp = wp + at1*(q(1,j,l)*conjg(q(1,j,l)))
   60   continue
c ---------------------------
c mode numbers kx = 0, nx/2
c ---------------------------
        if ((l+ks).eq.0) then
          do 70 k = 2, nyh
            k1 = ny2 - k
            at1 = real(ffc(k,1,l))*aimag(ffc(k,1,l))
            fx(k,1,l) = zero
            fx(k1,1,l) = zero
            fy(k,1,l) = dny*float(k - 1)*at1*
     1            cmplx(aimag(q(k,1,l)),-real(q(k,1,l)))
            fy(k1,1,l) = zero
            wp = wp + at1*(q(k,1,l)*conjg(q(k,1,l)))
   70     continue
        endif
   80 continue
   90 continue

      wp = float(nx*ny)*wp
      return
      end
C =========================================================================
c for 2d code, this subroutine updates particle co-ordinates and
c velocities using leap-frog scheme in time and second-order spline
c interpolation in space, with periodic boundary conditions,
c for distributed data.  equations used are:
c vx(t+dt/2) = vx(t-dt/2) + (q/m)*fx(x(t),y(t))*dt,
c vy(t+dt/2) = vy(t-dt/2) + (q/m)*fy(x(t),y(t))*dt,
c where q/m is charge/mass, and
c x(t+dt) = x(t) + vx(t+dt/2)*dt, y(t+dt) = y(t) + vy(t+dt/2)*dt
c fx(x(t),y(t)) and fy(x(t),y(t)) are approximated by interpolation from
c the nearest grid points:
c fx(x,y) = (.75-dy**2)*((.75-dx**2)*fx(n,m)+(.5*(.5+dx)**2)*fx(n+1,m)+
c (.5*(.5-dx)**2)*fx(n-1,m)) + (.5*(.5+dy)**2)*((.75-dx**2)*fx(n,m+1)+
c (.5*(.5+dx)**2)*fx(n+1,m+1)+(.5*(.5-dx)**2)*fx(n-1,m+1)) +
c (.5*(.5-dy)**2)*((.75-dx**2)*fx(n,m-1)+(.5*(.5+dx)**2)*fx(n+1,m-1)+
c (.5*(.5-dx)**2)*fx(n-1,m-1))
c fy(x,y) = (.75-dy**2)*((.75-dx**2)*fy(n,m)+(.5*(.5+dx)**2)*fy(n+1,m)+
c (.5*(.5-dx)**2)*fy(n-1,m)) + (.5*(.5+dy)**2)*((.75-dx**2)*fy(n,m+1)+
c (.5*(.5+dx)**2)*fy(n+1,m+1)+(.5*(.5-dx)**2)*fy(n-1,m+1)) +
c (.5*(.5-dy)**2)*((.75-dx**2)*fy(n,m-1)+(.5*(.5+dx)**2)*fy(n+1,m-1)+
c (.5*(.5-dx)**2)*fy(n-1,m-1))
c where n,m = nearest grid points and dx = x-n, dy = y-m
c 
C =========================================================================
      subroutine ppush2 (part,fx,fy,npp,noff,qtm,dt,ek,nx,idimp,npmax,nb
     1lok,nxv,nypmx)

      character*8 jbname
      common /pparms/ nproc, nprec, lgrp, jbname
      external s_vadd
      dimension part(idimp,npmax,nblok)
      dimension fx(nxv,nypmx,nblok), fy(nxv,nypmx,nblok)
      dimension npp(nblok), noff(nblok)
      DIMENSION sum_local(nblok)   ! THIS IS AN EXTENSION
      zero = 0.
      anx = float(nx)
      sum1 = 0.
      do l = 1, nblok
        sum_local(l) = 0.
      enddo
!HPF INDEPENDENT,NEW(amx,amy,dx,dy,dxl,dyl,dxp,dyp,ml,mm,mp,mnoff,nl,nn,np,tempval)
      do 20 l = 1, nblok
        mnoff = noff(l) - 2
c ---------------------------
c find interpolation weights
c ---------------------------
        do 10 j = 1, npp(l)
          nn = part(1,j,l) + .5
          dx = part(1,j,l) - float(nn)
          nn = nn + 1
          if (nn.gt.nx) nn = nn - nx
          amx = .75 - dx*dx
          np = nn + 1
          if (np.gt.nx) np = np - nx
          dxp = .5*(.5 + dx)**2
          nl = nn - 1
          if (nl.lt.1) nl = nl + nx
          dxl = .5*(.5 - dx)**2
          mm = part(2,j,l) + .5
          dy = part(2,j,l) - float(mm)
          mm = mm - mnoff
          amy = .75 - dy*dy
          mp = mm + 1
          dyp = .5*(.5 + dy)**2
          ml = mm - 1
          dyl = .5*(.5 - dy)**2
c ------------------
c find acceleration
c ------------------
          dx = amy*(amx*fx(nn,mm,l) + dxp*fx(np,mm,l) + dxl*fx(nl,mm,l))
     1  + dyp*(amx*fx(nn,mp,l) + dxp*fx(np,mp,l) + dxl*fx(nl,mp,l))
     2  + dyl*(amx*fx(nn,ml,l)+ dxp*fx(np,ml,l) + dxl*fx(nl,ml,l))
          dy = amy*(amx*fy(nn,mm,l) + dxp*fy(np,mm,l) + dxl*fy(nl,mm,l)) 
     1  + dyp*(amx*fy(nn,mp,l) + dxp*fy(np,mp,l) + dxl*fy(nl,mp,l))
     2  + dyl*(amx*fy(nn,ml,l)+ dxp*fy(np,ml,l) + dxl*fy(nl,ml,l))
c --------------
c new velocity
c --------------
          dx = part(3,j,l) + qtm*dx
          dy = part(4,j,l) + qtm*dy
c -----------------------
c average kinetic energy
c -----------------------
          tempval = (dx + part(3,j,l))**2 + (dy + part(4,j,l))**2
          sum1 = sum1 + tempval
          sum_local(l) = sum_local(l) + tempval
          part(3,j,l) = dx
          part(4,j,l) = dy
c -------------
c new position
c -------------
          dx = part(1,j,l) + dx*dt
          dy = part(2,j,l) + dy*dt
c ------------------------------
c periodic boundary conditions
c ------------------------------
          if (dx.lt.zero) dx = dx + anx
          if (dx.ge.anx) dx = dx - anx
          part(1,j,l) = dx
          part(2,j,l) = dy
   10   continue
   20 continue
c --------------------------
c normalize kinetic energy
c --------------------------
      sumx = 0.
      do l = 1, nblok
         sumx = sumx + sum_local(l)
      enddo 
      print *, 'sum1=', sum1, 'sum(local)=', sumx
      ek = ek + .125*sumx
      return
      end


c ========================================================================
c this subroutine moves particles into appropriate spatial regions
c nbmax =  size of buffers for passing particles between processors
c ntmax =  size of hole array for particles leaving processors
c ierr = (0,1) = (no,yes) error condition exists

c ========================================================================
      subroutine pmove2 (part,edges,npp,sbufr,sbufl,rbufr,rbufl,ihole,js
     1r,jsl,jss,ny,kstrt,nvp,idimp,npmax,nblok,idps,nbmax,ntmax,ierr)
      character*8 jbname
      common /pparms/ nproc, nprec, lgrp, jbname
      external i_vadd
      dimension part(idimp,npmax,nblok)
      dimension edges(idps,nblok), npp(nblok)
      dimension sbufl(idimp,nbmax,nblok), sbufr(idimp,nbmax,nblok)
      dimension rbufl(idimp,nbmax,nblok), rbufr(idimp,nbmax,nblok)
      dimension jsl(idps,nblok), jsr(idps,nblok), jss(idps,nblok)
      dimension ihole(ntmax,nblok)
      any = float(ny)
      ks = kstrt - 2
      iter = 4
c debugging section: count total number of particles before move
      npr = 0
      do 5 l = 1, nblok
        npr = npr + npp(l)
    5 continue
c --------------------------
c buffer outgoing particles
c --------------------------
   10 continue
      do 30 l = 1, nblok
        kb = l + ks
        jsl(1,l) = 0
        jsr(1,l) = 0
        jss(2,l) = 0
        do 20 j = 1, npp(l)
          yt = part(2,j,l)
c --------------------
c particles going up
c --------------------
          if (yt.ge.edges(2,l)) then
            if (jsr(1,l).lt.nbmax) then
              jsr(1,l) = jsr(1,l) + 1
              if ((kb+1).eq.nvp) yt = yt - any
              sbufr(1,jsr(1,l),l) = part(1,j,l)
              sbufr(2,jsr(1,l),l) = yt
              sbufr(3,jsr(1,l),l) = part(3,j,l)
              sbufr(4,jsr(1,l),l) = part(4,j,l)
              ihole(jsl(1,l)+jsr(1,l),l) = j
            else
            jss(2,l) = 1
          endif
c ---------------------
c particles going down
c ---------------------
          elseif (yt.lt.edges(1,l)) then
            if (jsl(1,l).lt.nbmax) then
              jsl(1,l) = jsl(1,l) + 1
              if (kb.eq.0) yt = yt + any
              sbufl(1,jsl(1,l),l) = part(1,j,l)
              sbufl(2,jsl(1,l),l) = yt
              sbufl(3,jsl(1,l),l) = part(3,j,l)
              sbufl(4,jsl(1,l),l) = part(4,j,l)
              ihole(jsl(1,l)+jsr(1,l),l) = j
            else
              jss(2,l) = 1
            endif
          endif
   20   continue
        jss(1,l) = jsl(1,l) + jsr(1,l)
   30 continue
c ---------------------------------
c check for full buffer condition
c ---------------------------------
      ibflg = 0
      do 40 l = 1, nblok
        ibflg = ibflg + jss(2,l)
   40 continue
c -----------------------
c copy particle buffers
c -----------------------
   50 continue
      iter = iter + 4
      do 80 l = 1, nblok
c --------------------------
c get particles from below
c --------------------------
c this segment is used for shared memory computers
        kl = l + ks
        if (kl.lt.1) then
          jsl(2,l) = jsr(1,kl+nvp)
        else
          jsl(2,l) = jsr(1,kl)
        endif
c this loop is used for shared memory computers
        do 60 j = 1, jsl(2,l)
          if (kl.lt.1) then
            rbufl(1,j,l) = sbufr(1,j,kl+nvp)
            rbufl(2,j,l) = sbufr(2,j,kl+nvp)
            rbufl(3,j,l) = sbufr(3,j,kl+nvp)
            rbufl(4,j,l) = sbufr(4,j,kl+nvp)
          else
            rbufl(1,j,l) = sbufr(1,j,kl)
            rbufl(2,j,l) = sbufr(2,j,kl)
            rbufl(3,j,l) = sbufr(3,j,kl)
            rbufl(4,j,l) = sbufr(4,j,kl)
          endif
   60   continue
c ---------------------------
c get particles from above
c ---------------------------
        kr = l + ks + 2
        if (kr.gt.nvp) then
          jsr(2,l) = jsl(1,kr-nvp)
        else
          jsr(2,l) = jsl(1,kr)
        endif

        do 70 j = 1, jsr(2,l)
          if (kr.gt.nvp) then
            rbufr(1,j,l) = sbufl(1,j,kr-nvp)
            rbufr(2,j,l) = sbufl(2,j,kr-nvp)
            rbufr(3,j,l) = sbufl(3,j,kr-nvp)
            rbufr(4,j,l) = sbufl(4,j,kr-nvp)
          else
            rbufr(1,j,l) = sbufl(1,j,kr)
            rbufr(2,j,l) = sbufl(2,j,kr)
            rbufr(3,j,l) = sbufl(3,j,kr)
            rbufr(4,j,l) = sbufl(4,j,kr)
          endif
   70   continue
   80 continue
c ------------------------------------------
c check if particles must be passed further
c ------------------------------------------
      nps = 0
      do 110 l = 1, nblok
c --------------------------------------------------------------
c check if any particles coming from above must go further down
c --------------------------------------------------------------
        jsl(1,l) = 0
        do 90 j = 1, jsr(2,l)
          if (rbufr(2,j,l).lt.edges(1,l)) jsl(1,l) = 1
   90   continue
c ------------------------------------------------------------
c check if any particles coming from below must go further up
c ------------------------------------------------------------
        jsr(1,l) = 0
        do 100 j = 1, jsl(2,l)
          if (rbufl(2,j,l).ge.edges(2,l)) jsr(1,l) = 1
  100   continue
        nps = nps + (jsl(1,l) + jsr(1,l))
  110 continue
      if (nps.eq.0) go to 150
c -------------------------------------------
c remove particles which do not belong here
c -------------------------------------------
      do 140 l = 1, nblok
        kb = l + ks
c -----------------------------------------
c first check particles coming from above
c -----------------------------------------
        jsl(1,l) = 0
        jss(2,l) = 0
        do 120 j = 1, jsr(2,l)
          yt = rbufr(2,j,l)
c ----------------------
c particles going down
c ----------------------
          if (yt.lt.edges(1,l)) then
            jsl(1,l) = jsl(1,l) + 1
            if (kb.eq.0) yt = yt + any
            sbufl(1,jsl(1,l),l) = rbufr(1,j,l)
            sbufl(2,jsl(1,l),l) = yt
            sbufl(3,jsl(1,l),l) = rbufr(3,j,l)
            sbufl(4,jsl(1,l),l) = rbufr(4,j,l)
c ----------------------
c particles staying here
c ----------------------
          else
            jss(2,l) = jss(2,l) + 1
            rbufr(1,jss(2,l),l) = rbufr(1,j,l)
            rbufr(2,jss(2,l),l) = yt
            rbufr(3,jss(2,l),l) = rbufr(3,j,l)
            rbufr(4,jss(2,l),l) = rbufr(4,j,l)
          endif
  120   continue
        jsr(2,l) = jss(2,l)
c ---------------------------------------
c next check particles coming from below
c ---------------------------------------
        jsr(1,l) = 0
        jss(2,l) = 0
        do 130 j = 1, jsl(2,l)
          yt = rbufl(2,j,l)
c -------------------
c particles going up
c -------------------
          if (yt.ge.edges(2,l)) then
            jsr(1,l) = jsr(1,l) + 1
            if ((kb+1).eq.nvp) yt = yt - any
            sbufr(1,jsr(1,l),l) = rbufl(1,j,l)
            sbufr(2,jsr(1,l),l) = yt
            sbufr(3,jsr(1,l),l) = rbufl(3,j,l)
            sbufr(4,jsr(1,l),l) = rbufl(4,j,l)
c ------------------------
c particles staying here
c ------------------------
          else
            jss(2,l) = jss(2,l) + 1
            rbufl(1,jss(2,l),l) = rbufl(1,j,l)
            rbufl(2,jss(2,l),l) = yt
            rbufl(3,jss(2,l),l) = rbufl(3,j,l)
            rbufl(4,jss(2,l),l) = rbufl(4,j,l)
          endif
  130   continue
        jsl(2,l) = jss(2,l)
  140 continue
c ---------------------------------------------
c check if move would overflow particle array
c ---------------------------------------------
  150 ierr = 0
      do 160 l = 1, nblok
        if ((npp(l)+jsl(2,l)+jsr(2,l)-jss(1,l)).gt.npmax) then
           jss(2,l) = 1
        else
           jss(2,l) = 0
        endif
        ierr = ierr + jss(2,l)
  160 continue
      if (ierr.gt.0) then
         write (6,*) 'particle overflow error, ierr =', ierr
         return
      endif
      do 200 l = 1, nblok
c ---------------------------------------------------
c distribute incoming particles from buffers
c distribute particles coming from below into holes
c ---------------------------------------------------
        jss(2,l) = min0(jss(1,l),jsl(2,l))
        do 170 j = 1, jss(2,l)
          part(1,ihole(j,l),l) = rbufl(1,j,l)
          part(2,ihole(j,l),l) = rbufl(2,j,l)
          part(3,ihole(j,l),l) = rbufl(3,j,l)
          part(4,ihole(j,l),l) = rbufl(4,j,l)
  170   continue
        if (jss(1,l).gt.jsl(2,l)) then
          jss(2,l) = min0(jss(1,l)-jsl(2,l),jsr(2,l))
        else
          jss(2,l) = jsl(2,l) - jss(1,l)
        endif
        do 180 j = 1, jss(2,l)
c ----------------------------------------------------
c no more particles coming from below
c distribute particles coming from above into holes
c ----------------------------------------------------
          if (jss(1,l).gt.jsl(2,l)) then
            part(1,ihole(j+jsl(2,l),l),l) = rbufr(1,j,l)
            part(2,ihole(j+jsl(2,l),l),l) = rbufr(2,j,l)
            part(3,ihole(j+jsl(2,l),l),l) = rbufr(3,j,l)
            part(4,ihole(j+jsl(2,l),l),l) = rbufr(4,j,l)
          else
c ------------------------------------------------------
c no more holes
c distribute remaining particles from below into bottom
c ------------------------------------------------------
            part(1,j+npp(l),l) = rbufl(1,j+jss(1,l),l)
            part(2,j+npp(l),l) = rbufl(2,j+jss(1,l),l)
            part(3,j+npp(l),l) = rbufl(3,j+jss(1,l),l)
            part(4,j+npp(l),l) = rbufl(4,j+jss(1,l),l)
          endif
  180   continue
        if (jss(1,l).le.jsl(2,l)) then
          npp(l) = npp(l) + (jsl(2,l) - jss(1,l))
          jss(1,l) = jsl(2,l)
        endif
        jss(2,l) = jss(1,l) - (jsl(2,l) + jsr(2,l))
        if (jss(2,l).gt.0) then
          jss(1,l) = (jsl(2,l) + jsr(2,l))
          jsr(2,l) = jss(2,l)
        else
          jss(1,l) = jss(1,l) - jsl(2,l)
          jsr(2,l) = -jss(2,l)
        endif
        do 190 j = 1, jsr(2,l)
c ---------------------------------------------------------------------
c holes left over
c fill up remaining holes in particle array with particles from bottom
c ---------------------------------------------------------------------
          if (jss(2,l).gt.0) then
            j1 = npp(l) - j + 1
            j2 = jss(1,l) + jss(2,l) - j + 1
            if (j1.gt.ihole(j2,l)) then
c ------------------------------------------------
c move particle only if it is below current hole
c ------------------------------------------------
              part(1,ihole(j2,l),l) = part(1,j1,l)
              part(2,ihole(j2,l),l) = part(2,j1,l)
              part(3,ihole(j2,l),l) = part(3,j1,l)
              part(4,ihole(j2,l),l) = part(4,j1,l)
            endif
          else
c --------------------------------------------------------
c no more holes
c distribute remaining particles from above into bottom
c --------------------------------------------------------
            part(1,j+npp(l),l) = rbufr(1,j+jss(1,l),l)
            part(2,j+npp(l),l) = rbufr(2,j+jss(1,l),l)
            part(3,j+npp(l),l) = rbufr(3,j+jss(1,l),l)
            part(4,j+npp(l),l) = rbufr(4,j+jss(1,l),l)
          endif
  190   continue
        if (jss(2,l).gt.0) then
          npp(l) = npp(l) - jsr(2,l)
        else
          npp(l) = npp(l) + jsr(2,l)
        endif
        jss(1,l) = 0
  200 continue
c -------------------------------------------------
c check if any particles have to be passed further
c -------------------------------------------------
      if (nps.gt.0) go to 50
c -------------------------------------------------------------------
c check if buffer overflowed and more particles remain to be checked
c -------------------------------------------------------------------
      if (ibflg.gt.0) go to 10
c ---------------------------------------------------------------
c debugging section: count total number of particles after move
c ---------------------------------------------------------------
      nps = 0
      do 205 l = 1, nblok
      nps = nps + npp(l)
  205 continue
      if (npr.ne.nps) write (6,*) 'number error, np-old,np-new=',npr,nps
      return
      end

