C =======================================================================
c
c  This subroutine calculates initial particle co-ordinates
c  and velocities with uniform density and maxwellian velocity with drift.
c
C =======================================================================
      subroutine dist_particle3 (part,edges,npp,nps,vtx,vty,vtz,vdx,
     1 vdy,vdz,npx,npy,npz,nx,ny,nz,idimp,npmax,nblok,idps,sum0,sum1,
     1  sum2)
 
      double precision ranorm
      dimension part(idimp,npmax,nblok)
      dimension edges(idps,nblok), npp(nblok), nps(nblok)
      real sum0(nblok),sum1(nblok),sum2(nblok)

      integer myprocnum,p,offset
      include 'pglocal.f'
 
      
      
      myprocnum = pghpf_myprocnum()
      item_cnt = npz/nblok
            
      npxyz = npx*npy*npz
      at1 = float(nx)/float(npx)
      at2 = float(ny)/float(npy)
      at3 = float(nz)/float(npz)
     
      if (myprocnum .eq. nblok -1 ) then
      do 33 p = 0, nblok-1
      num_of_particle = 0
      offset = npp(1)
      do 44 ki = 1, item_cnt
      zt = at3*(float(ki+p*item_cnt) - .5)
      do 30 j = 1, npy
      yt = at2*(float(j) - .5)
      do 20 k = 1, npx
c ---------------------------------
c uniform density profile
c ---------------------------------
      xt = at1*(float(k) - .5)
c ---------------------------------
c maxwellian velocity distribution
c ---------------------------------
      vxt = vtx*ranorm(d)
      vyt = vty*ranorm(d)
      vzt = vtz*ranorm(d)
   
      num_of_particle = num_of_particle + 1 
      part(1,num_of_particle+offset,1) = xt
      part(2,num_of_particle+offset,1) = yt
      part(3,num_of_particle+offset,1) = zt
      part(4,num_of_particle+offset,1) = vxt
      part(5,num_of_particle+offset,1) = vyt
      part(6,num_of_particle+offset,1) = vzt
    
   20 continue
   30 continue
   44 continue

    
      if ( p .lt. nblok-1) then
         call pghpf_csend(p,num_of_particle,1,1,PGLCL_INT4)
         call pghpf_csend(p,part(1,offset+1,1),6*num_of_particle,
     *   1,PGLCL_REAL4)
      else
         npp(1) = npp(1) + num_of_particle
      endif
    

   33 continue  
      else
      
        call pghpf_crecv(nblok-1,num_of_particle,1,1,
     *         PGLCL_INT4)
        offset = npp(1)+1
        call pghpf_crecv(nblok-1,part(1,offset,1),6*num_of_particle,
     *     1, PGLCL_REAL4) 
        npp(1)= npp(1) + num_of_particle
     
      endif

      sum0(1) = 0.
      sum1(1) = 0.
      sum2(1) = 0.
      do j = nps(1), npp(1)
        sum0(1) = sum0(1) + part(4,j,1)
        sum1(1) = sum1(1) + part(5,j,1)
        sum2(1) = sum2(1) + part(6,j,1)
      enddo
      return
      end



C =========================================================================
C =========================================================================

      subroutine do_forall_1 (f,fc,nxv,nyv,nzpmx,nblok,nxvh,
     1 kzp,lblok,nxh,nyh)
  
      complex fc
      dimension f(nxv,nyv,nzpmx,nblok), fc(nxvh,nyv,kzp,lblok)
      include 'pglocal.f' 
c ---------------------------------------
c copy from field to particle partition
c ---------------------------------------

      l = 1
      do 130 k = 1, kzp
      do 120 j = 1, ny
      do 122 i = 1, nxh
      f(2*i-1,2*j-1,k+1,l) = real(fc(i,j,k,l))
      f(2*i,2*j,k+1,l)     = aimag(fc(i,j,k,l))
  122 continue 
  120 continue
  130 continue
      return
      end



C =========================================================================
C =========================================================================
 
      subroutine do_forall_2 (f,scr,nxv,nyv,nxvh,nyvh,nzpmx,nblok,
     1 kzp,lblok,nxh,ny,idps)
  
      complex scr
      dimension f(nxv,nyv,nzpmx,nblok), scr(nxvh,nyv,idps,nblok)
      include 'pglocal.f'

      l = 1
      do 50 j = 1, ny
      do 55 i = 1, nxh
      f(2*i-1,2*j-1,1,l) = real(scr(i,j,1,l))
      f(2*i,2*j,1,l) = aimag(scr(i,j,1,l))
   55 continue  
   50 continue
      return
      end

C =========================================================================
C =========================================================================

      subroutine do_forall_3 (f,scr,nxv,nyv,nxvh,nyvh,nzpmx,nblok,
     1 kzp,lblok,nxh,ny,idps)
  
      complex scr
      dimension f(nxv,nyv,nzpmx,nblok), scr(nxvh,nyv,idps,nblok)
      include 'pglocal.f'

      l = 1
      do 160 j = 1, ny
      do 166 i = 1, nxh
      f(2*i-1,2*j-1,kzp+2,l) = real (scr(i,j,1,l))
      f(2*i,2*j,kzp+2,l)     = aimag(scr(i,j,1,l))
      f(2*i-1,2*j-1,kzp+3,l) = real (scr(i,j,2,l))
      f(2*i,2*j,kzp+3,l)     = aimag(scr(i,j,2,l))
  166 continue
  160 continue
      
      return
      end


C ========================================================================
C ========================================================================

      subroutine extrinsic_ppois3(q,fx,fy,fz,isign,ffc,ax,ay,az,affp,
     1 wp,nx,ny,nz,kstrt,nyv,nzv,kxp,jblok,nyhd,nzhd,sum1,nblok) 

      complex q, fx, fy, fz,ffc, zero
      dimension q(nzv,nyv,kxp,jblok)
      dimension fx(nzv,nyv,kxp,jblok),fy(nzv,nyv,kxp,jblok)
      dimension fz(nzv,nyv,kxp,jblok)
      dimension ffc(nzhd,nyhd,kxp,jblok),sum1(nblok)
      integer myprocnum
      include 'pglocal.f'


      myprocnum = pghpf_myprocnum()
      sum1(1) = 0.0

      nxh = nx/2
      nyh = ny/2
      nzh = nz/2
      ny2 = ny + 2
      nz2 = nz + 2
      ks = kstrt - 2
      dnx = 6.28318530717959/float(nx)
      dny = 6.28318530717959/float(ny)
      dnz = 6.28318530717959/float(nz)
      zero = cmplx(0.,0.)
      if (isign.ne.0) go to 50
      if (kstrt.gt.nxh) return
c prepare form factor array
   
      m = 1
      joff = kxp*(myprocnum) - 1
      do 30 j = 1, kxp
      dkx = dnx*float(j + joff)
      at1 = dkx*dkx
      at2 = (dkx*ax)**2
      do 20 k = 1, nyh
      dky = dny*float(k - 1)
      at3 = dky*dky + at1
      at4 = (dky*ay)**2 + at2
      do 10 l = 1, nzh
      dkz = dnz*float(l - 1)
      at5 = dkz*dkz + at3
      at6 = exp(-.5*((dkz*az)**2 + at4))
      if (at5.eq.0.) then
         ffc(l,k,j,m) = cmplx(0.,1.)
      else
         ffc(l,k,j,m) = cmplx(affp*at6/at5,at6)
      endif
   10 continue
   20 continue
   30 continue
   
      return
c calculate force/charge and sum field energy
   50 wp = 0.
      if (kstrt.gt.nxh) go to 160

      m = 1
c mode numbers 0 < kx < nx/2, 0 < ky < ny/2, and 0 < kz < nz/2
      joff = kxp*(myprocnum) - 1
      do 100 j = 1, kxp
      dkx = dnx*float(j + joff)
      if ((j+joff).gt.0) then
         do 70 k = 2, nyh
         k1 = ny2 - k
         dky = dny*float(k - 1)
         do 60 l = 2, nzh
         l1 = nz2 - l
         at1 = real(ffc(l,k,j,m))*aimag(ffc(l,k,j,m))
         at2 = dkx*at1
         at3 = dky*at1
         at4 = dnz*float(l - 1)*at1
         fx(l,k,j,m) = at2*cmplx(aimag(q(l,k,j,m)),-real(q(l,k,j,m)))
         fx(l,k1,j,m) = at2*cmplx(aimag(q(l,k1,j,m)),-real(q(l,k1,j,m)))
         fx(l1,k,j,m) = at2*cmplx(aimag(q(l1,k,j,m)),-real(q(l1,k,j,m)))
         fx(l1,k1,j,m) = at2*cmplx(aimag(q(l1,k1,j,m)),-real(q(l1,k1,j,m
     1)))
         fy(l,k,j,m) = at3*cmplx(aimag(q(l,k,j,m)),-real(q(l,k,j,m)))
         fy(l,k1,j,m) = at3*cmplx(-aimag(q(l,k1,j,m)),real(q(l,k1,j,m)))
         fy(l1,k,j,m) = at3*cmplx(aimag(q(l1,k,j,m)),-real(q(l1,k,j,m)))
         fy(l1,k1,j,m) = at3*cmplx(-aimag(q(l1,k1,j,m)),real(q(l1,k1,j,m
     1)))
         fz(l,k,j,m) = at4*cmplx(aimag(q(l,k,j,m)),-real(q(l,k,j,m)))
         fz(l,k1,j,m) = at4*cmplx(aimag(q(l,k1,j,m)),-real(q(l,k1,j,m)))
         fz(l1,k,j,m) = at4*cmplx(-aimag(q(l1,k,j,m)),real(q(l1,k,j,m)))
         fz(l1,k1,j,m) = at4*cmplx(-aimag(q(l1,k1,j,m)),real(q(l1,k1,j,m
     1)))
         wp = wp + at1*(q(l,k,j,m)*conjg(q(l,k,j,m)) + q(l,k1,j,m)*conjg
     1(q(l,k1,j,m)) + q(l1,k,j,m)*conjg(q(l1,k,j,m)) + q(l1,k1,j,m)*conj
     2g(q(l1,k1,j,m)))
   60    continue
   70    continue

c mode numbers kz = 0, nz/2
         l1 = nzh + 1
         do 80 k = 2, nyh
         k1 = ny2 - k
         at1 = real(ffc(1,k,j,m))*aimag(ffc(1,k,j,m))
         at2 = dkx*at1
         at3 = dny*float(k - 1)*at1
         fx(1,k,j,m) = at2*cmplx(aimag(q(1,k,j,m)),-real(q(1,k,j,m)))
         fx(1,k1,j,m) = at2*cmplx(aimag(q(1,k1,j,m)),-real(q(1,k1,j,m)))
         fx(l1,k,j,m) = zero
         fx(l1,k1,j,m) = zero
         fy(1,k,j,m) = at3*cmplx(aimag(q(1,k,j,m)),-real(q(1,k,j,m)))
         fy(1,k1,j,m) = at3*cmplx(-aimag(q(1,k1,j,m)),real(q(1,k1,j,m)))
         fy(l1,k,j,m) = zero
         fy(l1,k1,j,m) = zero
         fz(1,k,j,m) = zero
         fz(1,k1,j,m) = zero
         fz(l1,k,j,m) = zero
         fz(l1,k1,j,m) = zero
         wp = wp + at1*(q(1,k,j,m)*conjg(q(1,k,j,m)) + q(1,k1,j,m)*conjg
     1(q(1,k1,j,m)))
   80    continue
c mode numbers ky = 0, ny/2
         k1 = nyh + 1
         do 90 l = 2, nzh
         l1 = nz2 - l
         at1 = real(ffc(l,1,j,m))*aimag(ffc(l,1,j,m))
         at2 = dkx*at1
         at4 = dnz*float(l - 1)*at1
         fx(l,1,j,m) = at2*cmplx(aimag(q(l,1,j,m)),-real(q(l,1,j,m)))
         fx(l,k1,j,m) = zero
         fx(l1,1,j,m) = at2*cmplx(aimag(q(l1,1,j,m)),-real(q(l1,1,j,m)))
         fx(l1,k1,j,m) = zero
         fy(l,1,j,m) = zero
         fy(l,k1,j,m) = zero
         fy(l1,1,j,m) = zero
         fy(l1,k1,j,m) = zero
         fz(l,1,j,m) = at4*cmplx(aimag(q(l,1,j,m)),-real(q(l,1,j,m)))
         fz(l,k1,j,m) = zero
         fz(l1,1,j,m) = at4*cmplx(-aimag(q(l1,1,j,m)),real(q(l1,1,j,m)))
         fz(l1,k1,j,m) = zero
         wp = wp + at1*(q(l,1,j,m)*conjg(q(l,1,j,m)) + q(l1,1,j,m)*conjg
     1(q(l1,1,j,m)))
   90    continue
      endif
c mode numbers kz = 0, nz/2
      k1 = nyh + 1
      l1 = nzh + 1
      at1 = real(ffc(1,1,j,m))*aimag(ffc(1,1,j,m))
      at2 = dkx*at1
      fx(1,1,j,m) = at2*cmplx(aimag(q(1,1,j,m)),-real(q(1,1,j,m)))
      fx(1,k1,j,m) = zero
      fx(l1,1,j,m) = zero
      fx(l1,k1,j,m) = zero
      fy(1,1,j,m) = zero
      fy(1,k1,j,m) = zero
      fy(l1,1,j,m) = zero
      fy(l1,k1,j,m) = zero
      fz(1,1,j,m) = zero
      fz(1,k1,j,m) = zero
      fz(l1,1,j,m) = zero
      fz(l1,k1,j,m) = zero
      wp = wp + at1*(q(1,1,j,m)*conjg(q(1,1,j,m)))
  100 continue
c mode numbers kx = 0, nx/2
      if ((myprocnum).eq.0) then
         do 120 k = 2, nyh
         k1 = ny2 - k
         dky = dny*float(k - 1)
         do 110 l = 2, nzh

         l1 = nz2 - l
         at1 = real(ffc(l,k,1,m))*aimag(ffc(l,k,1,m))
         at3 = dky*at1
         at4 = dnz*float(l - 1)*at1
         fx(l,k,1,m) = zero
         fx(l,k1,1,m) = zero
         fx(l1,k,1,m) = zero
         fx(l1,k1,1,m) = zero
         fy(l,k,1,m) = at3*cmplx(aimag(q(l,k,1,m)),-real(q(l,k,1,m)))
         fy(l,k1,1,m) = zero
         fy(l1,k,1,m) = at3*cmplx(aimag(q(l1,k,1,m)),-real(q(l1,k,1,m)))
         fy(l1,k1,1,m) = zero
         fz(l,k,1,m) = at4*cmplx(aimag(q(l,k,1,m)),-real(q(l,k,1,m)))
         fz(l,k1,1,m) = zero
         fz(l1,k,1,m) = at4*cmplx(-aimag(q(l1,k,1,m)),real(q(l1,k,1,m)))
         fz(l1,k1,1,m) = zero
         wp = wp + at1*(q(l,k,1,m)*conjg(q(l,k,1,m)) + q(l1,k,1,m)*conjg
     1(q(l1,k,1,m)))

  110    continue
  120    continue
c mode numbers kz = 0, nz/2
         l1 = nzh + 1
         do 130 k = 2, nyh
         k1 = ny2 - k
         at1 = real(ffc(1,k,1,m))*aimag(ffc(1,k,1,m))
         at3 = dny*float(k - 1)*at1
         fx(1,k,1,m) = zero
         fx(1,k1,1,m) = zero
         fx(l1,k,1,m) = zero
         fx(l1,k1,1,m) = zero
         fy(1,k,1,m) = at3*cmplx(aimag(q(1,k,1,m)),-real(q(1,k,1,m)))
         fy(1,k1,1,m) = zero
         fy(l1,k,1,m) = zero
         fy(l1,k1,1,m) = zero
         fz(1,k,1,m) = zero
         fz(1,k1,1,m) = zero
         fz(l1,k,1,m) = zero
         fz(l1,k1,1,m) = zero
         wp = wp + at1*(q(1,k,1,m)*conjg(q(1,k,1,m)))
  130    continue
c mode numbers ky = 0, ny/2
         k1 = nyh + 1
         do 140 l = 2, nzh
         l1 = nz2 - l
         at1 = real(ffc(l,1,1,m))*aimag(ffc(l,1,1,m))
         at4 = dnz*float(l - 1)*at1
         fx(l,1,1,m) = zero
         fx(l,k1,1,m) = zero
         fx(l1,1,1,m) = zero
         fx(l1,k1,1,m) = zero
         fy(l,1,1,m) = zero
         fy(l,k1,1,m) = zero
         fy(l1,1,1,m) = zero
         fy(l1,k1,1,m) = zero
         fz(l,1,1,m) = at4*cmplx(aimag(q(l,1,1,m)),-real(q(l,1,1,m)))
         fz(l,k1,1,m) = zero
         fz(l1,1,1,m) = zero
         fz(l1,k1,1,m) = zero
         wp = wp + at1*(q(l,1,1,m)*conjg(q(l,1,1,m)))
  140    continue
      endif

  160 continue

      return
      end


C =========================================================================
      subroutine extrinsic_ppush3 (part,fx,fy,fz,npp,noff,qtm,dt,ek,
     1 nx,ny,idimp, npmax,nblok,nxv,nyv,nzpmx,sum1)
                                         
      dimension part(idimp,npmax,nblok)
      dimension fx(nxv,nyv,nzpmx,nblok), fy(nxv,nyv,nzpmx,nblok)
      dimension fz(nxv,nyv,nzpmx,nblok)
      dimension npp(nblok), noff(nblok),sum1(nblok)
      include 'pglocal.f'


      zero = 0.
      anx = float(nx)
      any = float(ny)
      sum1(1) = 0.

      m = 1

      lnoff = noff(m) - 2
c find interpolation weights
      do 10 j = 1, npp(m)
      nn = part(1,j,m) + .5
      dx = part(1,j,m) - float(nn)
      nn = nn + 1
      if (nn.gt.nx) nn = nn - nx
      amx = .75 - dx*dx
      np = nn + 1
      if (np.gt.nx) np = np - nx
      dxp = .5*(.5 + dx)**2
      nl = nn - 1
      if (nl.lt.1) nl = nl + nx
      dxl = .5*(.5 - dx)**2
      mm = part(2,j,m) + .5
      dy = part(2,j,m) - float(mm)
      mm = mm + 1
      if (mm.gt.ny) mm = mm - ny
      amy = .75 - dy*dy
      mp = mm + 1
      if (mp.gt.ny) mp = mp - ny
      dyp = .5*(.5 + dy)**2
      ml = mm - 1
      if (ml.lt.1) ml = ml + ny
      dyl = .5*(.5 - dy)**2
      ll = part(3,j,m) + .5
      dz = part(3,j,m) - float(ll)
      ll = ll - lnoff
      amz = .75 - dz*dz
      lp = ll + 1
      dzp = .5*(.5 + dz)**2
      lm = ll - 1
      dzl = .5*(.5 - dz)**2
c find acceleration

      dx = amz*(amy*(amx*fx(nn,mm,ll,m) + dxp*fx(np,mm,ll,m) + dxl*fx(nl
     1,mm,ll,m)) + dyp*(amx*fx(nn,mp,ll,m) + dxp*fx(np,mp,ll,m) + dxl*fx
     2(nl,mp,ll,m)) + dyl*(amx*fx(nn,ml,ll,m) + dxp*fx(np,ml,ll,m) + dxl
     3*fx(nl,ml,ll,m))) + dzp*(amy*(amx*fx(nn,mm,lp,m) + dxp*fx(np,mm,lp
     4,m) + dxl*fx(nl,mm,lp,m)) + dyp*(amx*fx(nn,mp,lp,m) + dxp*fx(np,mp
     5,lp,m) + dxl*fx(nl,mp,lp,m)) + dyl*(amx*fx(nn,ml,lp,m) + dxp*fx(np
     6,ml,lp,m) + dxl*fx(nl,ml,lp,m))) + dzl*(amy*(amx*fx(nn,mm,lm,m) +
     7dxp*fx(np,mm,lm,m) + dxl*fx(nl,mm,lm,m)) + dyp*(amx*fx(nn,mp,lm,m)
     8 + dxp*fx(np,mp,lm,m) + dxl*fx(nl,mp,lm,m)) + dyl*(amx*fx(nn,ml,lm
     9,m) + dxp*fx(np,ml,lm,m) + dxl*fx(nl,ml,lm,m)))
      dy = amz*(amy*(amx*fy(nn,mm,ll,m) + dxp*fy(np,mm,ll,m) + dxl*fy(nl
     1,mm,ll,m)) + dyp*(amx*fy(nn,mp,ll,m) + dxp*fy(np,mp,ll,m) + dxl*fy
     2(nl,mp,ll,m)) + dyl*(amx*fy(nn,ml,ll,m) + dxp*fy(np,ml,ll,m) + dxl
     3*fy(nl,ml,ll,m))) + dzp*(amy*(amx*fy(nn,mm,lp,m) + dxp*fy(np,mm,lp
     4,m) + dxl*fy(nl,mm,lp,m)) + dyp*(amx*fy(nn,mp,lp,m) + dxp*fy(np,mp
     5,lp,m) + dxl*fy(nl,mp,lp,m)) + dyl*(amx*fy(nn,ml,lp,m) + dxp*fy(np
     6,ml,lp,m) + dxl*fy(nl,ml,lp,m))) + dzl*(amy*(amx*fy(nn,mm,lm,m) +
     7dxp*fy(np,mm,lm,m) + dxl*fy(nl,mm,lm,m)) + dyp*(amx*fy(nn,mp,lm,m)
     8 + dxp*fy(np,mp,lm,m) + dxl*fy(nl,mp,lm,m)) + dyl*(amx*fy(nn,ml,lm
     9,m) + dxp*fy(np,ml,lm,m) + dxl*fy(nl,ml,lm,m)))
      dz = amz*(amy*(amx*fz(nn,mm,ll,m) + dxp*fz(np,mm,ll,m) + dxl*fz(nl
     1,mm,ll,m)) + dyp*(amx*fz(nn,mp,ll,m) + dxp*fz(np,mp,ll,m) + dxl*fz
     2(nl,mp,ll,m)) + dyl*(amx*fz(nn,ml,ll,m) + dxp*fz(np,ml,ll,m) + dxl
     3*fz(nl,ml,ll,m))) + dzp*(amy*(amx*fz(nn,mm,lp,m) + dxp*fz(np,mm,lp
     4,m) + dxl*fz(nl,mm,lp,m)) + dyp*(amx*fz(nn,mp,lp,m) + dxp*fz(np,mp
     5,lp,m) + dxl*fz(nl,mp,lp,m)) + dyl*(amx*fz(nn,ml,lp,m) + dxp*fz(np
     6,ml,lp,m) + dxl*fz(nl,ml,lp,m))) + dzl*(amy*(amx*fz(nn,mm,lm,m) +
     7dxp*fz(np,mm,lm,m) + dxl*fz(nl,mm,lm,m)) + dyp*(amx*fz(nn,mp,lm,m)
     8 + dxp*fz(np,mp,lm,m) + dxl*fz(nl,mp,lm,m)) + dyl*(amx*fz(nn,ml,lm
     9,m) + dxp*fz(np,ml,lm,m) + dxl*fz(nl,ml,lm,m)))
c new velocity
      dx = part(4,j,m) + qtm*dx
      dy = part(5,j,m) + qtm*dy
      dz = part(6,j,m) + qtm*dz
c average kinetic energy
      sum1(1) = sum1(1) + (dx + part(4,j,m))**2 + (dy + part(5,j,m))**2  
     1 + (dz+ part(6,j,m))**2
     
      part(4,j,m) = dx
      part(5,j,m) = dy
      part(6,j,m) = dz
c new position
      dx = part(1,j,m) + dx*dt
      dy = part(2,j,m) + dy*dt
      dz = part(3,j,m) + dz*dt
c periodic boundary conditions
      if (dx.lt.zero) dx = dx + anx
      if (dx.ge.anx) dx = dx - anx
      part(1,j,m) = dx
      if (dy.lt.zero) dy = dy + any
      if (dy.ge.any) dy = dy - any
      part(2,j,m) = dy
      part(3,j,m) = dz
   10 continue

c normalize kinetic energy
      return
      end
 

C ========================================================================
C ========================================================================

      
      subroutine extrinsic1_pmove3 (part,edges,npp,sbufr,sbufl,
     1 ihole,jsr,jsl,jss,nz,kstrt,nvp,idimp,npmax,nblok,idps,nbmax,
     1 ntmax,ierr)

      dimension part(idimp,npmax,nblok)
      dimension edges(idps,nblok), npp(nblok)
      dimension sbufl(idimp,nbmax,nblok), sbufr(idimp,nbmax,nblok)
      dimension jsl(idps,nblok), jsr(idps,nblok), jss(idps,nblok)
      dimension ihole(ntmax,nblok)
      integer myprocnum
      include 'pglocal.f'

      anz = float(nz)
      ks = kstrt - 2
      iter = 4

c --------------------------
c buffer outgoing particles
c --------------------------
      myprocnum  = pghpf_myprocnum()
      l = 1
      
      kb = myprocnum+ 1 + ks
      jsl(1,l) = 0
      jsr(1,l) = 0
      jss(2,l) = 0
      do 20 j = 1, npp(l)
      zt = part(3,j,l)
c --------------------
c particles going up
c --------------------
      if (zt.ge.edges(2,l)) then
         if (jsr(1,l).lt.nbmax) then
            jsr(1,l) = jsr(1,l) + 1
            if ((kb+1).eq.nvp) zt = zt - anz
            sbufr(1,jsr(1,l),l) = part(1,j,l)
            sbufr(2,jsr(1,l),l) = part(2,j,l)
            sbufr(3,jsr(1,l),l) = zt
            
            sbufr(4,jsr(1,l),l) = part(4,j,l)
            sbufr(5,jsr(1,l),l) = part(5,j,l)
            sbufr(6,jsr(1,l),l) = part(6,j,l)

            ihole(jsl(1,l)+jsr(1,l),l) = j
         else
            jss(2,l) = 1
         endif
c ---------------------
c particles going down
c ---------------------
      elseif (zt.lt.edges(1,l)) then
         if (jsl(1,l).lt.nbmax) then
            jsl(1,l) = jsl(1,l) + 1
            if (kb.eq.0) zt = zt + anz
            sbufl(1,jsl(1,l),l) = part(1,j,l)
            sbufr(2,jsl(1,l),l) = part(2,j,l)
            sbufl(3,jsl(1,l),l) = zt

            sbufr(4,jsl(1,l),l) = part(4,j,l)
            sbufr(5,jsl(1,l),l) = part(5,j,l)
            sbufr(6,jsl(1,l),l) = part(6,j,l)

            ihole(jsl(1,l)+jsr(1,l),l) = j
         else
            jss(2,l) = 1
         endif
      endif
   20 continue
      jss(1,l) = jsl(1,l) + jsr(1,l)

      return
      end

C ========================================================================
C ========================================================================

       subroutine extrinsic2_pmove3 (edges,sbufr,sbufl,rbufr,rbufl,
     1   jsr,jsl,jss,nz,kstrt,nvp,idimp,npmax,nblok,idps,nbmax,ntmax,
     1   ierr,sum1)

      dimension edges(idps,nblok),sum1(nblok)
      dimension sbufl(idimp,nbmax,nblok), sbufr(idimp,nbmax,nblok)
      dimension rbufl(idimp,nbmax,nblok), rbufr(idimp,nbmax,nblok)
      dimension jsl(idps,nblok), jsr(idps,nblok), jss(idps,nblok)

      integer myprocnum
      include 'pglocal.f'

      anz = float(nz)
      ks = kstrt - 2
      iter = 4 
 
      myprocnum  = pghpf_myprocnum()
      l = 1

c ------------------------------------------
c check if particles must be passed further
c ------------------------------------------
      nps = 0

c --------------------------------------------------------------
c check if any particles coming from above must go further down
c --------------------------------------------------------------
      jsl(1,l) = 0
      do 90 j = 1, jsr(2,l)
      if (rbufr(2,j,l).lt.edges(1,l)) jsl(1,l) = 1
   90 continue
c ------------------------------------------------------------
c check if any particles coming from below must go further up
c ------------------------------------------------------------
      jsr(1,l) = 0
      do 100 j = 1, jsl(2,l)
      if (rbufl(2,j,l).ge.edges(2,l)) jsr(1,l) = 1
  100 continue
      nps = nps + (jsl(1,l) + jsr(1,l))
     
      sum1(1) = nps

      return
      end

C ========================================================================
C ========================================================================   

      subroutine extrinsic3_pmove3 (edges,npp,sbufr,sbufl,rbufr,rbufl,
     1 jsr,jsl,jss,nz,kstrt,nvp,idimp,npmax,nblok,idps,nbmax,ntmax,ierr)

      dimension edges(idps,nblok), npp(nblok)
      dimension sbufl(idimp,nbmax,nblok), sbufr(idimp,nbmax,nblok)
      dimension rbufl(idimp,nbmax,nblok), rbufr(idimp,nbmax,nblok)
      dimension jsl(idps,nblok), jsr(idps,nblok), jss(idps,nblok)

      integer myprocnum
      include 'pglocal.f' 

      anz = float(nz)
      ks = kstrt - 2
      iter = 4
      myprocnum = pghpf_myprocnum()

c -------------------------------------------
c remove particles which do not belong here
c -------------------------------------------
      l = 1

      kb = myprocnum+1 + ks
c -----------------------------------------
c first check particles coming from above
c -----------------------------------------
      jsl(1,l) = 0
      jss(2,l) = 0
      do 120 j = 1, jsr(2,l)
      zt = rbufr(3,j,l)
c ----------------------
c particles going down
c ----------------------
      if (zt.lt.edges(1,l)) then
         jsl(1,l) = jsl(1,l) + 1
         if (kb.eq.0) zt = zt + anz
         sbufl(1,jsl(1,l),l) = rbufr(1,j,l)
         sbufl(2,jsl(1,l),l) = rbufr(2,j,l)
         sbufl(3,jsl(1,l),l) = zt

         sbufl(4,jsl(1,l),l) = rbufr(4,j,l)
         sbufl(5,jsl(1,l),l) = rbufr(5,j,l)
         sbufl(6,jsl(1,l),l) = rbufr(6,j,l)
c ----------------------
c particles staying here
c ----------------------
      else
         jss(2,l) = jss(2,l) + 1
         rbufr(1,jss(2,l),l) = rbufr(1,j,l) 
         rbufr(2,jss(2,l),l) = rbufr(2,j,l) 
         rbufr(3,jss(2,l),l) = zt

         rbufr(4,jss(2,l),l) = rbufr(4,j,l)
         rbufr(5,jss(2,l),l) = rbufr(5,j,l)
         rbufr(6,jss(2,l),l) = rbufr(6,j,l)
      endif
  120 continue
      jsr(2,l) = jss(2,l)
c ---------------------------------------
c next check particles coming from below
c ---------------------------------------
      jsr(1,l) = 0
      jss(2,l) = 0
      do 130 j = 1, jsl(2,l)
      zt = rbufl(3,j,l)
c -------------------
c particles going up
c -------------------
      if (zt.ge.edges(2,l)) then
         jsr(1,l) = jsr(1,l) + 1
         if ((kb+1).eq.nvp) zt = zt - anz
         sbufr(1,jsr(1,l),l) = rbufl(1,j,l)
         sbufr(2,jsr(1,l),l) = rbufl(2,j,l)
         sbufr(3,jsr(1,l),l) = zt

         sbufr(4,jsr(1,l),l) = rbufl(4,j,l)
         sbufr(5,jsr(1,l),l) = rbufl(5,j,l)
         sbufr(6,jsr(1,l),l) = rbufl(6,j,l)
c ------------------------
c particles staying here
c ------------------------
      else
         jss(2,l) = jss(2,l) + 1
         rbufl(1,jss(2,l),l) = rbufl(1,j,l)
         rbufl(2,jss(2,l),l) = rbufl(2,j,l)
         rbufl(3,jss(2,l),l) = zt
       
         rbufl(4,jss(2,l),l) = rbufl(4,j,l)
         rbufl(5,jss(2,l),l) = rbufl(5,j,l)
         rbufl(6,jss(2,l),l) = rbufl(6,j,l)
      endif
  130 continue
      jsl(2,l) = jss(2,l)

      return
      end

C ========================================================================
C ========================================================================

       subroutine extrinsic4_pmove3 (npp,jsr,jsl,jss,nz,kstrt,nvp,
     1  idimp,npmax,nblok,idps,nbmax,ntmax,ierr,sum1)

       dimension npp(nblok),sum1(nblok)
       dimension jsl(idps,nblok), jsr(idps,nblok), jss(idps,nblok)

c ---------------------------------------------
c check if move would overflow particle array
c ---------------------------------------------
      ierr = 0

      l = 1
      if ((npp(l)+jsl(2,l)+jsr(2,l)-jss(1,l)).gt.npmax) then
         jss(2,l) = 1
      else
         jss(2,l) = 0
      endif
      ierr = ierr + jss(2,l)
      sum1(1) = ierr

      return
      end

C ========================================================================
C ========================================================================
   
      subroutine extrinsic5_pmove3 (part,edges,npp,rbufr,rbufl,ihole,
     1 jsr,jsl,jss,nz,kstrt,nvp,idimp,npmax,nblok,idps,nbmax,ntmax,ierr)
      dimension part(idimp,npmax,nblok)
      dimension edges(idps,nblok), npp(nblok)
      dimension rbufl(idimp,nbmax,nblok), rbufr(idimp,nbmax,nblok)
      dimension jsl(idps,nblok), jsr(idps,nblok), jss(idps,nblok)
      dimension ihole(ntmax,nblok)
      include 'pglocal.f'

      anz = float(nz)
      ks = kstrt - 2

      l = 1 

c ---------------------------------------------------
c distribute incoming particles from buffers
c ---------------------------------------------------
      jss(2,l) = min0(jss(1,l),jsl(2,l))
      do 170 j = 1, jss(2,l)
      part(1,ihole(j,l),l) = rbufl(1,j,l)
      part(2,ihole(j,l),l) = rbufl(2,j,l)
      part(3,ihole(j,l),l) = rbufl(3,j,l)
      part(4,ihole(j,l),l) = rbufl(4,j,l)
      part(5,ihole(j,l),l) = rbufl(5,j,l)
      part(6,ihole(j,l),l) = rbufl(6,j,l)

  170 continue
      if (jss(1,l).gt.jsl(2,l)) then
         jss(2,l) = min0(jss(1,l)-jsl(2,l),jsr(2,l))
      else
         jss(2,l) = jsl(2,l) - jss(1,l)
      endif
      do 180 j = 1, jss(2,l)
      if (jss(1,l).gt.jsl(2,l)) then
         part(1,ihole(j+jsl(2,l),l),l) = rbufr(1,j,l)
         part(2,ihole(j+jsl(2,l),l),l) = rbufr(2,j,l)
         part(3,ihole(j+jsl(2,l),l),l) = rbufr(3,j,l)
         part(4,ihole(j+jsl(2,l),l),l) = rbufr(4,j,l)
         part(5,ihole(j+jsl(2,l),l),l) = rbufr(5,j,l)
         part(6,ihole(j+jsl(2,l),l),l) = rbufr(6,j,l)

      else
c ------------------------------------------------------
c no more holes
c distribute remaining particles from below into bottom
c ------------------------------------------------------
         part(1,j+npp(l),l) = rbufl(1,j+jss(1,l),l)
         part(2,j+npp(l),l) = rbufl(2,j+jss(1,l),l)
         part(3,j+npp(l),l) = rbufl(3,j+jss(1,l),l)
         part(4,j+npp(l),l) = rbufl(4,j+jss(1,l),l)
         part(5,j+npp(l),l) = rbufl(5,j+jss(1,l),l)
         part(6,j+npp(l),l) = rbufl(6,j+jss(1,l),l)

      endif
  180 continue
      if (jss(1,l).le.jsl(2,l)) then
         npp(l) = npp(l) + (jsl(2,l) - jss(1,l))
         jss(1,l) = jsl(2,l)
      endif
      jss(2,l) = jss(1,l) - (jsl(2,l) + jsr(2,l))
      if (jss(2,l).gt.0) then
         jss(1,l) = (jsl(2,l) + jsr(2,l))
         jsr(2,l) = jss(2,l)
      else
         jss(1,l) = jss(1,l) - jsl(2,l)
         jsr(2,l) = -jss(2,l)
      endif
      do 190 j = 1, jsr(2,l)
c ---------------------------------------------------------------------
c holes left over
c fill up remaining holes in particle array with particles from bottom
c ---------------------------------------------------------------------
      if (jss(2,l).gt.0) then
         j1 = npp(l) - j + 1
         j2 = jss(1,l) + jss(2,l) - j + 1
         if (j1.gt.ihole(j2,l)) then
c ------------------------------------------------
c move particle only if it is below current hole
c ------------------------------------------------
            part(1,ihole(j2,l),l) = part(1,j1,l)
            part(2,ihole(j2,l),l) = part(2,j1,l)
            part(3,ihole(j2,l),l) = part(3,j1,l)
            part(4,ihole(j2,l),l) = part(4,j1,l)
            part(5,ihole(j2,l),l) = part(5,j1,l)
            part(6,ihole(j2,l),l) = part(6,j1,l)

         endif
      else
c --------------------------------------------------------
c no more holes
c distribute remaining particles from above into bottom
c --------------------------------------------------------
         part(1,j+npp(l),l) = rbufr(1,j+jss(1,l),l)
         part(2,j+npp(l),l) = rbufr(2,j+jss(1,l),l)
         part(3,j+npp(l),l) = rbufr(3,j+jss(1,l),l)
         part(4,j+npp(l),l) = rbufr(4,j+jss(1,l),l)
         part(5,j+npp(l),l) = rbufr(5,j+jss(1,l),l)
         part(6,j+npp(l),l) = rbufr(6,j+jss(1,l),l)

      endif
  190 continue
      if (jss(2,l).gt.0) then
         npp(l) = npp(l) - jsr(2,l)
      else
         npp(l) = npp(l) + jsr(2,l)
      endif
      jss(1,l) = 0

      return
      end


      subroutine pfft3r(f,g,bs,br,isign,ntpose,mixup,sct,indx,indy,indz,
     1 kstrt,nxv,nyv,nzv,kxp,kzp,jblok,lblok,nyd,nxhyzd,nxyzhd)
c this subroutine performs a three dimensional real to complex fast
c fourier transform and its inverse, using complex arithmetic,
c for data which is distributed in blocks

      complex f, g, bs, br, sct, s, t, t1
      dimension f(nxv,nyv,kzp,lblok), g(nzv,nyv,kxp,jblok)
      dimension bs(kxp,nyd,kzp,lblok), br(kxp,nyd,kzp,jblok)
      dimension mixup(nxhyzd), sct(nxyzhd)
      integer myprocnum
      include 'pglocal.f'

      myprocnum = pghpf_myprocnum()

      indx1 = indx - 1
      ndx1yz = max0(indx1,indy,indz)
      nx = 2**indx
      nxh = nx/2
      nxhh = nx/4
      nxh2 = nxh + 2
      ny = 2**indy
      nyh = ny/2
      ny2 = ny + 2
      nz = 2**indz
      nzh = nz/2
      nz2 = nz + 2
      nxyz = max0(nx,ny,nz)
      nxhyz = 2**ndx1yz
      ks = kstrt - 2

      if (isign) 50, 10, 460
c prepare fft tables
c bit-reverse index table: mixup(j) = 1 + reversed bits of (j - 1)
   10 do 30 j = 1, nxhyz
      lb = j - 1
      ll = 0
      do 20 k = 1, ndx1yz
      jb = lb/2
      it = lb - 2*jb
      lb = jb
      ll = 2*ll + it
   20 continue
      mixup(j) = ll + 1
   30 continue
c sine/cosine table for the angles 2*n*pi/nxyz
      nxyzh = nxyz/2
      dnxyz = 6.28318530717959/float(nxyz)
      do 40 j = 1, nxyzh
      arg = dnxyz*float(j - 1)
      sct(j) = cmplx(cos(arg),-sin(arg))
   40 continue
      return

c inverse fourier transform

   50 if (kstrt.gt.nz) go to 320
      nrx = nxhyz/nxh
c     do 90 m = 1, lblok

      m = 1
c bit-reverse array elements in x
      do 80 n = 1, kzp
      do 70 j = 1, nxh
      j1 = (mixup(j) - 1)/nrx + 1
      if (j.ge.j1) go to 70
      do 60 i = 1, ny
      t = f(j1,i,n,m)
      f(j1,i,n,m) = f(j,i,n,m)
      f(j,i,n,m) = t
   60 continue
   70 continue
   80 continue
c  90 continue

c first transform in x
      nrx = nxyz/nxh
      do 150 l = 1, indx1
      ns = 2**(l - 1)
      ns2 = ns + ns
      km = nxhh/ns
      kmr = km*nrx
c     do 140 m = 1, lblok

      m = 1
      do 130 n = 1, kzp
      do 120 k = 1, km
      k1 = ns2*(k - 1)
      k2 = k1 + ns
      do 110 j = 1, ns
      j1 = j + k1
      j2 = j + k2
      s = sct(1+kmr*(j-1))
      do 100 i = 1, ny
      t = s*f(j2,i,n,m)
      f(j2,i,n,m) = f(j1,i,n,m) - t
      f(j1,i,n,m) = f(j1,i,n,m) + t
  100 continue
  110 continue
  120 continue
  130 continue
c 140 continue
  150 continue

c unscramble coefficients and normalize
      kmr = nxyz/nx
      ani = 1./float(2*nx*ny*nz)
      nry = nxhyz/ny
c     do 220 m = 1, lblok

      m = 1
      do 210 n = 1, kzp
      do 170 j = 2, nxhh
      t1 = cmplx(aimag(sct(1+kmr*(j-1))),-real(sct(1+kmr*(j-1))))
      do 160 k = 1, ny
      t = conjg(f(nxh2-j,k,n,m))
      s = f(j,k,n,m) + t
      t = (f(j,k,n,m) - t)*t1
      f(j,k,n,m) = ani*(s + t)
      f(nxh2-j,k,n,m) = ani*conjg(s - t)
  160 continue
  170 continue
      do 180 k = 1, ny
      f(nxhh+1,k,n,m) = 2.*ani*conjg(f(nxhh+1,k,n,m))
      f(1,k,n,m) = 2.*ani*cmplx(real(f(1,k,n,m)) + aimag(f(1,k,n,m)),rea
     1l(f(1,k,n,m)) - aimag(f(1,k,n,m)))
  180 continue
c bit-reverse array elements in y
      do 200 k = 1, ny
      k1 = (mixup(k) - 1)/nry + 1
      if (k.ge.k1) go to 200
      do 190 i = 1, nxh
      t = f(i,k1,n,m)
      f(i,k1,n,m) = f(i,k,n,m)
      f(i,k,n,m) = t
  190 continue
  200 continue
  210 continue
c 220 continue
c then transform in y

      nry = nxyz/ny
      do 280 l = 1, indy
      ns = 2**(l - 1)
      ns2 = ns + ns
      km = nyh/ns
      kmr = km*nry
c     do 270 m = 1, lblok

      m = 1
      do 260 n = 1, kzp
      do 250 k = 1, km
      k1 = ns2*(k - 1)
      k2 = k1 + ns
      do 240 j = 1, ns
      j1 = j + k1
      j2 = j + k2
      s = sct(1+kmr*(j-1))
      do 230 i = 1, nxh
      t = s*f(i,j2,n,m)
      f(i,j2,n,m) = f(i,j1,n,m) - t
      f(i,j1,n,m) = f(i,j1,n,m) + t
  230 continue
  240 continue
  250 continue
  260 continue
c 270 continue
  280 continue

c unscramble modes kx = 0, nx/2
c     do 310 m = 1, lblok

      m = 1
      do 300 n = 1, kzp
      do 290 k = 2, nyh
      s = f(1,ny2-k,n,m)
      f(1,ny2-k,n,m) = .5*cmplx(aimag(f(1,k,n,m) + s),real(f(1,k,n,m) -
     1s))
      f(1,k,n,m) = .5*cmplx(real(f(1,k,n,m) + s),aimag(f(1,k,n,m) - s))
  290 continue
  300 continue
c 310 continue
c transpose f array to g
      print *,myprocnum,'before ptpose'
       
  320 call ptpos2(f,g,bs,br,nxh,ny,nz,kstrt,nxv,nyv,nzv,kxp,kzp,jblok,
     1 lblok,myprocnum)
      
      if (kstrt.gt.nxh) go to 450
      nrz = nxhyz/nz
c     do 360 m = 1, jblok

      m = 1
c bit-reverse array elements in z
      do 350 l = 1, nz
      l1 = (mixup(l) - 1)/nrz + 1
      if (l.ge.l1) go to 350
      do 340 i = 1, kxp
      do 330 n = 1, ny
c     if (l.lt.l1) then
      t = g(l1,n,i,m)
      g(l1,n,i,m) = g(l,n,i,m)
      g(l,n,i,m) = t
c     endif
  330 continue
  340 continue
  350 continue
c 360 continue
c finally transform in z
      nrz = nxyz/nz
      do 420 l = 1, indz
      ns = 2**(l - 1)
      ns2 = ns + ns
      km = nzh/ns
      kmr = km*nrz
c     do 410 m = 1, jblok

      m = 1
      do 400 k = 1, km
      k1 = ns2*(k - 1)
      k2 = k1 + ns
      do 390 j = 1, ns
      j1 = j + k1
      j2 = j + k2
      s = sct(1+kmr*(j-1))
      do 380 i = 1, kxp
      do 370 n = 1, ny
      t = s*g(j2,n,i,m)
      g(j2,n,i,m) = g(j1,n,i,m) - t
      g(j1,n,i,m) = g(j1,n,i,m) + t
  370 continue
  380 continue
  390 continue
  400 continue
c 410 continue
  420 continue
c unscramble modes kx = 0, nx/2
 
c     do 440 m = 1, jblok

      m = 1
      if (myprocnum.gt.0) go to 450
      do 430 n = 2, nzh
      s = g(nz2-n,1,1,m)
      g(nz2-n,1,1,m) = .5*cmplx(aimag(g(n,1,1,m) + s),real(g(n,1,1,m) -
     1s))
      g(n,1,1,m) = .5*cmplx(real(g(n,1,1,m) + s),aimag(g(n,1,1,m) - s))
      s = g(nz2-n,nyh+1,1,m)
      g(nz2-n,nyh+1,1,m) = .5*cmplx(aimag(g(n,nyh+1,1,m) + s),real(g(n,n
     1yh+1,1,m) - s))
      g(n,nyh+1,1,m) = .5*cmplx(real(g(n,nyh+1,1,m) + s),aimag(g(n,nyh+1
     1,1,m) - s))
  430 continue
c 440 continue
  
c transpose g array to f
  450 if (ntpose.eq.0) call ptpos2(g,f,br,bs,nz,ny,nxh,kstrt,nzv,nyv,nxv
     1,kzp,kxp,lblok,jblok,myprocnum)
      return

c forward fourier transform
c transpose f array to g
  460 if (ntpose.eq.0) call ptpos2(f,g,bs,br,nxh,ny,nz,kstrt,nxv,nyv,nzv
     1,kxp,kzp,jblok,lblok,myprocnum)
      if (kstrt.gt.nxh) go to 590
      nrz = nxhyz/nz
c scramble modes kx = 0, nx/2
c     do 480 m = 1, jblok

      m = 1
      if (myprocnum.gt.0) go to 480
      do 470 n = 2, nzh
      s = cmplx(aimag(g(nz2-n,1,1,m)),real(g(nz2-n,1,1,m)))
      g(nz2-n,1,1,m) = conjg(g(n,1,1,m) - s)
      g(n,1,1,m) = g(n,1,1,m) + s
      s = cmplx(aimag(g(nz2-n,nyh+1,1,m)),real(g(nz2-n,nyh+1,1,m)))
      g(nz2-n,nyh+1,1,m) = conjg(g(n,nyh+1,1,m) - s)
      g(n,nyh+1,1,m) = g(n,nyh+1,1,m) + s
  470 continue
c 480 continue

c     do 520 m = 1, jblok

  480 m = 1
c bit-reverse array elements in z
      do 510 l = 1, nz
      l1 = (mixup(l) - 1)/nrz + 1
      if (l.ge.l1) go to 510
      do 500 i = 1, kxp
      do 490 n = 1, ny
      t = g(l1,n,i,m)
      g(l1,n,i,m) = g(l,n,i,m)
      g(l,n,i,m) = t
  490 continue
  500 continue
  510 continue
c 520 continue
c first transform in z
      nrz = nxyz/nz
      do 580 l = 1, indz
      ns = 2**(l - 1)
      ns2 = ns + ns
      km = nzh/ns
      kmr = km*nrz
c     do 570 m = 1, jblok

      m = 1
      do 560 k = 1, km
      k1 = ns2*(k - 1)
      k2 = k1 + ns
      do 550 j = 1, ns
      j1 = j + k1
      j2 = j + k2
      s = conjg(sct(1+kmr*(j-1)))
      do 540 i = 1, kxp
      do 530 n = 1, ny
      t = s*g(j2,n,i,m)
      g(j2,n,i,m) = g(j1,n,i,m) - t
      g(j1,n,i,m) = g(j1,n,i,m) + t
  530 continue
  540 continue
  550 continue
  560 continue
c 570 continue
  580 continue
c transpose g array to f
  590 call ptpos2(g,f,br,bs,nz,ny,nxh,kstrt,nzv,nyv,nxv,kzp,kxp,lblok,jb
     1lok,myprocnum)
      if (kstrt.gt.nz) return
      nry = nxhyz/ny
c scramble modes kx = 0, nx/2
c     do 620 m = 1, lblok

      m = 1
      do 610 n = 1, kzp
      do 600 k = 2, nyh
      s = cmplx(aimag(f(1,ny2-k,n,m)),real(f(1,ny2-k,n,m)))
      f(1,ny2-k,n,m) = conjg(f(1,k,n,m) - s)
      f(1,k,n,m) = f(1,k,n,m) + s
  600 continue
  610 continue
c 620 continue
c     do 660 m = 1, lblok

      m = 1
c bit-reverse array elements in y
      do 650 n = 1, kzp
      do 640 k = 1, ny
      k1 = (mixup(k) - 1)/nry + 1
      if (k.ge.k1) go to 640
      do 630 i = 1, nxh
      t = f(i,k1,n,m)
      f(i,k1,n,m) = f(i,k,n,m)
      f(i,k,n,m) = t
  630 continue
  640 continue
  650 continue
c 660 continue
c then transform in y
      nry = nxyz/ny
      do 720 l = 1, indy
      ns = 2**(l - 1)
      ns2 = ns + ns
      km = nyh/ns
      kmr = km*nry
c     do 710 m = 1, lblok

      m = 1
      do 700 n = 1, kzp
      do 690 k = 1, km
      k1 = ns2*(k - 1)
      k2 = k1 + ns
      do 680 j = 1, ns
      j1 = j + k1
      j2 = j + k2
      s = conjg(sct(1+kmr*(j-1)))
      do 670 i = 1, nxh
      t = s*f(i,j2,n,m)
      f(i,j2,n,m) = f(i,j1,n,m) - t
      f(i,j1,n,m) = f(i,j1,n,m) + t
  670 continue
  680 continue
  690 continue
  700 continue
c 710 continue
  720 continue
      nrx = nxhyz/nxh
c scramble coefficients
      kmr = nxyz/nx
c     do 790 m = 1, lblok

      m = 1
      do 780 n = 1, kzp
      do 740 j = 2, nxhh
      t1 = cmplx(aimag(sct(1+kmr*(j-1))),real(sct(1+kmr*(j-1))))
      do 730 k = 1, ny
      t = conjg(f(nxh2-j,k,n,m))
      s = f(j,k,n,m) + t
      t = (f(j,k,n,m) - t)*t1
      f(j,k,n,m) = s + t
      f(nxh2-j,k,n,m) = conjg(s - t)
  730 continue
  740 continue
      do 750 k = 1, ny
      f(nxhh+1,k,n,m) = 2.*conjg(f(nxhh+1,k,n,m))
      f(1,k,n,m) = cmplx(real(f(1,k,n,m)) + aimag(f(1,k,n,m)),real(f(1,k
     1,n,m)) - aimag(f(1,k,n,m)))
  750 continue
c bit-reverse array elements in x
      do 770 j = 1, nxh
      j1 = (mixup(j) - 1)/nrx + 1
      if (j.ge.j1) go to 770
      do 760 i = 1, ny
      t = f(j1,i,n,m)
      f(j1,i,n,m) = f(j,i,n,m)
      f(j,i,n,m) = t
  760 continue
  770 continue
  780 continue
c 790 continue
c finally transform in x
      nrx = nxyz/nxh
      do 850 l = 1, indx1
      ns = 2**(l - 1)
      ns2 = ns + ns
      km = nxhh/ns
      kmr = km*nrx
c     do 840 m = 1, lblok

      m = 1
      do 830 n = 1, kzp
      do 820 k = 1, km
      k1 = ns2*(k - 1)
      k2 = k1 + ns
      do 810 j = 1, ns
      j1 = j + k1
      j2 = j + k2
      s = conjg(sct(1+kmr*(j-1)))
      do 800 i = 1, ny
      t = s*f(j2,i,n,m)
      f(j2,i,n,m) = f(j1,i,n,m) - t
      f(j1,i,n,m) = f(j1,i,n,m) + t
  800 continue
  810 continue
  820 continue
  830 continue
c 840 continue
  850 continue
      return
      end
  

      
      subroutine pdost3(part,q,npp,noff,qm,nx,ny,idimp,npmax,nblok,nxv,n
     1yv,nzpmx)
c for 3d code, this subroutine calculates particle charge density
c using second-order spline interpolation, periodic boundaries
c and distributed data.

      dimension part(idimp,npmax,nblok), q(nxv,nyv,nzpmx,nblok)
      dimension npp(nblok), noff(nblok)
      integer myprocnum
      include 'pglocal.f'
 
      myprocnum = pghpf_myprocnum()

      do l = 1, nzpmx
       do k = 1, ny
        do j = 1, nx
         q(j,k,l,1) = 0.
        enddo
       enddo
      enddo

 
c     do 20 m = 1, nblok

      m = 1
      lnoff = noff(m) - 2
c find interpolation weights
      do 10 j = 1, npp(m)
      nn = part(1,j,m) + .5
      dxl = part(1,j,m) - float(nn)
      nn = nn + 1
      if (nn.gt.nx) nn = nn - nx
      amx = qm*(.75 - dxl*dxl)
      np = nn + 1
      if (np.gt.nx) np = np - nx
      dxp = .5*qm*(.5 + dxl)**2
      nl = nn - 1
      if (nl.lt.1) nl = nl + nx
      dxl = .5*qm*(.5 - dxl)**2
      mm = part(2,j,m) + .5
      dyl = part(2,j,m) - float(mm)
      mm = mm + 1
      if (mm.gt.ny) mm = mm - ny
      amy = .75 - dyl*dyl
      mp = mm + 1
      if (mp.gt.ny) mp = mp - ny
      dyp = .5*(.5 + dyl)**2
      ml = mm - 1
      if (ml.lt.1) ml = ml + ny
      dyl = .5*(.5 - dyl)**2
      ll = part(3,j,m) + .5
      dzl = part(3,j,m) - float(ll)
      ll = ll - lnoff
      amz = .75 - dzl*dzl
      lp = ll + 1
      dzp = .5*(.5 + dzl)**2
      lm = ll - 1
      dzl = .5*(.5 - dzl)**2
c deposit charge
      q(nn,mm,ll,m) = q(nn,mm,ll,m) + amx*amy*amz
      q(np,mm,ll,m) = q(np,mm,ll,m) + dxp*amy*amz
      q(nl,mm,ll,m) = q(nl,mm,ll,m) + dxl*amy*amz
      q(nn,mp,ll,m) = q(nn,mp,ll,m) + amx*dyp*amz
      q(np,mp,ll,m) = q(np,mp,ll,m) + dxp*dyp*amz
      q(nl,mp,ll,m) = q(nl,mp,ll,m) + dxl*dyp*amz
      q(nn,ml,ll,m) = q(nn,ml,ll,m) + amx*dyl*amz
      q(np,ml,ll,m) = q(np,ml,ll,m) + dxp*dyl*amz
      q(nl,ml,ll,m) = q(nl,ml,ll,m) + dxl*dyl*amz
      q(nn,mm,lp,m) = q(nn,mm,lp,m) + amx*amy*dzp
      q(np,mm,lp,m) = q(np,mm,lp,m) + dxp*amy*dzp
      q(nl,mm,lp,m) = q(nl,mm,lp,m) + dxl*amy*dzp
      q(nn,mp,lp,m) = q(nn,mp,lp,m) + amx*dyp*dzp
      q(np,mp,lp,m) = q(np,mp,lp,m) + dxp*dyp*dzp
      q(nl,mp,lp,m) = q(nl,mp,lp,m) + dxl*dyp*dzp
      q(nn,ml,lp,m) = q(nn,ml,lp,m) + amx*dyl*dzp
      q(np,ml,lp,m) = q(np,ml,lp,m) + dxp*dyl*dzp
      q(nl,ml,lp,m) = q(nl,ml,lp,m) + dxl*dyl*dzp
      q(nn,mm,lm,m) = q(nn,mm,lm,m) + amx*amy*dzl
      q(np,mm,lm,m) = q(np,mm,lm,m) + dxp*amy*dzl
      q(nl,mm,lm,m) = q(nl,mm,lm,m) + dxl*amy*dzl
      q(nn,mp,lm,m) = q(nn,mp,lm,m) + amx*dyp*dzl
      q(np,mp,lm,m) = q(np,mp,lm,m) + dxp*dyp*dzl
      q(nl,mp,lm,m) = q(nl,mp,lm,m) + dxl*dyp*dzl
      q(nn,ml,lm,m) = q(nn,ml,lm,m) + amx*dyl*dzl
      q(np,ml,lm,m) = q(np,ml,lm,m) + dxp*dyl*dzl
      q(nl,ml,lm,m) = q(nl,ml,lm,m) + dxl*dyl*dzl
   10 continue
c  20 continue
      return
      end


C ========================================================================
c
c  This subroutine performs a transpose of a matrix f, distributed in y,
c  to a matrix g, distributed in x, that is,
c    g(k+kyp*(m-1),j,l) = f(j+kxp*(l-1),k,m), where
c    1 <= j <= kxp, 1 <= k <= kyp, 1 <= l <= nx/kxp, 1 <= m <= ny/kyp
c  and where indices l and m can be distributed across processors.
c    f = complex input array
c    g = complex output array
c    s, t = complex scratch arrays
C ========================================================================
C     this is not extrinsic function which is called by pfft2r

 
      subroutine ptpos2(f,g,s,t,nx,ny,nz,kstrt,nxv,nyv,nzv,kxp,kzp,jblok
     1,lblok,myprocnum) 
       
      complex f, g, s, t
      dimension f(nxv,nyv,kzp,lblok), g(nzv,nyv,kxp,jblok)
      dimension s(kxp,ny,kzp,lblok), t(kxp,ny,kzp,jblok)
      integer   myprocnum
c      include   'pglocal.f'
      integer   p

      print *,myprocnum,'in ptpose'
      
      ks = kstrt - 2
      kxb = nx/kxp
      kzb = nz/kzp

      do l=0,jblok-1
        if (myprocnum .eq. l) then
          do p=0,lblok-1
            joff = kxp*p
            do iy = 1,nyv
             do k=1,kzp
              do j=1,kxp
               t(j,iy,k,1) = f(j+joff,iy,k,1)
              enddo
             enddo
            enddo

           if (p .ne. myprocnum) then
              call pghpf_csend(p,t(1,1,1,1),kxp*kzp*nyv,1,PGLCL_CPLX8)
           endif
          enddo

          koff = kzp*myprocnum
          joff = kxp*myprocnum
          do iy = 1,nyv
           do k=1,kzp
            do j=1,kxp
               g(k+koff,iy,j,1) = f(j+joff,iy,k,1)
            enddo
           enddo
          enddo
        else
          call pghpf_crecv(l,t(1,1,1,1),kxp*kzp*nyv,1,PGLCL_CPLX8) 
          koff = kzp*l
          do iy = 1,nyv
C DO K = 1,KYP olablir....
           do  k = 1, ny
            do  j = 1, kxp
             g(koff+k,iy,j,1) = t(j,iy,k,1)
            enddo
           enddo
          enddo  
        endif        
      enddo
      return
      end


      subroutine pist_extrinsic(part,npp,nps,idimp,nblok,npmax,sum3)
       
      real part(idimp,npmax,nblok),sum3(3)
      integer npp(nblok), nps(nblok)
      include 'pglocal.f'
       
      do j = nps(1), npp(1)
         part(4,j,1) = part(4,j,1) - sum3(1)
         part(5,j,1) = part(5,j,1) - sum3(2)
         part(6,j,1) = part(6,j,1) - sum3(3)
      enddo
      return
      end
