       
      subroutine do_forall_1(f,fc,nxv,nypmx,nblok,nxvh,kyp,kblok,nxh)
       
      complex fc
      dimension f(nxv,nypmx,nblok), fc(nxvh,kyp,kblok) 

   
      l = 1
      do 130 k = 1, kyp
      do 120 j = 1, nxh
      f(2*j-1,k+1,l) = real(fc(j,k,l))
      f(2*j,k+1,l) = aimag(fc(j,k,l))
  120 continue
  130 continue
      return
      end

c =======================================================================
c =======================================================================
c =======================================================================

      subroutine do_forall_2(f,scr,nxvh,idps,nblok,nxv,nypmx,nxh)

      complex scr
      dimension scr(nxvh,idps,nblok),f(nxv,nypmx,nblok)

      
      l = 1
      do 150 j = 1, nxh
      f(2*j-1,1,l) = real(scr(j,1,l))
      f(2*j,1,l) = aimag(scr(j,1,l))
  150 continue

      return
      end

c =======================================================================
c =======================================================================
c =======================================================================

      subroutine do_forall_3(f,scr,nxvh,idps,nblok,nxv,nypmx,kyp,nxh)

      complex scr
      dimension scr(nxvh,idps,nblok),f(nxv,nypmx,nblok)  
      
     
      l = 1        
      do 160 j = 1, nxh
      f(2*j-1,kyp+2,l) = real(scr(j,1,l))
      f(2*j,kyp+2,l) = aimag(scr(j,1,l))
      f(2*j-1,kyp+3,l) = real(scr(j,2,l))
      f(2*j,kyp+3,l) = aimag(scr(j,2,l))
  160 continue
      return
      end

c =======================================================================
c
c  This subroutine calculates initial particle co-ordinates
c and velocities with uniform density and maxwellian velocity with drift
c
c =======================================================================
      subroutine dist_particle2 (part,edges,npp,nps,vtx,vty,vdx,vdy,
     *     npx,npy,nx,ny,idimp,npmax,nblok,idps,sum0,sum1)
 
      double precision ranorm
      real part(idimp,npmax,nblok)
      real edges(idps,nblok),sum0(nblok),sum1(nblok)
      integer npp(nblok), nps(nblok)
      
      integer myprocnum,p,offset
      include 'pglocal.f'


      myprocnum = pghpf_myprocnum()
      item_cnt = npy/nblok
   
      npxy = npx*npy
      at1 = float(nx)/float(npx)
      at2 = float(ny)/float(npy)
      if (myprocnum .eq. nblok -1 ) then
         do p=0,nblok-1
            num_of_particle = 0
            offset = npp(1)
            do k = 1, item_cnt

               yt = at2*(float(k+p*item_cnt) - .5)
               do j = 1, npx
c ---------------------------------
c uniform density profile
c ---------------------------------
                  xt = at1*(float(j) - .5)
c ---------------------------------
c maxwellian velocity distribution
c ---------------------------------
                  vxt = vtx*ranorm(d)
                  vyt = vty*ranorm(d)
                  num_of_particle = num_of_particle + 1  
              
                  part(1,num_of_particle+offset,1) = xt
                  part(2,num_of_particle+offset,1) = yt
                  part(3,num_of_particle+offset,1) = vxt
                  part(4,num_of_particle+offset,1) = vyt
                  
               enddo ! do j=1,npx
             enddo ! do k=1,item_cnt

             if ( p .lt. nblok-1) then
                call pghpf_csend(p,num_of_particle,1,1,PGLCL_INT4)
                call pghpf_csend(p,part(1,offset+1,1),4*num_of_particle,
     *              1,PGLCL_REAL4)
             else
                  npp(1) = npp(1) + num_of_particle
             endif
          enddo ! do p=0,nblok-1

      else
            call pghpf_crecv(nblok-1,num_of_particle,1,1,PGLCL_INT4)
            offset = npp(1)+1
            call pghpf_crecv(nblok-1,part(1,offset,1),4*num_of_particle,
     *            1, PGLCL_REAL4)   
            npp(1)= npp(1) + num_of_particle

      endif

      sum0(1) = 0.
      sum1(1) = 0.
      do j = nps(1), npp(1)
        sum0(1) = sum0(1) + part(3,j,1)
        sum1(1) = sum1(1) + part(4,j,1)
      enddo

               
      return
      end

      subroutine pist_extrinsic(part,npp,nps,idimp,nblok,npmax,sum2)
       
      real part(idimp,npmax,nblok),sum2(2)
      integer npp(nblok), nps(nblok)
      include 'pglocal.f'
       
      do j = nps(1), npp(1)
         part(3,j,1) = part(3,j,1) - sum2(1)
         part(4,j,1) = part(4,j,1) - sum2(2)
      enddo
      return
      end

       
C =========================================================================
c
c  This subroutine calculates particle charge density
c  using second-order spline interpolation, periodic boundaries.
c
c charge density is approximated by values at the nearest grid points
c
C =========================================================================
      subroutine pdost2(part,q,npp,noff,qm,nx,idimp,npmax,nblok,nxv,
     1   nypmx)

      real  part(idimp,npmax,nblok), q(nxv,nypmx,nblok)
      integer npp(nblok), noff(nblok)
      include 'pglocal.f'


      do k=1,nxv
        do j=1,nypmx
          q(k,j,1) = 0.0
        enddo
      enddo


      l = 1
      
      mnoff = noff(l) - 2
c -------------------------------
c find interpolation weights
c -------------------------------
      do j = 1, npp(l)
          nn = part(1,j,l) + .5
          dxl = part(1,j,l) - float(nn)
          nn = nn + 1
          if (nn.gt.nx) nn = nn - nx
          amx = qm*(.75 - dxl*dxl)
          np = nn + 1
          if (np.gt.nx) np = np - nx
          dxp = .5*qm*(.5 + dxl)**2
          nl = nn - 1
          if (nl.lt.1) nl = nl + nx
          dxl = .5*qm*(.5 - dxl)**2
          mm = part(2,j,l) + .5
          dyl = part(2,j,l) - float(mm)
          mm = mm - mnoff
          amy = .75 - dyl*dyl
          mp = mm + 1
          dyp = .5*(.5 + dyl)**2
          ml = mm - 1
          dyl = .5*(.5 - dyl)**2
c ----------------
c deposit charge
c ----------------
          q(nn,mm,l) = q(nn,mm,l) + amx*amy
          q(np,mm,l) = q(np,mm,l) + dxp*amy
          q(nl,mm,l) = q(nl,mm,l) + dxl*amy
          q(nn,mp,l) = q(nn,mp,l) + amx*dyp
          q(np,mp,l) = q(np,mp,l) + dxp*dyp
          q(nl,mp,l) = q(nl,mp,l) + dxl*dyp
          q(nn,ml,l) = q(nn,ml,l) + amx*dyl
          q(np,ml,l) = q(np,ml,l) + dxp*dyl
          q(nl,ml,l) = q(nl,ml,l) + dxl*dyl
      enddo
   
      return
      end

C ========================================================================
c
c  This subroutine solves 2d poisson's equation in fourier space for
c  force/charge (or convolution of electric field over particle shape)
c  with periodic boundary conditions.
c
c  The equation used is:
c    fx(kx,ky) = -sqrt(-1)*kx*g(kx,ky)*s(kx,ky),
c    fy(kx,ky) = -sqrt(-1)*ky*g(kx,ky)*s(kx,ky),
c    where kx = 2pi*j/nx, ky = 2pi*k/ny, and j,k = fourier mode numbers,
c      g(kx,ky) = (affp/(kx**2+ky**2))*s(kx,ky),
c      s(kx,ky) = exp(-((kx*ax)**2+(ky*ay)**2)/2), except for
c    for fourier mode (jj-1,k-1), where jj = j + kxp*(l - 1)
c
c    if isign = 0, form factor array is prepared
c    if isign is not equal to 0, force/charge is calculated.
c
C ========================================================================
      subroutine extrinsic_ppois2(q,fx,fy,isign,ffc,ax,ay,affp,wp,nx,ny,
     1 kstrt,nyv,kxp,jblok,nyhd,sum1,nblok)
      complex q, fx, fy, ffc, zero
      dimension q(nyv,kxp,jblok)
      dimension fx(nyv,kxp,jblok), fy(nyv,kxp,jblok)
      dimension ffc(nyhd,kxp,jblok),sum1(nblok)
      integer myprocnum
      include 'pglocal.f'

      myprocnum = pghpf_myprocnum()
      sum1(1) = 0.0
     
      nxh = nx/2
      nyh = ny/2
      ny2 = ny + 2
      ks = kstrt - 2
      dnx = 6.28318530717959/float(nx)
      dny = 6.28318530717959/float(ny)
      zero = cmplx(0.,0.)
      if (isign.ne.0) go to 40
      if (kstrt.gt.nxh) return
c ---------------------------
c prepare form factor array
c ---------------------------
      l = 1
      joff = kxp*(myprocnum+1 + ks) - 1
      do j = 1, kxp
          dkx = dnx*float(j + joff)
          at1 = dkx*dkx       
          at2 = (dkx*ax)**2
          do k = 1, nyh
              dky = dny*float(k - 1)
              at3 = dky*dky + at1
              at4 = exp(-.5*((dky*ay)**2 + at2))
              if (at3.eq.0.) then
                 ffc(k,j,l) = cmplx(0.,1.)
              else
                 ffc(k,j,l) = cmplx(affp*at4/at3,at4)
              endif
          enddo
      enddo
      return
c ---------------------------------------------
c calculate force/charge and sum field energy
c ---------------------------------------------
   40 wp = 0.
      if (kstrt.gt.nxh) go to 90
      l = 1

c mode numbers 0 < kx < nx/2 and 0 < ky < ny/2
      joff = kxp*(myprocnum + 1 + ks) - 1
      do 60 j = 1, kxp
      dkx = dnx*float(j + joff)
      if ((j+joff).gt.0) then
         do 50 k = 2, nyh

         k1 = ny2 - k
         at1 = real(ffc(k,j,l))*aimag(ffc(k,j,l))
         at2 = dkx*at1
         at3 = dny*float(k - 1)*at1
         fx(k,j,l) = at2*cmplx(aimag(q(k,j,l)),-real(q(k,j,l)))
         fx(k1,j,l) = at2*cmplx(aimag(q(k1,j,l)),-real(q(k1,j,l)))
         fy(k,j,l) = at3*cmplx(aimag(q(k,j,l)),-real(q(k,j,l)))
         fy(k1,j,l) = at3*cmplx(-aimag(q(k1,j,l)),real(q(k1,j,l)))
         wp = wp + at1*(q(k,j,l)*conjg(q(k,j,l)) + q(k1,j,l)*conjg(q(k1,
     1j,l)))

   50    continue
      endif
c ---------------------------
c mode numbers ky = 0, ny/2
c ---------------------------
      k1 = nyh + 1
      at1 = real(ffc(1,j,l))*aimag(ffc(1,j,l))
      fx(1,j,l) = dkx*at1*cmplx(aimag(q(1,j,l)),-real(q(1,j,l)))
      fx(k1,j,l) = zero
      fy(1,j,l) = zero
      fy(k1,j,l) = zero
      wp = wp + at1*(q(1,j,l)*conjg(q(1,j,l)))
   60 continue
c ---------------------------
c mode numbers kx = 0, nx/2
c ---------------------------
      if ((myprocnum+1+ks) .eq. 0) then
         do 70 k = 2, nyh
         k1 = ny2 - k
         at1 = real(ffc(k,1,l))*aimag(ffc(k,1,l))
         fx(k,1,l) = zero
         fx(k1,1,l) = zero
         fy(k,1,l) = dny*float(k - 1)*at1*cmplx(aimag(q(k,1,l)),-real(q(
     1k,1,l)))
         fy(k1,1,l) = zero
         wp = wp + at1*(q(k,1,l)*conjg(q(k,1,l)))
   70    continue
      endif
   90 continue 

      sum1(1) = wp
      return
      end
 

C =========================================================================
c
c  This subroutine updates particle co-ordinates and
c  velocities using leap-frog scheme in time and second-order spline
c  interpolation in space, with periodic boundary conditions,
c  The equations used are:
c      vx(t+dt/2) = vx(t-dt/2) + (q/m)*fx(x(t),y(t))*dt,
c      vy(t+dt/2) = vy(t-dt/2) + (q/m)*fy(x(t),y(t))*dt,
c  where q/m is charge/mass, and
c      x(t+dt) = x(t) + vx(t+dt/2)*dt, y(t+dt) = y(t) + vy(t+dt/2)*dt
c      fx(x(t),y(t)) and fy(x(t),y(t)) are approximated by interpolation from
c the nearest grid points.
c 
C =========================================================================
      subroutine extrinsic_ppush2 (part,fx,fy,npp,noff,qtm,dt,nx,
     *    idimp,npmax,nblok,nxv,nypmx,sum1)

      dimension part(idimp,npmax,nblok)
      dimension fx(nxv,nypmx,nblok), fy(nxv,nypmx,nblok)
      dimension npp(nblok), noff(nblok),sum1(nblok)
      include 'pglocal.f'
      zero = 0.
      anx = float(nx)
     
      l = 1
      sum0 = 0.0
      mnoff = noff(l) - 2
c ---------------------------
c find interpolation weights
c ---------------------------
      do  j = 1, npp(l)
          nn = part(1,j,l) + .5
          dx = part(1,j,l) - float(nn)
          nn = nn + 1
          if (nn.gt.nx) nn = nn - nx
          amx = .75 - dx*dx
          np = nn + 1
          if (np.gt.nx) np = np - nx
          dxp = .5*(.5 + dx)**2
          nl = nn - 1
          if (nl.lt.1) nl = nl + nx
          dxl = .5*(.5 - dx)**2
          mm = part(2,j,l) + .5
          dy = part(2,j,l) - float(mm)
          mm = mm - mnoff
          amy = .75 - dy*dy
          mp = mm + 1
          dyp = .5*(.5 + dy)**2
          ml = mm - 1
          dyl = .5*(.5 - dy)**2
c ------------------
c find acceleration
c ------------------
      dx = amy*(amx*fx(nn,mm,l) + dxp*fx(np,mm,l) + dxl*fx(nl,mm,l)) + d
     1yp*(amx*fx(nn,mp,l) + dxp*fx(np,mp,l) + dxl*fx(nl,mp,l)) + dyl*(am
     2x*fx(nn,ml,l)+ dxp*fx(np,ml,l) + dxl*fx(nl,ml,l))
      dy = amy*(amx*fy(nn,mm,l) + dxp*fy(np,mm,l) + dxl*fy(nl,mm,l)) + d
     1yp*(amx*fy(nn,mp,l) + dxp*fy(np,mp,l) + dxl*fy(nl,mp,l)) + dyl*(am
     2x*fy(nn,ml,l)+ dxp*fy(np,ml,l) + dxl*fy(nl,ml,l))
c --------------
c new velocity
c --------------
          dx = part(3,j,l) + qtm*dx
          dy = part(4,j,l) + qtm*dy
c -----------------------
c average kinetic energy
c -----------------------
          sum0 = sum0 + (dx + part(3,j,l))**2 + (dy + part(4,j,l))**2
          part(3,j,l) = dx
          part(4,j,l) = dy
c -------------
c new position
c -------------
          dx = part(1,j,l) + dx*dt
          dy = part(2,j,l) + dy*dt
c ------------------------------
c periodic boundary conditions
c ------------------------------
          if (dx.lt.zero) dx = dx + anx
          if (dx.ge.anx) dx = dx - anx
          part(1,j,l) = dx
          part(2,j,l) = dy
      enddo

c --------------------------
c normalize kinetic energy
c --------------------------
      sum1(1) = sum0
      return
      end




      subroutine extrinsic1_pmove2 (part,edges,npp,sbufr,sbufl,
     1 ihole,jsr,jsl,jss,ny,kstrt,nvp,idimp,npmax,nblok,idps,nbmax,
     1 ntmax,ierr)

      dimension part(idimp,npmax,nblok)
      dimension edges(idps,nblok), npp(nblok)
      dimension sbufl(idimp,nbmax,nblok), sbufr(idimp,nbmax,nblok)
      dimension jsl(idps,nblok), jsr(idps,nblok), jss(idps,nblok)
      dimension ihole(ntmax,nblok)
      integer myprocnum
      include 'pglocal.f'

      any = float(ny)
      ks = kstrt - 2
      iter = 4
c --------------------------
c buffer outgoing particles
c --------------------------
      myprocnum  = pghpf_myprocnum()
      l = 1
      
      kb = myprocnum+ 1 + ks
      jsl(1,l) = 0
      jsr(1,l) = 0
      jss(2,l) = 0
      do j = 1, npp(l)
      yt = part(2,j,l)
c --------------------
c particles going up
c --------------------
      if (yt.ge.edges(2,l)) then
         if (jsr(1,l).lt.nbmax) then
            jsr(1,l) = jsr(1,l) + 1
            if ((kb+1).eq.nvp) yt = yt - any
            sbufr(1,jsr(1,l),l) = part(1,j,l)
            sbufr(2,jsr(1,l),l) = yt
            sbufr(3,jsr(1,l),l) = part(3,j,l)
            sbufr(4,jsr(1,l),l) = part(4,j,l)
            ihole(jsl(1,l)+jsr(1,l),l) = j
         else
            jss(2,l) = 1
         endif
c ---------------------
c particles going down
c ---------------------
      elseif (yt.lt.edges(1,l)) then
         if (jsl(1,l).lt.nbmax) then
            jsl(1,l) = jsl(1,l) + 1
            if (kb.eq.0) yt = yt + any
            sbufl(1,jsl(1,l),l) = part(1,j,l)
            sbufl(2,jsl(1,l),l) = yt
            sbufl(3,jsl(1,l),l) = part(3,j,l)
            sbufl(4,jsl(1,l),l) = part(4,j,l)
            ihole(jsl(1,l)+jsr(1,l),l) = j
         else
            jss(2,l) = 1
         endif
      endif
      enddo
      jss(1,l) = jsl(1,l) + jsr(1,l)

      return
      end


       subroutine extrinsic2_pmove2 (edges,sbufr,sbufl,rbufr,rbufl,
     1   jsr,jsl,jss,ny,kstrt,nvp,idimp,npmax,nblok,idps,nbmax,ntmax,
     1   ierr,sum1)

      dimension edges(idps,nblok),sum1(nblok)
      dimension sbufl(idimp,nbmax,nblok), sbufr(idimp,nbmax,nblok)
      dimension rbufl(idimp,nbmax,nblok), rbufr(idimp,nbmax,nblok)
      dimension jsl(idps,nblok), jsr(idps,nblok), jss(idps,nblok)

      integer myprocnum
      include 'pglocal.f'

      any = float(ny)
      ks = kstrt - 2
      iter = 4 
 
      myprocnum  = pghpf_myprocnum()
      l = 1
      
c ------------------------------------------
c check if particles must be passed further
c ------------------------------------------
      nps = 0

         l = 1
c --------------------------------------------------------------
c check if any particles coming from above must go further down
c --------------------------------------------------------------
         jsl(1,l) = 0
         do  j = 1, jsr(2,l)
            if (rbufr(2,j,l).lt.edges(1,l)) jsl(1,l) = 1
         enddo
c ------------------------------------------------------------
c check if any particles coming from below must go further up
c ------------------------------------------------------------
         jsr(1,l) = 0
         do j = 1, jsl(2,l)
            if (rbufl(2,j,l).ge.edges(2,l)) jsr(1,l) = 1
         enddo
         nps = nps + (jsl(1,l) + jsr(1,l))

         sum1(1) = nps

         return
         end


      subroutine extrinsic3_pmove2 (edges,npp,sbufr,sbufl,rbufr,rbufl,
     1 jsr,jsl,jss,ny,kstrt,nvp,idimp,npmax,nblok,idps,nbmax,ntmax,ierr)
      dimension edges(idps,nblok), npp(nblok)
      dimension sbufl(idimp,nbmax,nblok), sbufr(idimp,nbmax,nblok)
      dimension rbufl(idimp,nbmax,nblok), rbufr(idimp,nbmax,nblok)
      dimension jsl(idps,nblok), jsr(idps,nblok), jss(idps,nblok)

      integer myprocnum
      include 'pglocal.f' 

      any = float(ny)
      ks = kstrt - 2
      iter = 4
      myprocnum = pghpf_myprocnum()
c -------------------------------------------
c remove particles which do not belong here
c -------------------------------------------

      kb = myprocnum+1 + ks
c -----------------------------------------
c first check particles coming from above
c -----------------------------------------
      jsl(1,l) = 0
      jss(2,l) = 0
      do 120 j = 1, jsr(2,l)
      yt = rbufr(2,j,l)
c ----------------------
c particles going down
c ----------------------
      if (yt.lt.edges(1,l)) then
         jsl(1,l) = jsl(1,l) + 1
         if (kb.eq.0) yt = yt + any
         sbufl(1,jsl(1,l),l) = rbufr(1,j,l)
         sbufl(2,jsl(1,l),l) = yt
         sbufl(3,jsl(1,l),l) = rbufr(3,j,l)
         sbufl(4,jsl(1,l),l) = rbufr(4,j,l)
c ----------------------
c particles staying here
c ----------------------
      else
         jss(2,l) = jss(2,l) + 1
         rbufr(1,jss(2,l),l) = rbufr(1,j,l)
         rbufr(2,jss(2,l),l) = yt
         rbufr(3,jss(2,l),l) = rbufr(3,j,l)
         rbufr(4,jss(2,l),l) = rbufr(4,j,l)
      endif
  120 continue
      jsr(2,l) = jss(2,l)
c ---------------------------------------
c next check particles coming from below
c ---------------------------------------
      jsr(1,l) = 0
      jss(2,l) = 0
      do 130 j = 1, jsl(2,l)
      yt = rbufl(2,j,l)
c -------------------
c particles going up
c -------------------
      if (yt.ge.edges(2,l)) then
         jsr(1,l) = jsr(1,l) + 1
         if ((kb+1).eq.nvp) yt = yt - any
         sbufr(1,jsr(1,l),l) = rbufl(1,j,l)
         sbufr(2,jsr(1,l),l) = yt
         sbufr(3,jsr(1,l),l) = rbufl(3,j,l)
         sbufr(4,jsr(1,l),l) = rbufl(4,j,l)
c ------------------------
c particles staying here
c ------------------------
      else
         jss(2,l) = jss(2,l) + 1
         rbufl(1,jss(2,l),l) = rbufl(1,j,l)
         rbufl(2,jss(2,l),l) = yt
         rbufl(3,jss(2,l),l) = rbufl(3,j,l)
         rbufl(4,jss(2,l),l) = rbufl(4,j,l)
      endif
  130 continue
      jsl(2,l) = jss(2,l)

      return
      end


      subroutine extrinsic4_pmove2 (npp,jsr,jsl,jss,ny,kstrt,nvp,
     1  idimp,npmax,nblok,idps,nbmax,ntmax,ierr,sum1)

       dimension npp(nblok),sum1(nblok)
       dimension jsl(idps,nblok), jsr(idps,nblok), jss(idps,nblok)

c ---------------------------------------------
c check if move would overflow particle array
c ---------------------------------------------
      ierr = 0

      l = 1
      if ((npp(l)+jsl(2,l)+jsr(2,l)-jss(1,l)).gt.npmax) then
         jss(2,l) = 1
      else
         jss(2,l) = 0
      endif
      ierr = ierr + jss(2,l)
      sum1(1) = ierr

      return
      end


      subroutine extrinsic5_pmove2 (part,edges,npp,rbufr,rbufl,ihole,
     1 jsr,jsl,jss,ny,kstrt,nvp,idimp,npmax,nblok,idps,nbmax,ntmax,ierr)
      dimension part(idimp,npmax,nblok)
      dimension edges(idps,nblok), npp(nblok)
      dimension rbufl(idimp,nbmax,nblok), rbufr(idimp,nbmax,nblok)
      dimension jsl(idps,nblok), jsr(idps,nblok), jss(idps,nblok)
      dimension ihole(ntmax,nblok)
      include 'pglocal.f'

      any = float(ny)
      ks = kstrt - 2


      l = 1
c ---------------------------------------------------
c distribute incoming particles from buffers
c ---------------------------------------------------
      jss(2,l) = min0(jss(1,l),jsl(2,l))
      do 170 j = 1, jss(2,l)
      part(1,ihole(j,l),l) = rbufl(1,j,l)
      part(2,ihole(j,l),l) = rbufl(2,j,l)
      part(3,ihole(j,l),l) = rbufl(3,j,l)
      part(4,ihole(j,l),l) = rbufl(4,j,l)
  170 continue
      if (jss(1,l).gt.jsl(2,l)) then
         jss(2,l) = min0(jss(1,l)-jsl(2,l),jsr(2,l))
      else
         jss(2,l) = jsl(2,l) - jss(1,l)
      endif
      do 180 j = 1, jss(2,l)
      if (jss(1,l).gt.jsl(2,l)) then
         part(1,ihole(j+jsl(2,l),l),l) = rbufr(1,j,l)
         part(2,ihole(j+jsl(2,l),l),l) = rbufr(2,j,l)
         part(3,ihole(j+jsl(2,l),l),l) = rbufr(3,j,l)
         part(4,ihole(j+jsl(2,l),l),l) = rbufr(4,j,l)
      else
c ------------------------------------------------------
c no more holes
c distribute remaining particles from below into bottom
c ------------------------------------------------------
         part(1,j+npp(l),l) = rbufl(1,j+jss(1,l),l)
         part(2,j+npp(l),l) = rbufl(2,j+jss(1,l),l)
         part(3,j+npp(l),l) = rbufl(3,j+jss(1,l),l)
         part(4,j+npp(l),l) = rbufl(4,j+jss(1,l),l)
      endif
  180 continue
      if (jss(1,l).le.jsl(2,l)) then
         npp(l) = npp(l) + (jsl(2,l) - jss(1,l))
         jss(1,l) = jsl(2,l)
      endif
      jss(2,l) = jss(1,l) - (jsl(2,l) + jsr(2,l))
      if (jss(2,l).gt.0) then
         jss(1,l) = (jsl(2,l) + jsr(2,l))
         jsr(2,l) = jss(2,l)
      else
         jss(1,l) = jss(1,l) - jsl(2,l)
         jsr(2,l) = -jss(2,l)
      endif
      do 190 j = 1, jsr(2,l)
c ---------------------------------------------------------------------
c holes left over
c fill up remaining holes in particle array with particles from bottom
c ---------------------------------------------------------------------
      if (jss(2,l).gt.0) then
         j1 = npp(l) - j + 1
         j2 = jss(1,l) + jss(2,l) - j + 1
         if (j1.gt.ihole(j2,l)) then
c ------------------------------------------------
c move particle only if it is below current hole
c ------------------------------------------------
            part(1,ihole(j2,l),l) = part(1,j1,l)
            part(2,ihole(j2,l),l) = part(2,j1,l)
            part(3,ihole(j2,l),l) = part(3,j1,l)
            part(4,ihole(j2,l),l) = part(4,j1,l)
         endif
      else
c --------------------------------------------------------
c no more holes
c distribute remaining particles from above into bottom
c --------------------------------------------------------
         part(1,j+npp(l),l) = rbufr(1,j+jss(1,l),l)
         part(2,j+npp(l),l) = rbufr(2,j+jss(1,l),l)
         part(3,j+npp(l),l) = rbufr(3,j+jss(1,l),l)
         part(4,j+npp(l),l) = rbufr(4,j+jss(1,l),l)
      endif
  190 continue
      if (jss(2,l).gt.0) then
         npp(l) = npp(l) - jsr(2,l)
      else
         npp(l) = npp(l) + jsr(2,l)
      endif
      jss(1,l) = 0

      return
      end

c do not distribute mixup adn sct array among processors,becasue
c each one needs these.this is not extrinsic function ......!

       subroutine bitrv(isign,ntpose,mixup,sct,indx,indy,
     1 kstrt,nxvh,nyv,kxp,kyp,jblok,kblok,nxhyd,nxyhd)
      complex f, g, bs, br, sct, s, t, t1
      dimension mixup(nxhyd), sct(nxyhd)
      include 'pglocal.f'

      indx1 = indx - 1
      indx1y = max0(indx1,indy)
      nx = 2**indx
      nxh = nx/2
      nxhh = nx/4
      nxh2 = nxh + 2
      ny = 2**indy
      nyh = ny/2
      ny2 = ny + 2
      nxy = max0(nx,ny)
      nxhy = 2**indx1y
      ks = kstrt - 2

c ------------------------------------------------------------------
c prepare fft tables
c bit-reverse index table: mixup(j) = 1 + reversed bits of (j - 1)
c ------------------------------------------------------------------
      do j = 1, nxhy
         lb = j - 1
         ll = 0
         do  k = 1, indx1y
            jb = lb/2
            it = lb - 2*jb
            lb = jb
            ll = 2*ll + it
         enddo
         mixup(j) = ll + 1
      enddo
c ---------------------------------------------
c sine/cosine table for the angles 2*n*pi/nxy
c ---------------------------------------------
      nxyh = nxy/2
      dnxy = 6.28318530717959/float(nxy)
      do j = 1, nxyh
         arg = dnxy*float(j - 1)
         sct(j) = cmplx(cos(arg),-sin(arg))
      enddo
      return
      end

C =======================================================================
c
c This subroutine performs a two dimensional real to complex fast
c fourier transform and its inverse, using complex arithmetic,
c
c   indx/indy = exponent which determines length in x/y direction,
c   where nx=2**indx, ny=2**indy
c   ntpose = (0,1) = (no,yes) input, output data are transposed
c
c   if isign = 0, the fft tables are prepared
c   if isign = -1, an inverse fourier transform is performed
c   if ntpose = 0, f is the input and output array, g is a scratch array
c       f(n,m,l) = (1/nx*ny)*sum(f(j,k,i)*
c       exp(-sqrt(-1)*2pi*n*j/nx)*exp(-sqrt(-1)*2pi*mm*kk/ny))
c       where mm = m + kyp*(l - 1) and kk = k + kyp*(i - 1)
c   if ntpose = 1, f is the input and g is the output
c       g(m,n,l) = (1/nx*ny)*sum(f(j,k,i)*
c       exp(-sqrt(-1)*2pi*nn*j/nx)*exp(-sqrt(-1)*2pi*m*kk/ny))
c       where nn = n + kxp*(l - 1) and kk = k + kyp*(i - 1)
c   if isign = 1, a forward fourier transform is performed
c   if ntpose = 0, f is the input and output array, g is a scratch array
c   f(j,k,i) = sum(f(n,m,l)*exp(sqrt(-1)*2pi*n*j/nx)*
c       exp(sqrt(-1)*2pi*mm*kk/ny))
c   where mm = m + kyp*(l - 1) and kk = k + kyp*(i - 1)
c   if ntpose = 1, g is the input and f is the output
c   f(j,k,i) = sum(g(m,n,l)*exp(sqrt(-1)*2pi*nn*j/nx)*
c       exp(sqrt(-1)*2pi*m*kk/ny))
c   where nn = n + kxp*(l - 1) and kk = k + kyp*(i - 1)
c   g(k,1,1) = mode nx/2,k-1, where ny/2+2 <= k <= ny, and
c   imaginary part of g(1,1,1) = real part of mode nx/2,0 and
c   imaginary part of g(ny/2+1,1,1) = real part of mode nx/2,ny/2
c   written by viktor k. decyk, ucla
C =========================================================================
      subroutine pfft2r(f,g,bs,br,isign,ntpose,mixup,sct,indx,indy,
     1 kstrt,nxvh,nyv,kxp,kyp,jblok,kblok,nxhyd,nxyhd)
      complex f, g, bs, br, sct, s, t, t1
      dimension f(nxvh,kyp,kblok), g(nyv,kxp,jblok)
      dimension bs(kxp,kyp,kblok), br(kxp,kyp,jblok)
      dimension mixup(nxhyd), sct(nxyhd)
      integer myprocnum
      include 'pglocal.f'

      indx1 = indx - 1
      indx1y = max0(indx1,indy)
      nx = 2**indx
      nxh = nx/2
      nxhh = nx/4
      nxh2 = nxh + 2
      ny = 2**indy
      nyh = ny/2
      ny2 = ny + 2
      nxy = max0(nx,ny)
      nxhy = 2**indx1y
      ks = kstrt - 2
      myprocnum = pghpf_myprocnum()
      if (isign .eq. -1) then
          goto 50
      else if (isign .eq. 1) then
          goto 300
      endif
c ----------------------------
c inverse fourier transform
c ----------------------------
   50 if (kstrt.gt.ny) go to 180
      nrx = nxhy/nxh

      l = 1

c --------------------------------
c bit-reverse array elements in x
c --------------------------------
      do 70 j = 1, nxh
      j1 = (mixup(j) - 1)/nrx + 1
      if (j.ge.j1) go to 70
      do 60 k = 1, kyp
      t = f(j1,k,l)
      f(j1,k,l) = f(j,k,l)
      f(j,k,l) = t
   60 continue
   70 continue

c -----------------------
c first transform in x
c -----------------------
      nrx = nxy/nxh
      do 130 m = 1, indx1
      ns = 2**(m - 1)
      ns2 = ns + ns
      km = nxhh/ns
      kmr = km*nrx
      l = 1

      do 110 k = 1, km
      k1 = ns2*(k - 1)
      k2 = k1 + ns
      do 100 j = 1, ns
      j1 = j + k1
      j2 = j + k2
      s = sct(1+kmr*(j-1))
      do 90 i = 1, kyp
      t = s*f(j2,i,l)
      f(j2,i,l) = f(j1,i,l) - t
      f(j1,i,l) = f(j1,i,l) + t
   90 continue
  100 continue
  110 continue

  130 continue

c ---------------------------------------
c unscramble coefficients and normalize
c ---------------------------------------
      kmr = nxy/nx
      ani = 1./float(2*nx*ny)

      l = 1
      do 150 j = 2, nxhh
      t1 = cmplx(aimag(sct(1+kmr*(j-1))),-real(sct(1+kmr*(j-1))))
      do 140 k = 1, kyp
      t = conjg(f(nxh2-j,k,l))
      s = f(j,k,l) + t
      t = (f(j,k,l) - t)*t1
      f(j,k,l) = ani*(s + t)
      f(nxh2-j,k,l) = ani*conjg(s - t)
  140 continue
  150 continue
      do 160 k = 1, kyp
      f(nxhh+1,k,l) = 2.*ani*conjg(f(nxhh+1,k,l))
      f(1,k,l) = 2.*ani*cmplx(real(f(1,k,l)) + aimag(f(1,k,l)),real(f(1,
     1  k,l)) - aimag(f(1,k,l)))
  160 continue
c ------------------------
c transpose f array to g
c ------------------------
  180 call ptpose(f,g,bs,br,nxh,ny,kstrt,nxvh,nyv,kxp,kyp,jblok,kblok,
     1          myprocnum)

      if (kstrt.gt.nxh) go to 290
      nry = nxhy/ny

      l = 1

c ---------------------------------
c bit-reverse array elements in y
c ---------------------------------
      do 200 k = 1, ny
      k1 = (mixup(k) - 1)/nry + 1
      if (k.ge.k1) go to 200
      do 190 j = 1, kxp
      t = g(k1,j,l)
      g(k1,j,l) = g(k,j,l)
      g(k,j,l) = t

  190 continue
  200 continue

c ---------------------
c then transform in y
c ---------------------
      nry = nxy/ny
      do 260 m = 1, indy
      ns = 2**(m - 1)
      ns2 = ns + ns
      km = nyh/ns
      kmr = km*nry

      l = 1
      do 240 k = 1, km
      k1 = ns2*(k - 1)
      k2 = k1 + ns
      do 230 j = 1, ns
      j1 = j + k1
      j2 = j + k2
      s = sct(1+kmr*(j-1))
      do 220 i = 1, kxp
      t = s*g(j2,i,l)
      g(j2,i,l) = g(j1,i,l) - t
      g(j1,i,l) = g(j1,i,l) + t
  220 continue
  230 continue
  240 continue

  260 continue
c -------------------------------
c unscramble modes kx = 0, nx/2
c -------------------------------

      l = 1
      if ((myprocnum+1+ks).gt.0) go to 290
      do 270 k = 2, nyh

      s = g(ny2-k,1,l)
      g(ny2-k,1,l) = .5*cmplx(aimag(g(k,1,l) + s),real(g(k,1,l) - s))
      g(k,1,l) = .5*cmplx(real(g(k,1,l) + s),aimag(g(k,1,l) - s))

  270 continue
   
c ------------------------
c transpose g array to f
c ------------------------
  290 if (ntpose.eq.0) call ptpose(g,f,br,bs,ny,nxh,kstrt,nyv,nxvh,kyp,k
     1xp,kblok,jblok,myprocnum)
      return
c ---------------------------
c forward fourier transform
c transpose f array to g
c ---------------------------
  300 if (ntpose.eq.0) call ptpose(f,g,bs,br,nxh,ny,kstrt,nxvh,nyv,kxp,k
     1yp,jblok,kblok,myprocnum)
      if (kstrt.gt.nxh) go to 410
      nry = nxhy/ny

      l = 1
c ---------------------------
c scramble modes kx = 0, nx/2
c ---------------------------
      if ((myprocnum+1+ks).gt.0) go to 320
      do 310 k = 2, nyh
      s = cmplx(aimag(g(ny2-k,1,l)),real(g(ny2-k,1,l)))
      g(ny2-k,1,l) = conjg(g(k,1,l) - s)
      g(k,1,l) = g(k,1,l) + s
  310 continue
c ----------------------------------
c bit-reverse array elements in y
c ----------------------------------
  320 do 340 k = 1, ny
      k1 = (mixup(k) - 1)/nry + 1
      if (k.ge.k1) go to 340
      do 330 j = 1, kxp
      t = g(k1,j,l)
      g(k1,j,l) = g(k,j,l)
      g(k,j,l) = t
  330 continue
  340 continue

c ----------------------
c first transform in y
c ----------------------
      nry = nxy/ny
      do 400 m = 1, indy
      ns = 2**(m - 1)
      ns2 = ns + ns
      km = nyh/ns
      kmr = km*nry

      l = 1
      do 380 k = 1, km
      k1 = ns2*(k - 1)
      k2 = k1 + ns
      do 370 j = 1, ns
      j1 = j + k1
      j2 = j + k2
      s = conjg(sct(1+kmr*(j-1)))
      do 360 i = 1, kxp
      t = s*g(j2,i,l)
      g(j2,i,l) = g(j1,i,l) - t
      g(j1,i,l) = g(j1,i,l) + t
  360 continue
  370 continue
  380 continue

  400 continue
      
c ------------------------
c transpose g array to f
c ------------------------
  410 call ptpose(g,f,br,bs,ny,nxh,kstrt,nyv,nxvh,kyp,kxp,kblok,jblok,
     1    myprocnum)
     

      if (kstrt.gt.ny) return
      nrx = nxhy/nxh
      kmr = nxy/nx

      l = 1
c ----------------------
c scramble coefficients
c ----------------------
      do 430 j = 2, nxhh
      t1 = cmplx(aimag(sct(1+kmr*(j-1))),real(sct(1+kmr*(j-1))))
      do 420 k = 1, kyp
      t = conjg(f(nxh2-j,k,l))
      s = f(j,k,l) + t
      t = (f(j,k,l) - t)*t1
      f(j,k,l) = s + t
      f(nxh2-j,k,l) = conjg(s - t)
  420 continue
  430 continue
      do 440 k = 1, kyp
      f(nxhh+1,k,l) = 2.*conjg(f(nxhh+1,k,l))
      f(1,k,l) = cmplx(real(f(1,k,l)) + aimag(f(1,k,l)),real(f(1,k,l)) -
     1 aimag(f(1,k,l)))
  440 continue
c ---------------------------------
c bit-reverse array elements in x
c ---------------------------------
      do 460 j = 1, nxh
      j1 = (mixup(j) - 1)/nrx + 1
      if (j.ge.j1) go to 460
      do 450 k = 1, kyp
      t = f(j1,k,l)
      f(j1,k,l) = f(j,k,l)
      f(j,k,l) = t
  450 continue
  460 continue

c ---------------------
c then transform in x
c ---------------------
      nrx = nxy/nxh
      do 520 m = 1, indx1
      ns = 2**(m - 1)
      ns2 = ns + ns
      km = nxhh/ns
      kmr = km*nrx

      l = 1
      do 500 k = 1, km
      k1 = ns2*(k - 1)
      k2 = k1 + ns
      do 490 j = 1, ns
      j1 = j + k1
      j2 = j + k2
      s = conjg(sct(1+kmr*(j-1)))
      do 480 i = 1, kyp
      t = s*f(j2,i,l)
      f(j2,i,l) = f(j1,i,l) - t
      f(j1,i,l) = f(j1,i,l) + t
  480 continue
  490 continue
  500 continue

  520 continue
      return
      end

   
C ========================================================================
c
c  This subroutine performs a transpose of a matrix f, distributed in y,
c  to a matrix g, distributed in x, that is,
c    g(k+kyp*(m-1),j,l) = f(j+kxp*(l-1),k,m), where
c    1 <= j <= kxp, 1 <= k <= kyp, 1 <= l <= nx/kxp, 1 <= m <= ny/kyp
c  and where indices l and m can be distributed across processors.
c    f = complex input array
c    g = complex output array
c    s, t = complex scratch arrays
C ========================================================================
C     this is not extrinsic function whic is called by pfft2r

      subroutine ptpose(f,g,t,s,nx,ny,kstrt,nxv,nyv,kxp,kyp,jblok,
     1    kblok,myprocnum)
      complex f, g, s, t
      dimension f(nxv,kyp,kblok), g(nyv,kxp,jblok)
      dimension t(kxp,kyp,jblok),s(kxp,kyp,kblok)
      integer myprocnum
      include 'pglocal.f'
      integer p

      ks = kstrt - 2
      kxb = nx/kxp
      kyb = ny/kyp
 

      do l=0,jblok-1
        if (myprocnum .eq. l) then
          do p=0,kblok-1
            joff = kxp*p
            do k=1,kyp
             do j=1,kxp
               t(j,k,1) = f(j+joff,k,1)
             enddo
            enddo
            if (p .ne. myprocnum) then
                call pghpf_csend(p,t(1,1,1),kxp*kyp,1,PGLCL_CPLX8)
            endif
          enddo
          koff = kyp*myprocnum
          joff = kxp*myprocnum
          do k=1,kyp
             do j=1,kxp
               g(k+koff,j,1) = f(j+joff,k,1)
             enddo
          enddo
        else
          call pghpf_crecv(l,t(1,1,1),kxp*kyp,1,PGLCL_CPLX8) 
          koff = kyp*l
          do  k = 1, kyp
           do  j = 1, kxp
             g(koff+k,j,1) = t(j,k,1)
           enddo
          enddo  
        endif        
      enddo
      return
      end

      function ranorm(d)
c this program calculates a random number y from a gaussian distribution
c with zero mean and unit variance, according to the method of
c mueller and box:
c    y(k) = (-2*ln(x(k)))**1/2*sin(2*pi*x(k+1))
c    y(k+1) = (-2*ln(x(k)))**1/2*cos(2*pi*x(k+1)),
c where x is a random number uniformly distributed on (0,1).
c written for the ibm by viktor k. decyk, ucla
      integer r1,r2,r4,r5
      double precision ranorm,h1l,h1u,h2l,r0,r3,asc,bsc,temp
      save iflg,r1,r2,r4,r5,h1l,h1u,h2l,r0
      data r1,r2,r4,r5 /885098780,1824280461,1396483093,55318673/
      data h1l,h1u,h2l /65531.0d0,32767.0d0,65525.0d0/
      data iflg,r0 /0,0.0d0/
      if (iflg.eq.0) go to 10
      ranorm = r0
      r0 = 0.0d0
      iflg = 0
      return
   10 isc = 65536
      asc = dfloat(isc)
      bsc = asc*asc
      i1 = r1 - (r1/isc)*isc
      r3 = h1l*dfloat(r1) + asc*h1u*dfloat(i1)
      i1 = r3/bsc
      r3 = r3 - dfloat(i1)*bsc
      bsc = 0.5d0*bsc
      i1 = r2/isc
      isc = r2 - i1*isc
      r0 = h1l*dfloat(r2) + asc*h1u*dfloat(isc)
      asc = 1.0d0/bsc
      isc = r0*asc
      r2 = r0 - dfloat(isc)*bsc
      r3 = r3 + (dfloat(isc) + 2.0d0*h1u*dfloat(i1))
      isc = r3*asc
      r1 = r3 - dfloat(isc)*bsc
      temp = dsqrt(-2.0d0*dlog((dfloat(r1) + dfloat(r2)*asc)*asc))
      isc = 65536
      asc = dfloat(isc)
      bsc = asc*asc
      i1 = r4 - (r4/isc)*isc
      r3 = h2l*dfloat(r4) + asc*h1u*dfloat(i1)
      i1 = r3/bsc
      r3 = r3 - dfloat(i1)*bsc
      bsc = 0.5d0*bsc
      i1 = r5/isc
      isc = r5 - i1*isc
      r0 = h2l*dfloat(r5) + asc*h1u*dfloat(isc)
      asc = 1.0d0/bsc
      isc = r0*asc
      r5 = r0 - dfloat(isc)*bsc
      r3 = r3 + (dfloat(isc) + 2.0d0*h1u*dfloat(i1))
      isc = r3*asc
      r4 = r3 - dfloat(isc)*bsc
      r0 = 6.28318530717959d0*((dfloat(r4) + dfloat(r5)*asc)*asc)
      ranorm = temp*dsin(r0)
      r0 = temp*dcos(r0)
      iflg = 1
      return
      end 
