!important note. fft are not running for indx >= 14 . But it is ok for indx
! values less than 14

!* -------------------------------------------------------------------
!
!* The following code is Dr. Decyk's 1-D PIC code for single-processor
!* computers. [KD]
!*
!* -------------------------------------------------------------------

! * * * periodic 1d electrostatic particle simulation kernel code * * *
! 1D sm version  for public
! This is a simple 1d skeleton particle-in-cell code designed for
! exploring new computer architectures.  it contains the critical pieces
! needed for depositing charge, advancing particles, and solving the
! field.  the code moves only electrons, with periodic electrostatic
! forces obtained by solving poisson's equation with fast fourier
! transforms.  the only diagnostic is particle and field energy.
! portable gcpic kernel code, using algorithm described in:
! p. c. liewer and v. k. decyk, j. computational phys. 85, 302 (1989).
! written by viktor k. decyk, ucla
!
!'inherit ' addribute butun data yi processora kopyalar,extrinsic
! function kullanilyorsa eger. Fakat processor ancak kendi partition
! daki data yi update edebilir. Digerlerini degistiremez .extrinsic
! function ciktiktan sonra diger processor ler kendi local datalarini
! onceden oldugu gibi bulur 

       PROGRAM BEPS1K

!         parameter( indx =   7, npx =    5120, npxb = 512)
!         parameter( indx =   8, npx =    10240, npxb = 1024)
!         parameter( indx =  11, npx =   409600, npxb = 40960)
!         parameter( indx =  12, npx =  1000000, npxb =   200000)
!        parameter( indx =  12, npx =  4096000, npxb =   409600)
!         parameter( indx =  14, npx =  6096000, npxb =   409600)
!        parameter( indx =  18, npx = 40960000, npxb =  4096000)
          parameter( indx =  12, npx =   4096000, npxb = 409600)


! Time
      parameter( tend =  5.000, dt = 0.2000000e+00)
! Velocity
      parameter( vtx =   1.000,  vdx= 5.000, vtdx =   0.500)
      parameter( avdx=   5.000)
! Arch , vprocs, boundaries
      parameter( indnvp= 2, idps =    2, idimp =   2)
! Electrons
      parameter(np=npx+npxb)
      parameter(nx=2**indx,nxh=nx/2)
! Time steps
      parameter(nloop=tend/dt+.0001)
! Vprocs, partitions, particle/partition,
      parameter(nvp=2**indnvp,nblok=1+1*(nvp-1))
      parameter(npmax=(np/nvp)*1.01+250,nxpmx=(nx-1)/nvp+4)
! Grids/dim
      parameter(kxp=(nxh-1)/nvp+1,kblok=1+1*(nxh/kxp-1))
      parameter(nbmax=1+(2*(npx*vtx+npxb*vtdx)+1.4*npxb*avdx)*dt/nx)
      parameter(ntmax=2*nbmax)

      parameter(npd=128)
      parameter (nxp_val=nx/nvp)
      complex ffc, fc, qc, sct,scc,f,shifted
      common /large/ part

      dimension part(idimp,npmax,nblok)
      dimension maskp(npmax,nblok)
      dimension q(nxpmx,nblok), fx(nxpmx,nblok)
      dimension qc(kxp,kblok), fc(kxp,kblok)
      dimension ffc(kxp,kblok)
      dimension mixup(kxp,kblok), sct(kxp,kblok)
      dimension edges(idps,nblok)
      dimension nxp(nblok), noff(nblok)
      dimension npp(nblok), nps(nblok)

      dimension sbufl(idimp,nbmax,nblok), sbufr(idimp,nbmax,nblok)
      dimension rbufl(idimp,nbmax,nblok), rbufr(idimp,nbmax,nblok)

      dimension ihole(ntmax,nblok)
      dimension jsl(idps,nblok), jsr(idps,nblok)
      dimension jss(idps,nblok), scr(idps,nblok),scc(idps,nblok)


      DIMENSION sum_0(nblok),sum_wt(nblok),sum_we(nblok),sum_wke(nblok)
      INTEGER  , DIMENSION(nBLOK)   :: ISUM_0
      DOUBLE PRECISION   START_TIME,FINISH_TIME
      dimension shifted(kblok)
      !complex global_f(kxp,kblok) 
      ! global_f i fft ye parameter olarak gonder

      integer npr,ibflg,npss,ierr
      real awe(nloop), awke(nloop), awt(nloop)
      double precision timebegin,timeend

!HPF$ PROCESSORS    PROC(4)

!HPF$ DISTRIBUTE (*,BLOCK) ONTO PROC   :: EDGES,MASKP,Q,FX,IHOLE,JSL,JSR,JSS
!HPF$ DISTRIBUTE (*,BLOCK) ONTO PROC   :: SCR
!HPF$ DISTRIBUTE (*,BLOCK) ONTO PROC   :: QC,FC,FFC,MIXUP,SCT,SCC
!HPF$ DISTRIBUTE (*,*,BLOCK) ONTO PROC :: PART,SBUFL,SBUFR,RBUFL,RBUFR
!HPF$ DISTRIBUTE (BLOCK) ONTO PROC     :: NOFF,npp,NXP,NPS,SUM_0,ISUM_0
!HPF$ DISTRIBUTE (BLOCK) ONTO PROC     :: shifted,sum_wt,sum_we,sum_wke

interface 

subroutine dcomp1(edges,nxp,noff,nx,nvp,idps,nblok)
      real,intent(inout) ::  edges(:,:)
      integer,intent(inout) :: nxp(:), noff(:)

      !hpf$ distribute *(*,block) :: edges
      !hpf$ distribute *(block)   :: nxp,noff
  end subroutine  

 
 EXTRINSIC (HPF_LOCAL) SUBROUTINE INDEP_LOOP_PDOST1(PART,Q,NOFF,NPP,QME,&
    idimp, npmax,kblok,nblok,nxpmx)  
 
    REAL , DIMENSION(:,:,:) , INTENT(IN)     :: PART
    INTEGER , DIMENSION(:) , INTENT(IN)      :: NOFF,NPP
    REAL , DIMENSION(:,:) , INTENT(INOUT)    :: Q
    REAL, INTENT(IN)                         :: QME

    !HPF$ DISTRIBUTE   *(*,*,BLOCK)        :: PART
    !HPF$ DISTRIBUTE   *(BLOCK)            :: NOFF,NPP
    !HPF$ DISTRIBUTE   *(*,BLOCK)          :: Q

   END SUBROUTINE

   subroutine ppois1 (q,fx,isign,ffc,ax,affp,sum_wp,nx,kxp,kblok,nblok,sum_0)
     
      complex,intent(inout) ::  q(:,:), fx(:,:)
      complex,intent(inout) :: ffc(:,:)
     real,intent(inout) :: sum_0(:),sum_wp(:)

      !hpf$ distribute *(*,block) :: q,fx
      !hpf$ distribute *(*,block) :: ffc
      !hpf$ distribute *(block)   :: sum_0,sum_wp
  end subroutine 

  