set terminal latex
set terminal postscript portrait
set output "grid_speedup.ps"
set data style linespoints
set size  3.5/5,3/3
set format y "%g"
set format x "%g"
set title "# of particles=4505600 and # of Processors=8"
set xlabel "Number of Grid Points in 32768 " 
set ylabel "Parallel Time in milliseconds "
set xrange [1:16]
set yrange [1:1000] 
set autoscale
set key 6,170 
set xtics (1,2,4,8,16)
set ytics (1,100,200,300,400,500,600,700,800,900,1000)
p1(x) = x*1000
p2(x) = x*1000
p3(x)=  x*1000
p4(x) = x*1000
plot x*1000/16  title "Linear" with lines ,\
  "grid_speedup.dat" thru p1(x)   using \
1:2 "%f%f%*f%*f%*f" \
 title "for FFT subroutine"  with linespoints 2 3, \
 "grid_speedup.dat" thru p2(x)   using \
1:2 "%f%*f%f%*f%*f" \
 title "for ppush subroutine"  with linespoints 3 4, \
 "grid_speedup.dat" thru p3(x)   using \
1:2 "%f%*f%*f%f%*f" \
 title "for pmove subroutine"  with linespoints 4 5,\
 "grid_speedup.dat" thru p4(x)   using \
1:2 "%f%*f%*f%*f%f" \
 title "for pdost subroutine"  with linespoints 5 6\





