set terminal latex
set terminal postscript portrait
set output "particle_speedup.ps"
set data style linespoints
set size  3.5/5,3/3
set format y "%g"
set format x "%g"
set title "# of Grid Points=131072 and # of Processors=8"
set xlabel "Number of particles in 11264 " 
set ylabel "Parallel Time in milliseconds "
set xrange [1:2048]
set yrange [1:3000] 
set autoscale
set key 1024,2300
set xtics (128,256,512,1024,2048)
set ytics (1,100,200,300,400,500,600,700,800,900,1000,1500,2000,2500,3000)
p1(x) = x*1000
p2(x) = x*1000
p3(x)=  x*1000
p4(x) = x*1000
plot x*3000/2048  title "Linear" with lines ,\
  "particle_speedup.dat" thru p1(x)   using \
1:2 "%f%f%*f%*f%*f" \
 title "for FFT subroutine"  with linespoints 2 3, \
 "particle_speedup.dat" thru p2(x)   using \
1:2 "%f%*f%f%*f%*f" \
 title "for ppush subroutine"  with linespoints 3 4, \
 "particle_speedup.dat" thru p3(x)   using \
1:2 "%f%*f%*f%f%*f" \
 title "for pmove subroutine"  with linespoints 4 5,\
 "particle_speedup.dat" thru p4(x)   using \
1:2 "%f%*f%*f%*f%f" \
 title "for pdost subroutine"  with linespoints 5 6\





