set terminal latex
set terminal postscript portrait
set output "pmove_speedup.ps"
set data style linespoints
set size  3.5/5,3/3
set format y "%g"
set format x "%g"
set title "# of particles=4505600 and # of grid points=262144"
set xlabel "Number of Processors" 
set ylabel "Speedup" 
set xrange [0:16]
set yrange [0:16]
set autoscale
set key 10,5 
set xtics (1,2,4,8,16)
set ytics (1,2,4,8,16)
p1(x) = 1.60/x
plot x title "Linear" with lines ,"speedup.dat" thru p1(x)   using \
1:2 "%f%*f%*f%f%*f%*f" \
 title "Speedup"  with linespoints 2 3
